DIM SHARED MainDir AS STRING, PicDir AS STRING, DataDir AS STRING, SaveDir AS STRING, SoundDir AS STRING

''========    CHANGE THIS TO THE DIRECTORY OF THE GAME FILES    ========


MainDir = "air attack\"


'=======================================================================


MakeTypes

DIM SHARED Layer AS LONG, Music AS _BIT, CrossSpd AS SINGLE
DIM SHARED CockpitOn AS _BIT, NumEnemy AS INTEGER, NumBG AS INTEGER, NumWeapon AS INTEGER
DIM SHARED Restart AS _BIT
DIM SHARED MouseX AS INTEGER, MouseY AS INTEGER
DIM SHARED MouseLB AS _BIT, MouseRB AS _BIT, MouseMB AS _BIT
DIM SHARED MouseScrl AS _BYTE
DIM SHARED Shot AS _BYTE, NearestX AS INTEGER, NearestY AS INTEGER
DIM SHARED CrossX AS SINGLE, CrossY AS SINGLE
DIM SHARED Track AS INTEGER, XMove AS SINGLE, YMove AS SINGLE
DIM SHARED EyeDist AS SINGLE, CamDist AS SINGLE, DrawDist AS SINGLE, Compass AS STRING
DIM SHARED Pyramid AS LONG, Building AS LONG, Cloud(10) AS INTEGER
DIM SHARED Sky(12) AS INTEGER, BombPic AS INTEGER, Ground(12) AS INTEGER, DamagePic AS INTEGER
DIM SHARED ViewDist AS INTEGER, MaxWep AS INTEGER, CurLev AS _BYTE, MissionPoint AS _BYTE, PicCount AS INTEGER
DIM SHARED EnemyTotal AS INTEGER, FriendlyTotal AS INTEGER
DIM SHARED WepTimer AS _BYTE, Horiz AS INTEGER, FlakHide AS _BIT
DIM SHARED DamageDone AS LONG, Decel AS _BIT
DIM SHARED LevelTimer AS LONG, MissionTimer AS SINGLE, GameTime AS SINGLE
DIM SHARED Invert(2) AS _BYTE, AutoPilot AS _BYTE
DIM SHARED DisplayScreen AS INTEGER
DIM SHARED Sounds(20) AS INTEGER

DIM SHARED White AS LONG, Yellow AS LONG, Blue AS LONG, Orange AS LONG, Gray AS LONG, Black AS LONG
DIM SHARED Green AS LONG, Purple AS LONG, Red AS LONG
DIM SHARED Sun AS INTEGER

DIM SHARED PicType AS _BYTE

DIM SHARED Grid(10, 50, 5)
'1 = Map X
'2 = Map Y
'3 = Screen X
'4 = Screen Y
'5 = Visible

DIM SHARED Fonts(128, 5, 5) AS INTEGER
DIM SHARED BigFonts(128, 7, 8) AS INTEGER

DIM SHARED RunWay AS INTEGER
DIM SHARED Explosion(30) AS INTEGER

DIM SHARED Keys(5) AS LONG

DIM SHARED EnemyStat(100) AS EnemyStats
DIM SHARED WeaponStat(100, 10) AS Weaponstats

DIM SHARED Player AS Player
DIM SHARED Enemy(5000) AS EnemyInfo
DIM SHARED WeaponTimer(5000, 10) AS INTEGER

NumEnemy = 5000: '    How many enemies to shoot
NumBG = 2500: '      Background-elements
NumWeapon = 500 ' Active Weapons


DIM SHARED BackGround(NumBG) AS BGInfo
DIM SHARED Grass(200) AS BGInfo
DIM SHARED ObjectList(NumEnemy + NumBG + NumWeapon) AS ObjectList
DIM SHARED Weapon(NumWeapon) AS Weapon
DIM SHARED Ammo(5000, 10) AS LONG
DIM SHARED PlayWep(8) AS PlayWep

DIM SHARED EnemyStart(15, 5000) AS EnemyStart
DIM SHARED Level(15) AS Level

Invert(1) = 0 '1 = Invert
Invert(2) = 1 '0 = Normal

_TITLE "Air Attack Extreme"
_MOUSEHIDE


RANDOMIZE TIMER

White = _RGB32(255, 255, 255)
Red = _RGB32(255, 0, 0)
Green = _RGB32(0, 255, 0)
Blue = _RGB32(0, 0, 255)
Yellow = _RGB32(255, 255, 0)
Orange = _RGB32(255, 128, 0)
Purple = _RGB32(128, 0, 255)
Gray = _RGB32(128, 128, 128)
Black = _RGB32(0, 0, 0)


ViewDist = 5000

PicDir = MainDir + "pics\"
DataDir = MainDir + "data\"
SaveDir = MainDir + "save\"
SoundDir = MainDir + "sounds\"


SCREEN _NEWIMAGE(800, 600, 32)
Layer = _NEWIMAGE(400, 300)
_SCREENMOVE _MIDDLE
'_FULLSCREEN
_PRINTMODE _KEEPBACKGROUND

DisplayScreen = _NEWIMAGE(400, 300)
_DEST DisplayScreen
_CLEARCOLOR _RGB32(0, 0, 0)

FOR i = 1 TO 12
  Sky(i) = _NEWIMAGE(400, 300)
  Ground(i) = _NEWIMAGE(400, 300)
NEXT

MakeColors

Sun = _NEWIMAGE(100, 100)

_DEST Sun

FOR x = 0 TO 99
  FOR y = 0 TO 99
    Dist = Distance(x, y, 50, 50)
    IF Dist < 50 THEN
      A = ((50 - Dist) ^ .75) * 13.5
      PSET (x, y), _RGBA(255, 255, 0, A)
    END IF
  NEXT
NEXT





CONST Rad = 180 / 3.14159265
CONST Pi = 3.14159265

EyeDist = -225
CamDist = 250

IF _FILEEXISTS(PicDir + "runway.jpg") THEN
  RunWay = _LOADIMAGE(PicDir + "runway.jpg")
ELSE
  PRINT "File runway.jpg missing or not found."
  END
END IF
MakeFonts

FOR F = 1 TO 30
  Explosion(F) = _NEWIMAGE(200, 200)
  _DEST Explosion(F)
  FOR i = 1 TO 150
    Ang = RND * 360
    Dist = SQR(RND * 10000) '(RND * 10) ^ 2
    Size = RND * 15 + 15
    IF (Dist + Size) > 100 THEN
      Change = (Dist + Size) / 100
      Dist = Dist / Change
      Size = Size / Change
    END IF
    Col& = _RGBA32(255, ((100 - Dist) / 100) * 255, 0, 50)
    x = 100 + COS(Ang / Rad) * Dist
    y = 100 + SIN(Ang / Rad) * Dist
    FOR x2 = -Size TO Size
      FOR y2 = -Size TO Size
        IF Distance(x2, y2, 0, 0) <= Size THEN: PSET (x + x2, y + y2), Col&
      NEXT
    NEXT
  NEXT
  _CLEARCOLOR _RGB(0, 0, 0)
NEXT

'==============  LOAD PICTURES =================

MakeSounds
IF _FILEEXISTS(DataDir + "files.jml") THEN
  DIM TempPic(150, 100) AS LONG
  DIM TempPicWep(30, 20) AS LONG
  PicCount = 0
  OPEN DataDir + "files.jml" FOR INPUT AS #1
  DO
    PicCount = PicCount + 1
    INPUT #1, File$
  LOOP UNTIL EOF(1)
  CLOSE #1
  DIM SHARED PicInfo(PicCount) AS PicInfo
  DIM SHARED Pic(PicCount, 16) AS INTEGER
  OPEN DataDir + "files.jml" FOR INPUT AS #1
  FOR i = 1 TO PicCount
    INPUT #1, File$
    PicInfo(i).Name = File$
    PicInfo(i).Num = i
    File$ = PicDir + File$
    IF _FILEEXISTS(RTRIM$(File$) + ".jml") THEN
      OPEN RTRIM$(File$) + ".jml" FOR BINARY AS #2
      GET #2, , PicType
      PicInfo(i).Type = PicType

      FOR A = 1 TO 16
        SELECT CASE PicType
          CASE 0
            Pic(i, A) = _NEWIMAGE(150, 100)
            XSize = 149
            YSize = 99
          CASE 1
            Pic(i, A) = _NEWIMAGE(30, 20)
            XSize = 29
            YSize = 19
        END SELECT

        _DEST Pic(i, A)
        IF A <= 8 THEN
          SELECT CASE PicType
            CASE 0
              GET #2, , TempPic()
            CASE 1
              GET #2, , TempPicWep()
          END SELECT

          FOR x = 0 TO XSize
            FOR y = 0 TO YSize
              SELECT CASE PicType
                CASE 0
                  PSET (x, y), TempPic(x, y)
                CASE 1
                  PSET (x, y), TempPicWep(x, y)
              END SELECT
            NEXT
          NEXT
        ELSE

          'RED VERSION OF EACH

          _SOURCE Pic(i, A - 8)
          FOR x = 0 TO XSize
            FOR y = 0 TO YSize
              IF POINT(x, y) > 0 THEN: PSET (x, y), Red
            NEXT
          NEXT
        END IF

        _CLEARCOLOR _RGB32(0, 0, 0)
      NEXT
      CLOSE #2
    END IF
  NEXT
  CLOSE #1
ELSE
  _DEST 0
  _PRINTSTRING (50, 50), "No Files Found"
  SLEEP
  SYSTEM
END IF

Pyramid = _NEWIMAGE(10, 10)
Building = _NEWIMAGE(10, 10)

FOR i = 1 TO 10
  Cloud(i) = _NEWIMAGE(400, 300)
  _DEST Cloud(i)
  FOR j = 0 TO 350
    Cx = 200 + (RND * 150 - 75)
    Cy = 150 + (RND * 100 - 50)
    A = RND * 360
    D = RND * 150
    x = Cx + COS(A / Rad) * (D * (4 / 3))
    y = Cy + SIN(A / Rad) * D
    s = RND * 25 + 25

    FOR x2 = -s TO s
      FOR y2 = -s TO s
        Dist = SQR(x2 * x2 + y2 * y2)
        IF Dist < s THEN: PSET (x + x2, y + y2), _RGBA32(255, 255, 255, 5)
      NEXT
    NEXT
  NEXT
  _SOURCE Cloud(i)

  _DEST Cloud(i)
  _DONTBLEND

  FOR x = 0 TO 399
    FOR y = 0 TO 299
      IF _ALPHA32(POINT(x, y)) < 45 THEN: PSET (x, y), _RGBA(0, 0, 0, 0)
    NEXT
  NEXT
  _BLEND
NEXT



_DEST Pyramid
LINE (0, 0)-(10, 10), _RGB(225, 170, 0), BF

_DEST Building
LINE (0, 0)-(10, 10), _RGB32(128, 128, 128), BF
LINE (0, 0)-(10, 10), _RGB32(64, 64, 64), B

_DEST Layer


Music = 0: '        Start with music on
CrossSpd = 4: '     Speed of auto-tracking cross
Track = 5000: '     Default auto-tracking range
CockpitOn = -1: '    Start with Cockpit off


DIM SHARED Title$(18)

Title$(1) = "        >>> AIR ATTACK EXTREME<<<"
Title$(2) = "     Original Code by Jeff Barnette"
Title$(3) = "   (c) 1997 by Solid Rock Software"
Title$(5) = "     Enhanced Version by Justin Lloyd"
Title$(6) = "         2012 by Tumbleweed Inc."
Title$(7) = "    Use the mouse to control your jet."
Title$(8) = "        Press Space Bar to Begin,"
Title$(9) = "       Press left button to shoot."
Title$(9) = "    Press `n` for navigation screen,"
Title$(10) = "   press `+` and `-` to toggle speed"
Title$(11) = "       `m` toggles sfx on / off"
Title$(12) = "`t` + `T` changes auto-tracking radius"
Title$(13) = " `c` toggles Cockpit drawing on / off"
Title$(14) = "watch your height, it may be dangerous"
Title$(15) = "       Don`t use too many bombs!"
Title$(16) = ""
Title$(17) = "       >>> AIR ATTACK EXTREME<<<"
Title$(18) = "*"



IF _FILEEXISTS(DataDir + "bad.jml") THEN
  OPEN DataDir + "bad.jml" FOR BINARY AS #1
  GET #1, , EnemyStat()
  GET #1, , WeaponStat()
  CLOSE #1
END IF


IF _FILEEXISTS(DataDir + "mapinfo.jml") THEN
  OPEN DataDir + "mapinfo.jml" FOR BINARY AS #1
  GET #1, , EnemyStart()
  GET #1, , Level()
  CLOSE #1
END IF

MakeWeapons

Begin:
Restart = 0
Compass = "--E---SE---S---SW---W---NW---N---NE---E--"


FOR i = 1 TO 200
  Dir = RND * 360
  Dist = RND * 2000
  Grass(i).X = Player.X + COS(Dir / Rad) * Dist
  Grass(i).Y = Player.Y + SIN(Dir / Rad) * Dist
NEXT

CLS


Player.Ang = 180
Player.Alt = 1000
Player.Speed = 100
Player.TargetSpeed = 1000
Player.Thrust = 10
Player.X = Level(CurLev).StartX * 10
Player.Y = Level(CurLev).StartY * 10
Player.CurWep = 1

Player.Armor = 10000

CrossX = 200
CrossY = 150

TitleScreen

Start = TIMER

' %%%%%%%%%%%%%%%%%%%%%%%%%%%% MAINPART %%%%%%%%%%%%%%%%%%%%%%%%%
DO
  _DEST DisplayScreen
  CLS , _RGBA(0, 0, 0, 0)
  _DEST Layer
  CLS

  Current = TIMER
  Frames = Frames + 1
  IF Current - Start >= 1 THEN
    FPS = Frames
    Frames = 0
    Start = TIMER
  END IF

  GameTime = GameTime + 1

  HeatSink = 10
  IF Player.Heat > 0 THEN
    Player.Heat = Player.Heat - HeatSink
    IF Player.Heat > 10000 THEN: Player.Heat = 10000
    IF Player.Heat > 8000 THEN: Player.Armor = Player.Armor - ABS((8000 - Player.Heat) / 500)
  END IF

  WeaponCount = 0
  FOR i = 1 TO NumWeapon
    IF Weapon(i).Use = 1 THEN: WeaponCount = WeaponCount + 1
  NEXT

  IF MissionPoint > 0 THEN
    Horizon
    DrawObjects
    EnemyMove
    Display
    WeaponUse
    IF CockpitOn THEN: CockPit
  END IF
  Mission
  Controls


  IF Restart THEN: GOTO Begin


  _DEST DisplayScreen

  IF MouseScrl <> 0 THEN
    Player.CurWep = Player.CurWep + MouseScrl
    IF Player.CurWep < 1 THEN: Player.CurWep = MaxWep
    IF Player.CurWep > MaxWep THEN: Player.CurWep = 1
    MouseScrl = 0
    WepTimer = 80
  END IF

  DrawMouse 2
  _PUTIMAGE (0, 0)-(399, 299), DisplayScreen, Layer
  ShowScreen
LOOP



FUNCTION Angle (X1, Y1, X2, Y2)
IF (Y1 - Y2) = 0 THEN
  Angle = 0
  EXIT FUNCTION
END IF
Ang = ATN((X1 - X2) / (Y1 - Y2)) * Rad
IF Y1 > Y2 THEN
  Angle = 270 - Ang
ELSE
  Angle = 90 - Ang
END IF
END FUNCTION


SUB CockPit

_DEST DisplayScreen

Col& = _RGB32(128, 128, 128)
Col2& = _RGB32(64, 64, 64)

LINE (25, 300)-(125, 210), Col&
LINE -(275, 210), Col&
LINE -(375, 300), Col&
LINE (38, 300)-(131, 218), Col&
LINE -(269, 218), Col&
LINE -(363, 300), Col&
LINE (25, 299)-(38, 299), Col&
LINE (363, 299)-(375, 299), Col&

LINE (125, 210)-(50, 0), Col&
LINE (131, 210)-(63, 0), Col&
LINE (50, 0)-(63, 0), Col&
LINE (269, 210)-(338, 0), Col&
LINE (275, 210)-(350, 0), Col&
LINE (338, 0)-(350, 0), Col&

PAINT (59, 8), Col2&, Col&
PAINT (340, 8), Col2&, Col&
PAINT (200, 215), Col2&, Col&
_DEST Layer

END SUB


SUB Controls

Mouse

PlayWep(Player.CurWep).BulletTimer = PlayWep(Player.CurWep).BulletTimer + 1
IF AutoPilot = 0 THEN
  XMove = ((400 - MouseX) * (400 - MouseX)) / 400
  YMove = ((300 - MouseY) * (300 - MouseY)) / 300

  IF YMove < -125 THEN: YMove = -125
  IF YMove > 125 THEN: YMove = 125

  IF MouseX < 400 THEN: XMove = -XMove
  IF MouseY > 300 THEN: YMove = -YMove

  IF Invert(1) = 1 THEN: YMove = YMove * -1
  IF Invert(2) = 1 THEN: XMove = XMove * -1

END IF

Player.Drop = (Player.Speed / 100) * (YMove / 250)
Player.Alt = Player.Alt - Player.Drop


IF Player.Alt < 80 THEN
  Player.Alt = 80
  IF CurLev <> 5 THEN: Player.Armor = Player.Armor - ((YMove * YMove) / 100)
END IF
IF CurLev = 5 THEN
  Player.Alt = 80
  IF Player.TargetSpeed > 600 THEN: Player.TargetSpeed = 600
ELSE
  IF Player.TargetSpeed < 0 THEN: Player.TargetSpeed = 0
END IF
IF Player.Armor <= 0 THEN: Failed



Player.Ang = Player.Ang - (XMove / 50)
IF Player.Ang > 359 THEN Player.Ang = Player.Ang - 360
IF Player.Ang < 0 THEN Player.Ang = Player.Ang + 360

' %%%%%%%%%% YOUR POSITION %%%%%%%%%%%%%%%%%%%%%%%%%%

Decel = 0
IF Player.Speed < Player.TargetSpeed THEN
  Player.Speed = Player.Speed + Player.Thrust
  IF Player.Speed > Player.TargetSpeed THEN: Player.Speed = Player.TargetSpeed
END IF

IF Player.Speed > Player.TargetSpeed THEN
  IF CurLev <> 5 THEN
    Player.Speed = Player.Speed - Player.Thrust
    Decel = -1
  ELSE
    Player.Speed = Player.Speed - Player.Thrust * 2
  END IF
END IF


IF Player.Speed > 1500 AND Decel = 0 THEN
  Player.Heat = Player.Heat + ABS(1500 - Player.Speed) / 50
END IF

IF Player.Speed < 0 THEN: Player.Speed = 0


Player.X = Player.X + COS(Player.Ang / Rad) * (Player.Speed / 100)
Player.Y = Player.Y + SIN(Player.Ang / Rad) * (Player.Speed / 100)


' %%%%%%%%% cross adjust when in range %%%%%%%%%%%%%%
IF NearestX > CrossX THEN CrossX = CrossX + CrossSpd
IF NearestX < CrossX THEN CrossX = CrossX - CrossSpd
IF NearestY > CrossY THEN CrossY = CrossY + CrossSpd
IF NearestY < CrossY THEN CrossY = CrossY - CrossSpd

IF NearestX < 0 OR NearestX > 399 OR NearestY < 0 OR NearestY > 299 THEN
  Player.Target = 0
  NearestX = 200
  NearestY = 150
END IF


Button = 0
IF MouseLB THEN
  IF Shot = 0 THEN
    _SNDPLAYCOPY (Sounds(8))
    Shot = 1
  END IF
END IF
IF MouseRB THEN
  IF CurLev <> 5 THEN
    IF PlayWep(Player.CurWep).BulletTimer >= PlayWep(Player.CurWep).Refire THEN
      PlayWep(Player.CurWep).BulletTimer = PlayWep(Player.CurWep).Refire
      IF PlayWep(Player.CurWep).Ammo > 0 OR Player.CurWep = 6 THEN
        SELECT CASE Player.CurWep
          CASE 6
            Shots = 3
            IF Player.Laser = 0 THEN: EXIT SUB
          CASE ELSE: Shots = 1
        END SELECT
        FOR j = 1 TO Shots
          FOR i = 1 TO NumWeapon
            IF Weapon(i).Use = 0 THEN
              IF Player.CurWep <> 6 THEN
                PlayWep(Player.CurWep).Ammo = PlayWep(Player.CurWep).Ammo - 1
              END IF

              PlayWep(Player.CurWep).BulletTimer = 0

              Weapon(i).Type = Player.CurWep
              Weapon(i).Target = Player.Target
              Weapon(i).Var = 1
              Weapon(i).Use = 1
              Weapon(i).X = Player.X
              Weapon(i).Y = Player.Y
              Weapon(i).Alt = Player.Alt - 75
              Weapon(i).Power = PlayWep(Player.CurWep).Power
              Weapon(i).Range = PlayWep(Player.CurWep).Range
              Weapon(i).Radius = PlayWep(Player.CurWep).Radius
              Weapon(i).Speed = PlayWep(Player.CurWep).Speed
              Weapon(i).MaxSpeed = Weapon(i).Speed
              Weapon(i).Ang = Player.Ang
              Weapon(i).Tilt = YMove / PlayWep(Player.CurWep).Tilt

              SELECT CASE Weapon(i).Type
                CASE 4, 5
                  FOR p = 1 TO PicCount
                    IF UCASE$(RTRIM$(PicInfo(p).Name)) = "MISSILE" THEN: Weapon(i).Pic = p
                  NEXT
              END SELECT


              SELECT CASE Player.CurWep
                CASE 1, 3 'Bomb

                CASE 2 'Vulcan
                  Weapon(i).Tilt = Weapon(i).Tilt + RND * 50 - 25
                  Weapon(i).Ang = Weapon(i).Ang + RND * 10 - 5
                  _SNDPLAYCOPY Sounds(8)
                CASE 4, 5 'Rocket Missile
                  Weapon(i).Alt = Player.Alt - 5
                  _SNDPLAYCOPY Sounds(7)
                CASE 6 'Laser
                  Weapon(i).Ang = Player.Ang + 1 * (j - 2)
                  Player.Heat = Player.Heat + 150
                  _SNDPLAYCOPY Sounds(3)
                CASE 7 'Back Flash
                  Weapon(i).Ang = Player.Ang - 180
                  _SNDPLAYCOPY Sounds(9)
                CASE 8 'Magnum
                  _SNDPLAYCOPY Sounds(10)
              END SELECT
              EXIT FOR
            END IF
          NEXT
        NEXT
      END IF
    END IF
  END IF
END IF


Press = _KEYHIT
SELECT CASE Press / 256
  CASE 73 ' Page Up
    Track = Track + 100
  CASE 81 ' Page Down
    Track = Track - 100
  CASE 59 TO 66
    Player.CurWep = (Press / 256) - 58
END SELECT
SELECT CASE Press
  CASE 65, 97 'A
    IF AutoPilot = 0 THEN
      AutoPilot = -1
    ELSE
      AutoPilot = 0
    END IF
  CASE 44, 60 ' <
    IF Invert(1) = 0 THEN
      Invert(1) = 1
      Font "Invert Up / Down:  OFF", 50, 80, White, 2
      ShowScreen
      _DELAY 1
    ELSE
      Invert(1) = 0
      Font "Invert Up / Down:  ON", 50, 80, White, 2
      ShowScreen
      _DELAY 1

    END IF
  CASE 46, 62 ' >
    IF Invert(2) = 0 THEN
      Invert(2) = 1
      Font "Invert Left / Right:  OFF", 50, 80, White, 2
      ShowScreen
      _DELAY 1
    ELSE
      Invert(2) = 0
      Font "Invert Left / Right:  ON", 50, 80, White, 2
      ShowScreen
      _DELAY 1
    END IF

    'CASE 77, 109 'M
    '  IF Music = 0 THEN
    '    Music = 0 '-1
    '    _PRINTSTRING (60, 60), "MUSIC ON"
    '    ShowScreen
    '    SLEEP 1
    '  ELSE
    '    Music = 0
    '    _PRINTSTRING (60, 60), "MUSIC OFF"
    '    ShowScreen
    '    SLEEP 1
    '  end if
  CASE 32
    IF Player.Target > 0 THEN: Player.TargetSpeed = Enemy(Player.Target).Speed * 100
  CASE 45, 95 '-
    Player.TargetSpeed = Player.TargetSpeed - 25
  CASE 43, 61 '+
    Player.TargetSpeed = Player.TargetSpeed + 25
  CASE 78, 110 'N
    IF Demo = 0 THEN: Navigation
  CASE 48 '  0
    IF CurLev = 5 THEN
      Player.TargetSpeed = 600
    ELSE
      Player.TargetSpeed = 2000
    END IF
  CASE 49 TO 57 '   1 - 9
    IF CurLev = 5 THEN
      Player.TargetSpeed = (600 / 9) * (Press - 49)
    ELSE
      Player.TargetSpeed = (2000 / 10) * (Press - 48)
    END IF
  CASE 67, 99 'C
    IF CockpitOn = -1 THEN
      CockpitOn = 0
    ELSE
      CockpitOn = -1
    END IF
  CASE 8
    IF CurLev <> 5 THEN: Player.TargetSpeed = 3000
END SELECT
IF CurLev <> 5 THEN
  IF Player.TargetSpeed < 200 THEN: Player.TargetSpeed = 200
  IF Player.TargetSpeed > 3000 THEN: Player.TargetSpeed = 3000
END IF


'IF MouseScrl <> 0 THEN
'  Track = Track + MouseScrl * 200
'  MouseScrl = 0
'  IF Track < 200 THEN: Track = 200
'  IF Track > 2400 THEN: Track = 2400
'end if


END SUB



SUB Display


_DEST DisplayScreen

' %%%%% HEIGHT INSTRUMENT %%%%
IF CurLev <> 5 THEN
  LINE (381, 100)-(392, 225), Gray, BF
  LINE (381, 224 - (Player.Alt / 10000) * 125)-(392, 226 - (Player.Alt / 10000) * 125), Red, BF
  LINE (381, 100)-(392, 225), White, B
  IF Player.Alt > 9500 THEN
    AltCol& = _RGBA(198, 170, 0, 168)
    Font "W", 383, 115, AltCol&, 2
    Font "A", 383, 135, AltCol&, 2
    Font "R", 383, 155, AltCol&, 2
    Font "N", 383, 185, AltCol&, 2
    Font "I", 383, 205, AltCol&, 2
    Font "N", 383, 225, AltCol&, 2
    Font "G", 383, 245, AltCol&, 2

  ELSEIF Player.Alt < 200 THEN
    IF INT(TIMER * 10) MOD 10 = 1 THEN
      AltCol& = _RGBA(198, 170, 0, 168)
    ELSE
      AltCol& = _RGBA(198, 0, 0, 168)
    END IF
    Font "W", 383, 110, AltCol&, 2
    Font "A", 383, 125, AltCol&, 2
    Font "R", 383, 140, AltCol&, 2
    Font "N", 383, 155, AltCol&, 2
    Font "I", 383, 170, AltCol&, 2
    Font "N", 383, 185, AltCol&, 2
    Font "G", 383, 200, AltCol&, 2
  ELSE
    AltCol& = _RGBA(198, 170, 0, 168)
    Font "A", 383, 135, AltCol&, 2
    Font "L", 383, 160, AltCol&, 2
    Font "T", 383, 185, AltCol&, 2
  END IF
  IF Player.Alt > 10000 THEN
    Player.TargetSpeed = Player.TargetSpeed * .99
    Player.Alt = 10000
  END IF
END IF

'%%%%%  HEAT %%%%%%%%%%%

IF Player.Heat < 8000 THEN
  TempCol& = _RGBA32(240, 200, 0, 168)
  LINE (7, 100)-(18, 225), Red, BF
  LINE (7, 100)-(18, 225 - (Player.Heat / 10000) * 125), Yellow, BF
  LINE (7, 100)-(18, 225), White, B
  Font "H", 9, 130, TempCol&, 2
  Font "E", 9, 150, TempCol&, 2
  Font "A", 9, 170, TempCol&, 2
  Font "T", 9, 190, TempCol&, 2
ELSE
  IF INT(TIMER * 10) MOD 10 = 1 THEN
    TempCol& = _RGB32(240, 200, 250)
    LINE (7, 100)-(18, 225), Orange, BF
    LINE (7, 100)-(18, 225 - (Player.Heat / 10000) * 125), White, BF
    LINE (7, 100)-(18, 225), Orange, B
  ELSE
    TempCol& = _RGB32(255, 255, 255)
    LINE (7, 100)-(18, 225), Red, BF
    LINE (7, 100)-(18, 225 - (Player.Heat / 10000) * 125), Yellow, BF
    LINE (7, 100)-(18, 225), White, B
  END IF
  Font "O", 9, 110, TempCol&, 2
  Font "V", 9, 125, TempCol&, 2
  Font "E", 9, 140, TempCol&, 2
  Font "R", 9, 155, TempCol&, 2
  Font "H", 9, 170, TempCol&, 2
  Font "E", 9, 185, TempCol&, 2
  Font "A", 9, 200, TempCol&, 2
  Font "T", 9, 215, TempCol&, 2
END IF

Font "Enemies Left : " + STR$(EnemyTotal), 70, 282, White, 1
IF CurLev = 10 THEN: Font "Friendlies Left : " + STR$(FriendlyTotal), 70, 290, White, 1


LINE (79, 5)-(321, 43), _RGBA32(32, 32, 32, 192), BF

IF Player.Speed <= 2000 THEN
  IF CurLev <> 5 THEN
    LINE (120, 8)-(120 + 160 * (Player.Speed / 2000), 18), Yellow, BF
    LINE (120, 8)-(280, 18), _RGB32(200, 200, 200), B
  ELSE
    LINE (120, 8)-(120 + 160 * (Player.Speed / 600), 18), Yellow, BF
    LINE (120, 8)-(280, 18), _RGB32(200, 200, 200), B
  END IF
  Font STR$(CINT(Player.Speed)) + "/" + STR$(CINT(Player.TargetSpeed)) + " " + " mph", 140, 10, Orange, 1
ELSE
  LINE (120, 8)-(280, 18), Yellow, BF
  LINE (120, 8)-(120 + 160 * ((Player.Speed - 2000) / 1000), 18), Red, BF
  LINE (120, 8)-(280, 18), _RGB32(200, 200, 200), B
  Font STR$(CINT(Player.Speed)) + "/" + STR$(CINT(Player.TargetSpeed)) + " " + " mph", 140, 10, Black, 1
END IF
Font "Speed:", 80, 10, Green, 1


LINE (120, 22)-(280, 32), Red, BF
LINE (120, 22)-(120 + 160 * (Player.Armor / 10000), 32), Gray, BF
LINE (120, 22)-(280, 32), _RGB32(200, 200, 200), B
Font "Armor:", 80, 24, Green, 1
Font STR$(CINT(Player.Armor)) + "/ 10000", 140, 24, Black, 1

IF CurLev <> 5 THEN
  SELECT CASE Player.CurWep
    CASE 6
      SELECT CASE Player.Laser
        CASE 0: LINE (120, 34)-(280, 40), Red, BF
        CASE 1: LINE (120, 34)-(280, 40), Gray, BF
      END SELECT
    CASE ELSE
      LINE (120, 34)-(280, 40), Red, BF
      LINE (120, 34)-(120 + 160 * (PlayWep(Player.CurWep).Ammo / PlayWep(Player.CurWep).MaxAmmo), 40), Gray, BF
      Font STR$(PlayWep(Player.CurWep).Ammo) + " / " + STR$(PlayWep(Player.CurWep).MaxAmmo), 195, 34, Black, 1
  END SELECT

  LINE (120, 34)-(280, 40), _RGB32(200, 200, 200), B
  Font "Ammo:", 80, 34, Green, 1
  Font PlayWep(Player.CurWep).Name, 130, 34, Black, 1


END IF
'Font "Damage: " + STR$(DamageDone), 5, 150, White, 2

IF CurLev = 6 THEN
  Minutes$ = STR$(INT((14400 - LevelTimer) / 1800))
  Seconds$ = RIGHT$(STR$(INT(((14400 - LevelTimer) MOD 1800) / 30) + 100), 2)
  Font "Defend Base For: " + Minutes$ + "." + Seconds$, 85, 265, White, 2
END IF

Cursor = 1
IF WepTimer > 0 AND CurLev <> 5 THEN
  WepTimer = WepTimer - 1
  Trans = 255 - (80 - WepTimer) * 3
  LINE (23, 150)-(100, 212), _RGBA32(100, 100, 100, Trans), BF
  LINE (28, 155)-(95, 207), _RGBA32(160, 160, 160, Trans), BF
  FOR i = Player.CurWep - 3 TO Player.CurWep + 3
    Sel = i
    IF i < 1 THEN
      Sel = MaxWep + Sel
    END IF
    IF i > MaxWep THEN
      Sel = (Sel - MaxWep)
    END IF
    Trans = 255 - (ABS(i - Player.CurWep) * 70) - (80 - WepTimer) * 3
    SELECT CASE Sel
      CASE 6
        IF Player.Laser = 0 THEN
          Font "-", 30, Cursor * 7 + 150, _RGBA(255, 0, 0, Trans), 1
        ELSE
          Font RTRIM$(PlayWep(Sel).Name), 30, Cursor * 7 + 150, _RGBA(255, 0, 0, Trans), 1
        END IF
      CASE ELSE
        IF PlayWep(Sel).Ammo <= 0 THEN
          Font "-", 30, Cursor * 7 + 150, _RGBA(255, 0, 0, Trans), 1
        ELSE
          Font RTRIM$(PlayWep(Sel).Name), 30, Cursor * 7 + 150, _RGBA(255, 0, 0, Trans), 1
        END IF
    END SELECT
    Cursor = Cursor + 1
  NEXT
END IF

CompassX = 375
CompassY = 250
Font MID$(Compass, CINT(Player.Ang / 10) + 1, 5), CompassX - 20, CompassY + 20, White, 2
X = CompassX + COS(Player.Ang / Rad) * 15
Y = CompassY + SIN(Player.Ang / Rad) * 15
CIRCLE (CompassX, CompassY), 15, _RGB32(145, 145, 145)
PAINT (CompassX, CompassY), _RGB32(145, 145, 145), _RGB32(145, 145, 145)
CIRCLE (CompassX, CompassY), 15, _RGB32(0, 0, 120)
LINE (CompassX, CompassY)-(X, Y), _RGB32(200, 200, 0)
Font "N", CompassX - 4, CompassY - 13, White, 1

'IF Player.Speed < 10 THEN
'  Font "Stall", 50, 180, White, 2
'  Effect 4
'end if

IF Shot > 0 THEN Shot = Shot + 1: IF Shot = 4 THEN Shot = 0
IF Shot > 0 AND Shot < 3 THEN
  LINE (399, 297)-(CrossX - 1, CrossY), _RGBA32(255, 255, 0, 128)
  LINE (0, 297)-(CrossX + 1, CrossY), _RGBA32(255, 255, 0, 128)

  LINE (399, 299)-(CrossX - 1, CrossY), _RGBA32(255, 0, 0, 198)
  LINE (0, 299)-(CrossX + 1, CrossY), _RGBA32(255, 0, 0, 198)

  LINE (397, 299)-(CrossX - 1, CrossY), _RGBA32(255, 255, 0, 128)
  LINE (2, 299)-(CrossX + 1, CrossY), _RGBA32(255, 255, 0, 128)

  CIRCLE (CrossX, CrossY), 1, White
  Player.Heat = Player.Heat + 50
END IF


IF CrossX <> 200 AND CrossY <> 150 THEN
  C& = _RGBA(255, 255, 0, 128)
ELSE
  C& = _RGBA(255, 0, 0, 128)
END IF

CIRCLE (200, 150), 10, Red
LINE (180, 150)-(220, 150), Gray
LINE (200, 130)-(200, 170), Gray

CIRCLE (CrossX, CrossY), 8, C&
LINE (CrossX - 13, CrossY)-(CrossX + 13, CrossY), _RGBA(128, 128, 128, 128)
LINE (CrossX, CrossY - 13)-(CrossX, CrossY + 13), _RGBA(128, 128, 128, 128)

_DEST Layer

END SUB


FUNCTION Distance (X1, Y1, X2, Y2)
Distance = SQR((X1 - X2) * (X1 - X2) + (Y1 - Y2) * (Y1 - Y2))
END FUNCTION


FUNCTION Distance3D (X1, Y1, Z1, X2, Y2, Z2)
Distance3D = SQR((X1 - X2) * (X1 - X2) + (Y1 - Y2) * (Y1 - Y2) + (Z1 - Z2) * (Z1 - Z2))
END FUNCTION

SUB DrawMouse (Style)

DIM DrawX AS INTEGER, DrawY AS INTEGER

DrawX = INT(MouseX / 2)
DrawY = INT(MouseY / 2)

SELECT CASE Style
  CASE 1
    D = 15
    FOR A = 70 TO 90
      X = DrawX + COS(A / Rad) * D
      Y = DrawY + SIN(A / Rad) * D
      LINE (DrawX, DrawY)-(X, Y), _RGB(255 - (90 - A) * 10, 0, 0)
    NEXT
  CASE 2
    LINE (DrawX - 2, DrawY)-(DrawX + 2, DrawY), _RGBA(192, 192, 192, 128)
    LINE (DrawX, DrawY - 2)-(DrawX, DrawY + 2), _RGBA(192, 192, 192, 128)
    PSET (DrawX - 3, DrawY), _RGBA(255, 255, 0, 128)
    PSET (DrawX + 3, DrawY), _RGBA(255, 255, 0, 128)
    PSET (DrawX, DrawY - 3), _RGBA(255, 255, 0, 128)
    PSET (DrawX, DrawY + 3), _RGBA(255, 255, 0, 128)

END SELECT
END SUB


SUB DrawObjects

DIM BackGY AS SINGLE, BackGX AS SINGLE, Dist AS SINGLE
DIM BGAngle AS SINGLE, AngleDif AS SINGLE
DIM i AS LONG, Limit AS LONG, Max AS LONG


'=====  RADAR  ======

RadarX = 325
RadarY = 215

IF Track > 10000 THEN: Track = 10000
IF Track < 250 THEN: Track = 250

_DEST DisplayScreen

CIRCLE (RadarX, RadarY), 25, _RGB32(100, 0, 255) ' radar ring
PAINT (RadarX, RadarY), _RGB32(192, 192, 192), _RGB32(100, 0, 255)
CIRCLE (RadarX, RadarY), Track / 500, _RGB32(200, 100, 0) ' tracking radius
PSET (RadarX, RadarY), _RGB32(0, 0, 255): ' player
X = RadarX + COS((270 + 32) / Rad) * 25
Y = RadarY + SIN((270 + 32) / Rad) * 25
LINE (RadarX, RadarY)-(X, Y)
X = RadarX + COS((270 - 32) / Rad) * 25
Y = RadarY + SIN((270 - 32) / Rad) * 25
LINE (RadarX, RadarY)-(X, Y)

_DEST Layer

'===========================


Count = 0
FOR i = 1 TO NumEnemy
  IF Enemy(i).Status <= 30 THEN
    Count = Count + 1
    ObjectList(Count).Use = 1
    ObjectList(Count).Type = 1
    ObjectList(Count).Which = i
    ObjectList(Count).Dist = Enemy(i).Dist
  END IF
NEXT
FOR i = 1 TO NumBG
  IF BackGround(i).Use = 1 THEN
    Count = Count + 1
    ObjectList(Count).Use = 1
    ObjectList(Count).Type = 2
    ObjectList(Count).Which = i
    ObjectList(Count).Dist = BackGround(i).Dist
  END IF
NEXT
FOR i = 1 TO NumWeapon
  IF Weapon(i).Use = 1 THEN
    Count = Count + 1
    ObjectList(Count).Use = 1
    ObjectList(Count).Type = 3
    ObjectList(Count).Which = i
    ObjectList(Count).Dist = Weapon(i).Dist
  END IF
NEXT


Max = NumEnemy + NumBG + NumWeapon

FOR i = 2 TO Max
  J = i
  DO UNTIL J = 1
    Parent = J \ 2
    IF ObjectList(J).Dist < ObjectList(Parent).Dist THEN
      SWAP ObjectList(Parent), ObjectList(J)
      J = Parent
    ELSE
      EXIT DO
    END IF
  LOOP
NEXT
FOR i = Max TO 2 STEP -1
  SWAP ObjectList(1), ObjectList(i)
  J = 1
  DO
    Child = 2 * J
    IF Child > i - 1 THEN: EXIT DO
    IF Child + 1 <= i - 1 THEN
      IF ObjectList(Child + 1).Dist < ObjectList(Child).Dist THEN
        Child = Child + 1
      END IF
    END IF
    IF ObjectList(J).Dist > ObjectList(Child).Dist THEN
      SWAP ObjectList(J), ObjectList(Child)
      J = Child
    ELSE
      EXIT DO
    END IF
  LOOP
NEXT


Nearest = 0
Near = 100000

FOR X = 1 TO Max
  IF ObjectList(X).Use = 1 THEN
    ObjectList(X).Use = 0
    i = ObjectList(X).Which

    SELECT CASE ObjectList(X).Type
      CASE 1

        'IF Enemy(i).Dist <= ViewDist AND Enemy(i).Status <= 30 THEN
        IF Enemy(i).Status <= 30 THEN

          Show = 1
          IF FlakHide AND Enemy(i).Type = 13 THEN: Show = 0

          AngleDif = Player.Ang - Enemy(i).Dir

          Facing = Player.Ang - Enemy(i).Ang
          IF Facing < 0 THEN: Facing = Facing + 360
          Enemy(i).Frame = CINT(Facing / 45) + 1
          IF Enemy(i).Frame > 8 THEN: Enemy(i).Frame = Enemy(i).Frame - 8

          Dist = Distance(Enemy(i).X, Enemy(i).Y, Player.X, Player.Y)

          EnemyX = COS((AngleDif + 90) / Rad) * Dist
          EnemyY = SIN((AngleDif - 90) / Rad) * Dist

          _DEST DisplayScreen
          IF Enemy(i).Dist < 12000 AND Show = 1 THEN
            SELECT CASE Enemy(i).Friendly
              CASE 0
                PSET (RadarX + EnemyX / 500, RadarY + EnemyY / 500), _RGB32(255, 0, 0)
              CASE 1
                PSET (RadarX + EnemyX / 500, RadarY + EnemyY / 500), _RGB32(0, 0, 255)
            END SELECT
          END IF
          _DEST Layer

          IF EnemyY < DrawDist THEN
            ZFac = 1 - ((EnemyY - EyeDist) / CamDist)
            Enemy(i).ScreenX = EnemyX / ZFac + 200
            Enemy(i).ScreenY = (Player.Alt - Enemy(i).Alt) / ZFac + 150 - YMove

            Size = Enemy(i).Size / ZFac


            IF Size > 1 THEN
              Ratio = 2 / 3


              X1 = Enemy(i).ScreenX - Size
              Y1 = Enemy(i).ScreenY - Size * Ratio

              X2 = Enemy(i).ScreenX + Size
              Y2 = Enemy(i).ScreenY + Size * Ratio

              IF X1 < X2 AND Y1 < Y2 THEN
                IF ScreenCheck(Enemy(i).ScreenX, Enemy(i).ScreenY, Size) THEN
                  IF Enemy(i).Status = 0 THEN

                    IF Show = 1 THEN
                      IF Enemy(i).Hit = 1 THEN
                        _PUTIMAGE (X1, Y1)-(X2, Y2), Pic(Enemy(i).Pic, Enemy(i).Frame + 8), Layer
                      ELSE
                        _PUTIMAGE (X1, Y1)-(X2, Y2), Pic(Enemy(i).Pic, Enemy(i).Frame), Layer
                      END IF
                    END IF

                    IF Enemy(i).Hit = 1 THEN: Enemy(i).Hit = 0

                    TargDist = Distance(CrossX, CrossY, Enemy(i).ScreenX, Enemy(i).ScreenY)

                    IF Enemy(i).Dist < Near AND Enemy(i).Dist < Track AND Enemy(i).Friendly = 0 AND Show = 1 THEN
                      Near = Enemy(i).Dist
                      Nearest = i
                      NearestX = Enemy(i).ScreenX
                      NearestY = Enemy(i).ScreenY
                    END IF
                  ELSE
                    _PUTIMAGE (Enemy(i).ScreenX - Size, Enemy(i).ScreenY - Size)-(Enemy(i).ScreenX + Size, Enemy(i).ScreenY + Size), Explosion(INT(30 * RND + 1)), Layer
                  END IF
                END IF
              END IF
            END IF

            IF Shot > 0 AND Player.WepLock > 0 AND Player.Target = i THEN
              Hit = RND * 100
              IF Hit < Size THEN
                _SNDPLAYCOPY Sounds(2)
                Damage = 100
                Enemy(i).Armor = Enemy(i).Armor - Damage
                DamageDone = DamageDone + Damage
              END IF
            END IF

            'IF Enemy(i).Dist < 1000 AND RND < .06 AND Enemy(i).Shot = 0 THEN: Enemy(i).Shot = 15
          END IF
        END IF
        IF Player.Target = 0 THEN
          NearestX = 200
          NearestY = 150
        END IF
      CASE 2
        BackGround(i).Ang = Angle(Player.X, Player.Y, BackGround(i).X, BackGround(i).Y)
        BackGround(i).Dist = Distance3D(Player.X, Player.Y, Player.Alt, BackGround(i).X, BackGround(i).Y, BackGround(i).Alt)

        IF BackGround(i).Dist <= ViewDist THEN
          AngleDif = Player.Ang - BackGround(i).Ang

          BackGX = COS((AngleDif + 90) / Rad) * BackGround(i).Dist
          BackGY = SIN((AngleDif - 90) / Rad) * BackGround(i).Dist

          IF BackGY < DrawDist THEN

            ZFac = 1 - ((BackGY - EyeDist) / CamDist)
            BackGround(i).ScreenX = BackGX / ZFac + 200
            BackGround(i).ScreenY = (Player.Alt - BackGround(i).Alt) / ZFac + 150 - YMove

            IF ScreenCheck(BackGround(i).ScreenX, BackGround(i).ScreenY, Size) AND Size < 10000 THEN
              SELECT CASE BackGround(i).Style
                CASE 0 'Pyramid
                  IF CurLev <> 8 THEN
                    Size = 100 / ZFac

                    X1 = BackGround(i).ScreenX - Size
                    Y1 = BackGround(i).ScreenY
                    X2 = BackGround(i).ScreenX
                    Y2 = BackGround(i).ScreenY - Size
                    X3 = BackGround(i).ScreenX + Size
                    Y3 = BackGround(i).ScreenY


                    _MAPTRIANGLE (0, 0)-(10, 10)-(0, 10), Pyramid TO(X1, Y1)-(X2, Y2)-(X3, Y3), Layer
                    LINE (X1, Y1)-(X2, Y2), _RGB32(200, 130, 0)
                    LINE (X2, Y2)-(X3, Y3), _RGB32(200, 130, 0)
                    LINE (X3, Y3)-(X1, Y1), _RGB32(200, 130, 0)
                  END IF
                CASE 1 'Building
                  LINE (BackGround(i).ScreenX - Size, BackGround(i).ScreenY - Size * 2)-(BackGround(i).ScreenX + Size, BackGround(i).ScreenY), _RGB32(200, 200, 200), BF
                  LINE (BackGround(i).ScreenX - Size, BackGround(i).ScreenY - Size * 2)-(BackGround(i).ScreenX + Size, BackGround(i).ScreenY), _RGB32(120, 120, 120), B
                CASE 2 'Cloud
                  Size = 250 / ZFac

                  X1 = BackGround(i).ScreenX - Size * 2
                  X2 = BackGround(i).ScreenX + Size * 2
                  Y1 = BackGround(i).ScreenY - Size
                  Y2 = BackGround(i).ScreenY + Size

                  _PUTIMAGE (X1, Y1)-(X2, Y2), Cloud(BackGround(i).Type), Layer

              END SELECT
            END IF

          END IF
        END IF

      CASE 3
        IF Weapon(i).Use = 1 THEN
          SELECT CASE Weapon(i).Target
            CASE IS >= 0 'Enemies  (Player Weapons)
              IF Weapon(i).Var > 0 THEN
                WeaponAng = Angle(Player.X, Player.Y, Weapon(i).X, Weapon(i).Y)
                AngleDif = Player.Ang - WeaponAng

                WepX = COS((AngleDif + 90) / Rad) * Weapon(i).Dist
                WepY = SIN((AngleDif - 90) / Rad) * Weapon(i).Dist

                ZFac = 1 - ((WepY - EyeDist) / CamDist)
                WepX2D = WepX / ZFac + 200
                WepY2D = (Player.Alt - Weapon(i).Alt) / ZFac + 150 - YMove

                SELECT CASE Weapon(i).Type
                  CASE 1
                    SizeX = 50 / ZFac
                  CASE 2
                    SizeX = 10 / ZFac
                  CASE 3
                    SizeX = 250 / ZFac
                  CASE 4
                    SizeX = 40 / ZFac
                  CASE 5
                    SizeX = 45 / ZFac
                  CASE 6
                    Length = 1000
                  CASE 8
                    SizeX = 25 / ZFac
                END SELECT



                _DEST DisplayScreen
                IF Distance(Weapon(i).X, Weapon(i).Y, Player.X, Player.Y) < 12000 AND Show = 1 THEN
                  PSET (RadarX + WepX / 500, RadarY + WepY / 500), _RGBA32(0, 128, 128, 128)
                END IF
                _DEST Layer



                IF WepY < DrawDist THEN

                  Facing = Player.Ang - Weapon(i).Ang
                  IF Facing < 0 THEN: Facing = Facing + 360
                  Frame = CINT(Facing / 45) MOD 8
                  IF Frame < 0 THEN: Frame = 8 - ABS(Frame)
                  Frame = Frame + 1

                  SELECT CASE Weapon(i).Type
                    CASE 1 TO 5, 7 TO 8
                      SELECT CASE Weapon(i).Var
                        CASE 1 TO Weapon(i).Range
                          SELECT CASE Weapon(i).Type
                            CASE 4, 5
                              SizeY = SizeX / 1.5
                              _PUTIMAGE (WepX2D - SizeX, WepY2D - SizeY)-(WepX2D + SizeX, WepY2D + SizeY), Pic(Weapon(i).Pic, Frame), Layer
                            CASE ELSE
                              SizeY = SizeX
                              _PUTIMAGE (WepX2D - SizeX, WepY2D - SizeY)-(WepX2D + SizeX, WepY2D + SizeY), BombPic, Layer
                          END SELECT
                        CASE ELSE
                          Frame = INT(30 * RND + 1)
                          SizeY = SizeX
                          _PUTIMAGE (WepX2D - SizeX, WepY2D - SizeY)-(WepX2D + SizeX, WepY2D + SizeY), Explosion(Frame), Layer
                      END SELECT
                    CASE 6
                      FarAlt = Weapon(i).Alt - Weapon(i).Tilt
                      X3D = Weapon(i).X + COS(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)
                      Y3D = Weapon(i).Y + SIN(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)
                      FarDist = Distance(X3D, Y3D, Player.X, Player.Y)
                      IF FarDist < 5000 THEN
                        WeaponAng = Angle(Player.X, Player.Y, X3D, Y3D)
                        AngleDif = Player.Ang - WeaponAng

                        WepX = COS((AngleDif + 90) / Rad) * FarDist
                        WepY = SIN((AngleDif - 90) / Rad) * FarDist

                        ZFac = 1 - (WepY - EyeDist) / CamDist
                        WepX2D2 = WepX / ZFac + 200
                        WepY2D2 = (Player.Alt - FarAlt) / ZFac + 150 - YMove

                        LINE (WepX2D, WepY2D)-(WepX2D2, WepY2D2), Yellow
                      END IF
                  END SELECT
                END IF
              END IF

            CASE -1 '  Player (Enemy Weapons)

              '1  Bullet
              '2  Missile
              '3  Laser
              '4  Heat Seek
              '5  Flak (Area Damage)

              IF Weapon(i).Var > 0 THEN

                WeaponAng = Angle(Player.X, Player.Y, Weapon(i).X, Weapon(i).Y)
                AngleDif = Player.Ang - WeaponAng

                WepX = COS((AngleDif + 90) / Rad) * Weapon(i).Dist
                WepY = SIN((AngleDif - 90) / Rad) * Weapon(i).Dist

                _DEST DisplayScreen
                IF Distance(Weapon(i).X, Weapon(i).Y, Player.X, Player.Y) < 12000 AND Show = 1 THEN
                  PSET (RadarX + WepX / 500, RadarY + WepY / 500), _RGBA32(0, 128, 128, 128)
                END IF
                _DEST Layer


                IF WepY < DrawDist THEN

                  ZFac = 1 - ((WepY - EyeDist) / CamDist)
                  WepX2D = WepX / ZFac + 200
                  WepY2D = (Player.Alt - Weapon(i).Alt) / ZFac + 150 - YMove

                  Facing = Player.Ang - Weapon(i).Ang
                  IF Facing < 0 THEN: Facing = Facing + 360
                  Frame = CINT(Facing / 45) MOD 8
                  IF Frame < 0 THEN: Frame = 8 - ABS(Frame)
                  Frame = Frame + 1

                  SELECT CASE Weapon(i).Type

                    CASE 1 'Bullet
                      SizeX = 5 / ZFac
                      SizeY = SizeX
                      _PUTIMAGE (WepX2D - SizeX, WepY2D - SizeY)-(WepX2D + SizeX, WepY2D + SizeY), BombPic, Layer
                    CASE 2, 4 'Missile  Rocket
                      SizeX = 10 / ZFac
                      SizeY = SizeX / 1.5
                      _PUTIMAGE (WepX2D - SizeX, WepY2D - SizeY)-(WepX2D + SizeX, WepY2D + SizeY), Pic(Weapon(i).Pic, Frame), Layer

                    CASE 3 'Laser

                      X3D2 = Weapon(i).X - COS(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)
                      Y3D2 = Weapon(i).Y - SIN(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)
                      FarAlt = Weapon(i).Alt + Weapon(i).Tilt

                      WeaponAng = Angle(Player.X, Player.Y, X3D2, Y3D2)
                      Dist = Distance3D(Player.X, Player.Y, Player.Alt, X3D2, Y3D2, FarAlt)
                      AngleDif = Player.Ang - WeaponAng

                      WepX2 = COS((AngleDif + 90) / Rad) * Dist
                      WepY2 = SIN((AngleDif - 90) / Rad) * Dist

                      IF WepY2 < DrawDist THEN
                        ZFac = 1 - ((WepY2 - EyeDist) / CamDist)
                        WepX2D2 = WepX2 / ZFac + 200
                        WepY2D2 = (Player.Alt - FarAlt) / ZFac + 150 - YMove
                        LINE (WepX2D, WepY2D)-(WepX2D2, WepY2D2), Yellow
                      END IF
                    CASE 5
                      IF Weapon(i).Var < 2 THEN
                        SizeX = 50 / ZFac
                        SizeY = SizeX
                        _PUTIMAGE (WepX2D - SizeX, WepY2D - SizeY)-(WepX2D + SizeX, WepY2D + SizeY), BombPic, Layer
                      ELSE
                        Frame = INT(30 * RND + 1)
                        Size = 500 / ZFac

                        _PUTIMAGE (WepX2D - Size, WepY2D - Size)-(WepX2D + Size, WepY2D + Size), Explosion(Frame), Layer
                      END IF
                  END SELECT
                END IF
              END IF
          END SELECT
        END IF
    END SELECT
  END IF
NEXT

Dist = Distance(CrossX, CrossY, NearestX, NearestY)
IF Dist < Player.WepLock OR Dist <= 10 THEN
  IF Dist < 10 THEN: Player.WepLock = 1
  Player.Target = Nearest
  IF Player.Target > 0 THEN: Font "LOCK!", 180, 190, White, 2
ELSE
  Player.WepLock = 0
  'Player.Target = 0
END IF
IF AutoPilot THEN: Font "Auto Pilot", 160, 240, White, 2


END SUB


SUB EnemyMove
IF MissionPoint = 0 THEN: EXIT SUB

'====================

EnemyTotal = 0
FriendlyTotal = 0
'Player.Alt = 0

FOR i = 1 TO NumEnemy
  IF Enemy(i).Status <= 30 AND Enemy(i).Use = 1 THEN
    IF Enemy(i).Status = 30 THEN: Enemy(i).Use = 0

    SELECT CASE Enemy(i).Friendly
      CASE 0: EnemyTotal = EnemyTotal + 1
      CASE 1: FriendlyTotal = FriendlyTotal + 1
    END SELECT

    '   SHOOT WEAPONS

    PlayDist = Distance(Enemy(i).X, Enemy(i).Y, Player.X, Player.Y)
    PlayAng = Angle(Enemy(i).X, Enemy(i).Y, Player.X, Player.Y)

    IF Distance3D(Enemy(i).X, Enemy(i).Y, Enemy(i).Alt, Player.X, Player.Y, Player.Alt) < Enemy(i).Size / 5 THEN
      Player.Armor = Player.Armor - (Enemy(i).Size * Player.Speed) / 500
      IF Player.Armor < 0 THEN: Failed: Restart = 1
    END IF

    IF CurLev = 6 AND Enemy(i).Type = 10 THEN
      PlayDist = Distance(Enemy(i).X, Enemy(i).Y, Enemy(i).GoX, Enemy(i).GoY)
      PlayAng = Angle(Enemy(i).X, Enemy(i).Y, Enemy(i).GoX, Enemy(i).GoY)
    END IF

    AngleDif = ABS(Enemy(i).Ang - PlayAng)

    IF AngleDif > 180 THEN
      IF Enemy(i).Ang > PlayAng THEN
        AngleDif = ((360 - AngleDif) + PlayAng)
      ELSE
        AngleDif = ((360 - AngleDif) + Enemy(i).Ang)
      END IF
    END IF

    FOR j = 1 TO 10
      WeaponTimer(i, j) = WeaponTimer(i, j) + 1
      IF WeaponTimer(i, j) >= WeaponStat(Enemy(i).Type, j).Refire THEN
        WeaponTimer(i, j) = WeaponStat(Enemy(i).Type, j).Refire
        WepType = WeaponStat(Enemy(i).Type, j).WeaponType
        SELECT CASE WepType
          CASE 1, 2, 4
            IF Ammo(i, j) <= 0 THEN: EXIT FOR
        END SELECT

        IF PlayDist <= WeaponStat(Enemy(i).Type, j).Range AND ABS(AngleDif) <= WeaponStat(Enemy(i).Type, j).Ang OR WeaponStat(Enemy(i).Type, j).WeaponType = 5 THEN
          FOR w = 1 TO NumWeapon
            IF Weapon(w).Use = 0 THEN
              WeaponTimer(i, j) = 0
              IF Enemy(i).Type = 13 THEN
                WeaponTimer(i, j) = RND * WeaponStat(Enemy(i).Type, j).Refire / 5
              END IF
              SELECT CASE WepType
                CASE 1, 2, 4
                  Ammo(i, j) = Ammo(i, j) - 1
              END SELECT

              Weapon(w).Use = 1
              Weapon(w).Shooter = i
              Weapon(w).X = Enemy(i).X
              Weapon(w).Y = Enemy(i).Y
              Weapon(w).Alt = Enemy(i).Alt
              Weapon(w).Ang = PlayAng
              Weapon(w).Speed = WeaponStat(Enemy(i).Type, j).Speed
              Weapon(w).Type = WeaponStat(Enemy(i).Type, j).WeaponType
              Weapon(w).Var = 1
              Weapon(w).Power = WeaponStat(Enemy(i).Type, j).Damage
              Weapon(w).Range = WeaponStat(Enemy(i).Type, j).Range
              Weapon(w).Target = -1
              Weapon(w).Dist = Distance(Player.X, Player.Y, Enemy(i).X, Enemy(i).Y)
              Weapon(w).Tilt = (Weapon(w).Alt - Player.Alt) / (Weapon(w).Dist / (Weapon(w).Speed / 100))

              IF CurLev = 6 AND Enemy(i).Type = 10 THEN
                Weapon(w).Tilt = (Weapon(w).Alt - 80) / (Weapon(w).Dist / (Weapon(w).Speed / 100))
              END IF

              SELECT CASE Weapon(w).Type
                CASE 2, 4
                  FOR p = 1 TO PicCount
                    IF UCASE$(RTRIM$(PicInfo(p).Name)) = "MISSILE" THEN
                      Weapon(w).Pic = p
                    END IF
                  NEXT
              END SELECT

              EXIT FOR
            END IF
          NEXT
        END IF
      END IF
    NEXT

    '  MOVE

    IF Enemy(i).Ground = 1 THEN: Enemy(i).Alt = 0
    Enemy(i).TargetDist = Distance3D(Enemy(i).X, Enemy(i).Y, Enemy(i).Alt, Enemy(i).GoX, Enemy(i).GoY, Enemy(i).GoAlt)
    Enemy(i).TurnRadius = (((360 / Enemy(i).Turn) * Enemy(i).Speed) / 2) / Pi

    IF Enemy(i).Speed > 0 THEN
      IF (Enemy(i).TargetDist / Enemy(i).Speed) > 0 THEN
        Enemy(i).Tilt = (Enemy(i).Alt - Enemy(i).GoAlt) / (Enemy(i).TargetDist / Enemy(i).Speed)
      ELSE
        Enemy(i).Tilt = 0
      END IF
    END IF

    Enemy(i).Dir = Angle(Player.X, Player.Y, Enemy(i).X, Enemy(i).Y)
    Enemy(i).Dist = Distance3D(Player.X, Player.Y, Player.Alt, Enemy(i).X, Enemy(i).Y, Enemy(i).Alt)

    Enemy(i).X = Enemy(i).X + COS(Enemy(i).Ang / Rad) * Enemy(i).Speed
    Enemy(i).Y = Enemy(i).Y + SIN(Enemy(i).Ang / Rad) * Enemy(i).Speed
    Enemy(i).Alt = Enemy(i).Alt - Enemy(i).Tilt
    IF Enemy(i).Alt < 80 THEN: Enemy(i).Alt = 80

    IF Enemy(i).TargetDist < 50 THEN
      NewAng = RND * 360
      NewDist = RND * 5000 + 2500
      Enemy(i).GoAlt = RND * 3000

      Enemy(i).GoX = Enemy(i).X + COS(NewAng / Rad) * NewDist
      Enemy(i).GoY = Enemy(i).Y + SIN(NewAng / Rad) * NewDist
      SELECT CASE CurLev
        CASE 8
          Enemy(i).GoX = Player.X + COS(NewAng / Rad) * 2500
          Enemy(i).GoY = Player.Y + SIN(NewAng / Rad) * 2500
        CASE 11
          Enemy(i).GoAlt = 2000 * RND + 6000
      END SELECT
    END IF

    SELECT CASE CurLev
      CASE 10
        IF Enemy(i).Type = 12 THEN
          Enemy(i).GoX = Enemy(i).X + COS(0) * 200000
          Enemy(i).GoY = Enemy(i).Y + SIN(0) * 200000
          Enemy(i).Friendly = 1
        END IF
      CASE 11
        IF Enemy(i).Type <> 15 THEN
          NewDist = RND * 5000 + 250
          NewAng = RND * 360
          NewAlt = RND * 2000 - 1000
          Enemy(i).GoX = Enemy(Enemy(i).Origin).X + COS(NewAng / Rad) * NewDist
          Enemy(i).GoY = Enemy(Enemy(i).Origin).Y + SIN(NewAng / Rad) * NewDist
          Enemy(i).GoAlt = Enemy(Enemy(i).Origin).Alt + NewAlt
        END IF
    END SELECT


    IF PlayDist <= Enemy(i).Engage THEN
      SELECT CASE CurLev
        CASE 6
          IF Enemy(i).Type = 10 THEN
            NewAng = RND * 360
            NewDist = RND * 2000

            Enemy(i).GoX = COS(NewAng / Rad) * NewDist
            Enemy(i).GoY = SIN(NewAng / Rad) * NewDist
            Enemy(i).GoAlt = RND * 750 + 80
          END IF
        CASE ELSE
          Enemy(i).GoX = Player.X
          Enemy(i).GoY = Player.Y
          Enemy(i).GoAlt = Player.Alt
      END SELECT
    END IF

    SELECT CASE Enemy(i).Type
      CASE 7
        Enemy(i).GoX = 80000
        Enemy(i).GoY = -80000
        Enemy(i).GoAlt = 6000

      CASE 15
        Enemy(i).Alt = 7000
        Enemy(i).GoX = Enemy(i).X + COS(Enemy(i).Turn / Rad) * Enemy(i).Speed
        Enemy(i).GoY = Enemy(i).Y + SIN(Enemy(i).Turn / Rad) * Enemy(i).Speed
        Newjet = RND * 1000
        IF Newjet < 5 THEN
          NumEnemy = NumEnemy + 1
          FOR N = 1 TO 5000
            IF Enemy(N).Use = 0 THEN
              Enemy(N).Use = 1
              EnemyType = INT(RND * 20 + 1)
              SELECT CASE EnemyType
                CASE 1 TO 10: Enemy(N).Type = 1
                CASE 11 TO 16: Enemy(N).Type = 2
                CASE 17 TO 20: Enemy(N).Type = 3
                  'CASE 20: Enemy(N).Type = 6
              END SELECT
              NewAng = RND * 360

              Enemy(N).X = Enemy(i).X
              Enemy(N).Y = Enemy(i).Y

              Enemy(N).GoX = Player.X
              Enemy(N).GoY = Player.Y
              Enemy(N).Alt = Player.Alt
              Enemy(N).Scrap = EnemyStat(Enemy(N).Type).Scrap * 10

              Enemy(N).Name = EnemyStat(Enemy(N).Type).Name
              Enemy(N).Ground = EnemyStat(Enemy(N).Type).Ground
              Enemy(N).Size = EnemyStat(Enemy(N).Type).Size
              Enemy(N).MaxSpeed = EnemyStat(Enemy(N).Type).MaxSpeed
              Enemy(N).Thrust = EnemyStat(Enemy(N).Type).Thrust
              Enemy(N).Armor = EnemyStat(Enemy(N).Type).Armor
              Enemy(N).Status = 0 '   status      (0 = Ok    Other = destroyed)
              Enemy(N).Turn = EnemyStat(Enemy(N).Type).Turn
              Enemy(N).Engage = EnemyStat(Enemy(N).Type).Engage
              Enemy(N).Origin = i

              FOR p = 1 TO PicCount
                IF UCASE$(RTRIM$(EnemyStat(Enemy(N).Type).FileName)) = UCASE$(RTRIM$(PicInfo(p).Name)) THEN
                  Enemy(N).Pic = p
                END IF
              NEXT


              FOR A = 1 TO 10
                Ammo(i, A) = WeaponStat(Enemy(N).Type, A).Ammo
              NEXT
              EXIT FOR
            END IF

          NEXT
        END IF
      CASE 16
        Enemy(i).GoX = Player.X
        Enemy(i).GoY = Player.Y
    END SELECT




    IF PlayDist <= 200 THEN
      Enemy(i).Speed = Enemy(i).Speed - Enemy(i).Thrust
    END IF

    IF Enemy(i).X < -Level(CurLev).Width * 5 OR Enemy(i).X > Level(CurLev).Width * 5 OR Enemy(i).Y < -Level(CurLev).Height * 5 OR Enemy(i).Y > Level(CurLev).Height * 5 THEN
      NewDist = RND * Distance(Enemy(i).X, Enemy(i).Y, 0, 0)
      NewAng = Angle(Enemy(i).X, Enemy(i).Y, 0, 0)
      Enemy(i).GoX = Enemy(i).X + COS(NewAng / Rad) * NewDist
      Enemy(i).GoY = Enemy(i).Y + SIN(NewAng / Rad) * NewDist
    END IF


    Enemy(i).TargetAngle = Angle(Enemy(i).X, Enemy(i).Y, Enemy(i).GoX, Enemy(i).GoY)
    AngleDif = ABS(Enemy(i).Ang - Enemy(i).TargetAngle)
    IF AngleDif < 180 THEN
      IF Enemy(i).Ang < Enemy(i).TargetAngle THEN
        Enemy(i).Ang = Enemy(i).Ang + Enemy(i).Turn
      ELSE
        Enemy(i).Ang = Enemy(i).Ang - Enemy(i).Turn
      END IF
      IF AngleDif < Enemy(i).Turn THEN: Enemy(i).Ang = Enemy(i).TargetAngle
    ELSE
      IF Enemy(i).Ang > Enemy(i).TargetAngle THEN
        Enemy(i).Ang = Enemy(i).Ang + Enemy(i).Turn
        IF ((360 - AngleDif) + Enemy(i).TargetAngle) < Enemy(i).Turn THEN: Enemy(i).Ang = Enemy(i).TargetAngle
      ELSE
        Enemy(i).Ang = Enemy(i).Ang - Enemy(i).Turn
        IF ((360 - Enemy(i).TargetAngle) + AngleDif) < Enemy(i).Turn THEN: Enemy(i).Ang = Enemy(i).TargetAngle
      END IF
    END IF

    IF Enemy(i).TurnRadius > Enemy(i).TargetDist AND AngleDif > Enemy(i).Turn THEN
      IF Enemy(i).Speed > 0 THEN: Enemy(i).Speed = Enemy(i).Speed * .9
    ELSE
      IF Enemy(i).Speed < Enemy(i).MaxSpeed THEN: Enemy(i).Speed = Enemy(i).Speed + Enemy(i).Thrust
    END IF


    SELECT CASE Enemy(i).Ang
      CASE IS < 0: Enemy(i).Ang = Enemy(i).Ang + 360
      CASE IS > 360: Enemy(i).Ang = Enemy(i).Ang - 360
    END SELECT

    IF Enemy(i).Armor <= 0 AND Enemy(i).Status = 0 THEN
      Enemy(i).Status = 1
      Enemy(i).Friendly = 0
      _SNDPLAYCOPY Sounds(1)
      Player.Money = Player.Money + Enemy(i).Scrap
    END IF

    IF PlayDist <= 500 AND Enemy(i).Engage >= 500 THEN
      IF Enemy(i).Speed > Player.Speed / 100 THEN: Enemy(i).Speed = Player.Speed / 100
    END IF

    IF Enemy(i).Status > 0 THEN: Enemy(i).Status = Enemy(i).Status + 1
    IF Enemy(i).Armor <> Enemy(i).OldArmor THEN: Enemy(i).Hit = 1
    Enemy(i).OldArmor = Enemy(i).Armor
  END IF
NEXT

'Font STR$(Player.Target), 0, 230, White, 2

END SUB


SUB Failed
_PRINTMODE _KEEPBACKGROUND
LINE (0, 0)-(400, 300), Red, BF
DO
  Press = _KEYHIT
  _PRINTSTRING (RND * 400, RND * 300), "BOOM"
  ShowScreen
  X = RND * 400
  Y = RND * 300
  S = RND * 50
  FOR C = 1 TO S
    CIRCLE (X, Y), C, _RGBA32((C / S) * 255, 0, 0, 128)
  NEXT
LOOP UNTIL Press <> 0

Player.Alt = 100

LINE (80, 80)-(320, 240), Black, BF
LINE (80, 80)-(320, 240), Yellow, B

Text$ = "You've been destroyed and have failed your mission.  Without anyone to oppose them, the Invading Force is able to complete their plans for invasion."
FontBox Text$, 80, 80, 320, 240, 5, 1
SLEEP

Restart = 1


END SUB



SUB Font (Text$, Col%, Row%, Colr&, FontSize%)

StringLen% = LEN(Text$)
FOR I = 1 TO StringLen%

  Char% = ASC(MID$(Text$, I, 1))
  SELECT CASE FontSize%
    CASE 1: FontX% = 5: FontY% = 5
    CASE 2: FontX% = 7: FontY% = 8
  END SELECT
  FOR X = 1 TO FontX%
    FOR Y = 1 TO FontY%
      TextX% = Col% + (I * (FontX% + 1) - FontY%) + X
      TextY% = Row% + Y
      SELECT CASE FontSize%
        CASE 1: IF Fonts(Char%, X, Y) > 0 THEN: PSET (TextX%, TextY%), Colr&
        CASE 2: IF BigFonts(Char%, X, Y) > 0 THEN: PSET (TextX%, TextY%), Colr&
      END SELECT
    NEXT
  NEXT
NEXT
END SUB


SUB FontBox (Text$, X1, Y1, X2, Y2, Border, IfDelay)

X1 = X1 + Border
Y1 = Y1 + Border
X2 = X2 - Border
Y2 = Y2 - Border

X = X1
Y = Y1
Skip = 0
FOR i = 1 TO LEN(Text$)
  Press = _KEYHIT
  IF Press > 0 THEN: Hold = 1
  IF Press <= 0 THEN: Hold = 0
  IF Press = 27 THEN: Skip = 1
  IF Skip = 0 THEN
    IF Hold = 0 AND IfDelay = 1 THEN
      _DELAY .1
    END IF
  END IF
  Font MID$(Text$, i, 1), X, Y, White, 1

  IF MID$(Text$, i, 1) = CHR$(32) THEN
    WordLen = 0
    Pointer = i
    DO
      Done = 0
      Pointer = Pointer + 1
      IF MID$(Text$, Pointer, 1) = CHR$(32) OR Pointer > LEN(Text$) THEN
        Done = 1
      ELSE
        WordLen = WordLen + 1
      END IF
    LOOP UNTIL Done = 1
    WordEnd = X + WordLen * 10 + 10
  END IF

  X = X + 10

  IF WordEnd >= X2 THEN
    WordEnd = X1
    X = X1
    Y = Y + 10
  END IF
  IF Skip = 0 THEN
    IF IfDelay = 1 THEN: ShowScreen
  END IF
NEXT
IF Skip = 1 THEN: ShowScreen
END SUB

SUB GameOverCheck

_DEST Layer

SELECT CASE CurLev
  CASE 4
    IF MissionPoint = 2 THEN

      CLS
      Text$ = "The satellite ship was able to reach its max speed and escape.  The enemy now knows of your secret information and can use it to their advantage.  Failure at their hands is now inevitable.               GAME OVER"
      FontBox Text$, 50, 50, 250, 150, 15, 1
      ShowScreen
      SLEEP
      Restart = -1

    END IF

  CASE 6

    IF MissionPoint = 2 THEN

      CLS
      Text$ = "You have failed to defend the air strip and it has been destroyed.  Without the aid of the Friendly fighters, all of your forces are overrun and the Enemy Force completes their plans for invasion.                                           GAME OVER"
      FontBox Text$, 50, 50, 250, 150, 15, 1
      ShowScreen
      SLEEP
      Restart = -1

    END IF


  CASE 9

    IF MissionPoint = 2 THEN

      CLS
      Text$ = "You have failed to stop the strategic bomber Titan and it has reached its destination, dropping its massive payload of destruction onto your forces.  Without their aid, the Invading Force is able to complete their objective.                         GAME OVER"
      FontBox Text$, 50, 50, 250, 150, 15, 1
      ShowScreen
      SLEEP
      Restart = -1

    END IF

  CASE 10

    IF MissionPoint = 2 THEN

      CLS
      Text$ = "You have failed to successfully escort your forces.  The flak cannons destroyed the vast majority of them and have severely crippled your efforts of retaliation against the Invading Force.  Without their help, failure is inevitable.                                           GAME OVER"
      FontBox Text$, 50, 50, 250, 150, 15, 1
      ShowScreen
      SLEEP
      Restart = -1

    END IF

END SELECT

END SUB


SUB GrassMove

GrassRange = 500

DIM Corner(4, 4)

'1 = 3DX
'2 = 3DZ    (Y = 0    GROUND)

'3 = 2DX Screen
'4 = 2DY Screen

XCoord = INT(Player.X / GrassRange) * GrassRange
YCoord = INT(Player.Y / GrassRange) * GrassRange

MapX = X / 50 + 250
MapY = Y / 50 + 250

Focus = 20
_SOURCE Layer

FOR X = XCoord - ViewDist * 2 TO XCoord + ViewDist * 2 STEP GrassRange
  FOR Y = YCoord - ViewDist * 2 TO YCoord + ViewDist * 2 STEP GrassRange
    Good = 1

    GrassAng = Angle(Player.X, Player.Y, X, Y)
    AngleDif = Player.Ang - GrassAng
    GrassDist = Distance(Player.X, Player.Y, X, Y)

    GrassX = COS((AngleDif + 90) / Rad) * GrassDist
    GrassY = SIN((AngleDif - 90) / Rad) * GrassDist

    ZFac = 1 - ((GrassY - EyeDist) / CamDist)
    GrassX2D = GrassX / ZFac + 200
    GrassY2D = Player.Alt / ZFac + 150 - YMove

    IF GrassY < DrawDist THEN
      SELECT CASE CurLev
        CASE 8
          Col& = _RGB32(0, 0, _GREEN32(POINT(GrassX2D, GrassY2D)) * .85)
        CASE ELSE
          Col& = _RGB32(0, _GREEN32(POINT(GrassX2D, GrassY2D)) * .85, 0)
      END SELECT
      PSET (GrassX2D, GrassY2D), Col&
    END IF
  NEXT
NEXT

IF CurLev = 6 THEN

  FOR X = 0 TO 10
    FOR Y = 0 TO 50
      Good = 4
      CornerDist = Distance(Player.X, Player.Y, Grid(X, Y, 1) * 4 - 200, Grid(X, Y, 2) * 4 - 1000)
      CornerAngle = Angle(Player.X, Player.Y, Grid(X, Y, 1) * 4 - 200, Grid(X, Y, 2) * 4 - 1000)
      AngleDif = Player.Ang - CornerAngle
      CornerX = COS((AngleDif + 90) / Rad) * CornerDist
      CornerY = SIN((AngleDif - 90) / Rad) * CornerDist
      ZFac = 1 - ((CornerY - EyeDist) / CamDist)
      Grid(X, Y, 3) = CornerX / ZFac + 200
      Grid(X, Y, 4) = Player.Alt / ZFac + 150 - YMove

      IF CornerY > DrawDist THEN: Good = 0 'Good - 1
      IF ABS(Grid(X, Y, 3)) > 16383 OR ABS(Grid(X, Y, 4)) > 16383 THEN: Good = 0
      Grid(X, Y, 5) = 0
      IF Good > 0 THEN Grid(X, Y, 5) = 1
    NEXT
  NEXT
  FOR X = 0 TO 9
    FOR Y = 0 TO 49
      IF Grid(X, Y, 5) > 0 AND Grid(X + 1, Y, 5) > 0 AND Grid(X, Y + 1, 5) > 0 AND Grid(X + 1, Y + 1, 5) > 0 THEN
        _MAPTRIANGLE (Grid(X, Y, 1), Grid(X, Y, 2))-(Grid(X + 1, Y, 1), Grid(X + 1, Y, 2))-(Grid(X + 1, Y + 1, 1), Grid(X + 1, Y + 1, 2)), RunWay TO(Grid(X, Y, 3), Grid(X, Y, 4))-(Grid(X + 1, Y, 3), Grid(X + 1, Y, 4))-(Grid(X + 1, Y + 1, 3), Grid(X + 1, Y + 1, 4)), Layer
        _MAPTRIANGLE (Grid(X, Y, 1), Grid(X, Y, 2))-(Grid(X + 1, Y + 1, 1), Grid(X + 1, Y + 1, 2))-(Grid(X, Y + 1, 1), Grid(X, Y + 1, 2)), RunWay TO(Grid(X, Y, 3), Grid(X, Y, 4))-(Grid(X + 1, Y + 1, 3), Grid(X + 1, Y + 1, 4))-(Grid(X, Y + 1, 3), Grid(X, Y + 1, 4)), Layer
      END IF
    NEXT
  NEXT

END IF


END SUB




SUB Horizon
' %%%%%%%%%%%%% DRAW HORIZON %%%%%%%%%%%%%%%%%%%%



ZFac = 1 - ((-1000000 - EyeDist) / CamDist)
Horiz = Player.Alt / ZFac + 150 - YMove
Bottom = Horiz + 299
IF Bottom < 299 THEN: Bottom = 299

SELECT CASE CurLev
  CASE 1: SunHeight = 150
  CASE 2: SunHeight = -10
  CASE 3: SunHeight = -10
  CASE 4: SunHeight = 100
  CASE 5: SunHeight = 160
  CASE 6: SunHeight = 350
  CASE 7: SunHeight = 150
  CASE 8: SunHeight = -20
  CASE 9: SunHeight = -25
  CASE 10: SunHeight = 120
  CASE 11: SunHeight = 20
  CASE 12: SunHeight = 115
END SELECT

Top = Horiz - 299
IF Top > 0 THEN: Top = 0

_PUTIMAGE (0, Top)-(399, Horiz), Sky(CurLev), Layer, (0, 0)-(399, 299)

SunX = ((270 - Player.Ang) / 90) * 200
SunY = SunHeight - YMove

_PUTIMAGE (SunX - 50, SunY - 50)-(SunX + 50, SunY + 50), Sun, Layer
_PUTIMAGE (0, Horiz)-(400, Bottom), Ground(CurLev), Layer, (0, 0)-(399, 299)

GrassMove

END SUB



FUNCTION IfHit (Bx1, By1, Bx2, By2, Tx1, Ty1, TargDist, Infinite)

'Checks to see if the bullet line (Bx1,By1)-(Bx2,By2)
'crosses over the target circle (Tx1,Ty1).

'The coordinates (Px,Py) are the closest point on the line to the center of the circle.
'If the distance between the enemy and the closest point are less than TargetDist then
'the line passes through the circle.

'INFINITE

'1 / Yes
'If the line passes through the circle, it's a hit.
'The line is of infinite length in both directions, so the
'position of the projectile is irrelevant.

'0 / No
'The length of the line is confined.  (Px, Py) must be on the line for it to register
'as a hit.  This is for moving projectiles.


DIM TBx, TBy, Bx, By, Dot, LineLen, Cross, Px, Py, M


SELECT CASE Infinite
  TBx = Tx1 - Bx1
  TBy = Ty1 - By1
  Bx = Bx2 - Bx1
  By = By2 - By1

  CASE 0

    Dot = TBx * Bx + TBy * By
    LineLen = Bx * Bx + By * By

    Cross = Dot / LineLen
    SELECT CASE Cross
      CASE IS < 0
        Px = Bx1
        Py = By1
      CASE IS > 1
        Px = Bx2
        Py = By2
      CASE ELSE
        Px = Bx1 + Cross * Bx
        Py = By1 + Cross * By
    END SELECT

    IF Distance(Tx1, Ty1, Px, Py) <= TargDist THEN
      IfHit = -1
    ELSE
      IfHit = 0
    END IF

  CASE 1

    LineLen = SQR(Bx * Bx + By * By)
    Dist = ABS(TBx * By - TBy * Bx) / LineLen


    IF Dist < Diam THEN
      IfHit = -1
    ELSE
      IfHit = 0
    END IF


END SELECT
END FUNCTION



SUB Intro
_DEST Layer
CLS
FOR i = 0 TO 9
  LINE (40 + i, 40 + i)-(360 - i, 260 - i), _RGB32(0, 0, 160 + (i - 5) * 8), B
NEXT


SELECT CASE CurLev
  CASE 1
    Font "INTRO", 180, 15, White, 2
    LevelText$ = "You are the pilot of a new, heavily armed, heavily armored, high speed, prototype jet.  However, while on a test mission, an Enemy Force invades, launching strategic missiles at all the local air bases.  You alone are the only capable force within 1000 miles who can fight them off before they succeed in their invasion."
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
    LINE (10, 10)-(390, 40), Black, BF
    Font "LEVEL 1", 175, 15, White, 2
    LINE (50, 50)-(350, 250), Black, BF
    LevelText$ = "The Invading Force has discovered your whereabouts and has dispatched fighters to destroy you.  Engage and defeat the enemy fighters."
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 2
    Font "LEVEL 2", 175, 15, White, 2
    LevelText$ = "The invading force underestimated your fighting capabilities, but it is a mistake they do not plan on making again.  Along with a multitude of more fighters, they've sent an attack force of assault missile gunboats.  Defeat them!"
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 3
    Font "LEVEL 3", 175, 15, White, 2
    LevelText$ = "Several Enemy supply depots have been discovered on radar.  Apparantly, they had been set up some time ago in anticipation of this invasion and are heavily guarded by SAM launchers.  Find the supply depots and destroy them."
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 4
    Font "LEVEL 4", 175, 15, White, 2
    LevelText$ = "A mobile satellite plane was able to sneak in behind you while you were destroying the supply depots and has managed to attain top secret information.  It is now escaping amidst a swarm of enemy fighters.  Its thrusters are slow, but its top speed is unmatched.  Find it and destroy it before it reaches max speed and escapes!"
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 5
    Font "LEVEL 5", 175, 15, White, 2
    LevelText$ = "You've fallen into a trap!  The Enemy Force set up a tractor beam and was able to pull you in.  Fortunately, you were able to jettison in time and escape, but they have your plane hostage.  In the mean time, you've managed to steal a tank.  Make your way back to their base and recover your plane."
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 6
    Font "LEVEL 6", 175, 15, White, 2
    LevelText$ = "You've rescued your fighter and got in the air just in time!  A Friendly air base managed to assemble some fighters, but they need time to get off the ground.  Protect the air base for 8 minutes from enemy fighters."
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 7
    Font "LEVEL 7", 175, 15, White, 2
    LevelText$ = "Although you've been outfitted for protection from tractor beams, the Enemy Force was able to procure details on your jet during its capture.  As such, they've developed an experimental fighter of their own and have dispatched them to destroy you.  Engage and destroy their new fighters."
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 8
    Font "LEVEL 8", 175, 15, White, 2
    LevelText$ = "The experimental fighters were a decoy!  A massive attack force has been assembled and is headed your way."
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 9
    Font "LEVEL 9", 175, 15, White, 2
    LevelText$ = "The Titan, a massive strategic bomber, is headed north to one of your outposts.  Engage it and destroy it before it reaches its destination and drops its explosives."
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 10
    Font "LEVEL 10", 173, 15, White, 2
    LevelText$ = "Your forces need your help!  While in route to assault an enemy outpost, they're being attacked by invisible flak cannons.  Find and destroy the field generators that render the cannons invisible and then destroy the flak cannons and escort your forces safely across.  125 of your forces must survive."
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 11
    Font "LEVEL 11", 173, 15, White, 2
    LevelText$ = "As your forces are fighting on the front, several mobile air carriers have moved in from the rear and flanked them.  Engage the mobile carriers and take them down."
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 12
    Font "LEVEL 12", 173, 15, White, 2
    LevelText$ = "The Final Assault!  The Enemy Force's mobile headquarters is all that remains.  Engage it and destroy it!  Be warned, it won't go down easy."
    FontBox LevelText$, 50, 50, 350, 250, 10, 1
    SLEEP
  CASE 13
    LevelText$ = "You've done it!  The Enemy Force has been defeated!  You are owed a great debt of gratitude for your bravery and skillful flying!"

    Congrats = _NEWIMAGE(400, 300)
    Congrats2 = _NEWIMAGE(400, 300)

    _DEST Congrats1
    _CLEARCOLOR _RGB32(0, 0, 0)
    _DEST Congrats2
    _CLEARCOLOR _RGB32(0, 0, 0)

    _DEST Congrats
    _PRINTSTRING (0, 0), "You are an"
    _PRINTSTRING (0, 20), "AIR ACE!"

    _PUTIMAGE (100, 50)-(300, 80), Congrats, Congrats2, (0, 0)-(80, 13)
    _PUTIMAGE (10, 100)-(390, 250), Congrats, Congrats2, (0, 20)-(61, 33)

    _DEST Layer

    DIM Corner(4, 2)
    '1 = X
    '2 = Y

    A = -45
    CLS


    Font "Congratulations!", 135, 15, Red, 2
    FontBox LevelText$, 30, 50, 370, 250, 10, 1
    SLEEP

    DO
      CLS

      Font "Congratulations!", 135, 15, Red, 2
      FontBox LevelText$, 30, 50, 370, 250, 10, 0


      A = A + 8
      D = D + 4
      C = C + 1

      FOR i = 1 TO 4
        Corner(i, 1) = 200 + COS((A + (i - 2) * 90) / Rad) * D
        Corner(i, 2) = 150 + SIN((A + (i - 2) * 90) / Rad) * D
      NEXT

      _MAPTRIANGLE (0, 0)-(400, 0)-(400, 300), Congrats2 TO(Corner(1, 1), Corner(1, 2))-(Corner(2, 1), Corner(2, 2))-(Corner(3, 1), Corner(3, 2)), Layer
      _MAPTRIANGLE (0, 0)-(400, 300)-(0, 300), Congrats2 TO(Corner(1, 1), Corner(1, 2))-(Corner(3, 1), Corner(3, 2))-(Corner(4, 1), Corner(4, 2)), Layer

      ShowScreen
    LOOP UNTIL C > 40
    _DEST 0

    Seconds = (GameTime / 30) MOD 60
    Minutes = (GameTime / 1800) MOD 60
    Hours = INT(GameTime / 108000)

    _PRINTSTRING (450, 500), "You dealt: " + STR$(DamageDone) + " damage."
    _PRINTSTRING (450, 530), "Completion Time: " + STR$(Hours) + "H " + STR$(Minutes) + "M " + STR$(Seconds) + "S"
    DO
      Press = _KEYHIT
    LOOP UNTIL Press <> 0

    Ang = 5
    DO

      IF Which < 1 THEN: Which = 1
      IF Which > 12 THEN: Which = 12
      IF Ang < 1 THEN: Ang = 8
      IF Ang > 8 THEN: Ang = 1

      SELECT CASE Which
        CASE 1
          E = 1
        CASE 2
          E = 2
        CASE 3
          E = 3
        CASE 4
          E = 8
        CASE 5
          E = 4
        CASE 6
          E = 9
        CASE 7
          E = 6
        CASE 8
          E = 10
        CASE 9
          E = 13
        CASE 10
          E = 7
        CASE 11
          E = 15
        CASE 12
          E = 16
      END SELECT
      _DEST Layer


      FOR p = 1 TO PicCount
        IF UCASE$(RTRIM$(EnemyStat(E).FileName)) = UCASE$(RTRIM$(PicInfo(p).Name)) THEN
          Pic = p
        END IF
      NEXT

      CLS
      _LIMIT 30

      Font EnemyStat(E).Name, 10, 10, White, 2
      Font "Speed        : " + STR$(INT(EnemyStat(E).MaxSpeed * 100) / 100), 10, 30, White, 2
      Font "Acceleration : " + STR$(INT(EnemyStat(E).Thrust * 100) / 100), 10, 45, White, 2
      Font "Turn Rate    : " + STR$(INT(EnemyStat(E).Turn * 100) / 100), 10, 60, White, 2
      Font "Armor        : " + STR$(EnemyStat(E).Armor), 10, 75, White, 2
      Font "Credits      : " + STR$(EnemyStat(E).Scrap * 10), 10, 90, White, 2
      Font "Size         : " + STR$(EnemyStat(E).Size), 10, 105, White, 2

      FOR B = 1 TO 5
        LINE (120 - B, 150 - B)-(270 + B, 250 + B), _RGB32(50 + B * 25, 0, 0), B
      NEXT

      Font "Left / Right    Rotate", 130, 265, White, 1
      Font "Up   /  Down    Change Enemy", 130, 275, White, 1
      Font "ESC             End Game", 130, 290, White, 1

      _PUTIMAGE (120, 150), Pic(Pic, Ang)

      ShowScreen
      Press = _KEYHIT
      SELECT CASE Press
        CASE 27: SYSTEM
        CASE 256 * 72: Which = Which + 1
        CASE 256 * 75: Ang = Ang - 1
        CASE 256 * 77: Ang = Ang + 1
        CASE 256 * 80: Which = Which - 1
      END SELECT


    LOOP



    SYSTEM



END SELECT
END SUB

SUB Load (Done)

DIM WhichLev AS _BYTE
DIM Money AS LONG
DIM PlayTime AS SINGLE

Trans = 255
LClick = 1
_DEST Layer
DO
  _LIMIT 30
  CLS
  FOR i = 1 TO 10
    LINE (10 + i, 10 + i)-(389 - i, 289 - i), _RGB32(15 * i + 50, 15 * i + 50, 15 * i + 50), B
  NEXT
  FOR S = 1 TO 5
    FOR i = 1 TO 5
      IF S = Sel THEN
        LINE (30 + i, i + 45 * S)-(369 - i, 40 + 45 * S - i), _RGB32(15 * i + 50, 0, 0), B
      ELSE
        LINE (30 + i, i + 45 * S)-(369 - i, 40 + 45 * S - i), _RGB32(15 * i + 50, 15 * i + 50, 15 * i + 50), B
      END IF
    NEXT
  NEXT

  Font "Load", 184, 30, White, 2
  Mouse


  SELECT CASE MouseX
    CASE 72 TO 727
      SELECT CASE MouseY
        CASE 92 TO 170: Sel = 1
        CASE 182 TO 260: Sel = 2
        CASE 272 TO 350: Sel = 3
        CASE 362 TO 440: Sel = 4
        CASE 452 TO 530: Sel = 5
      END SELECT
  END SELECT

  FOR i = 1 TO 5
    File$ = SaveDir + "save" + LTRIM$(STR$(i)) + ".sav"
    IF _FILEEXISTS(File$) THEN
      OPEN File$ FOR BINARY AS #1
      GET #1, , CurDate$
      GET #1, , WhichLev
      GET #1, , Money
      GET #1, , PlayTime
      CLOSE #1

      Seconds = (PlayTime / 30) MOD 60
      Minutes = (PlayTime / 1800) MOD 60
      Hours = INT(PlayTime / 108000)

      Font "Level     : " + STR$(WhichLev), 55, i * 45 + 12, White, 1
      Font CurDate$, 205, i * 45 + 12, White, 1
      Font "Credits   : " + STR$(Money), 55, i * 45 + 22, White, 1
      Font "Game Time : " + STR$(Hours) + "h" + STR$(Minutes) + "m" + STR$(Seconds) + "s", 205, i * 45 + 22, White, 1

    ELSE
      Font "EMPTY", 55, i * 45 + 15, White, 2
    END IF
  NEXT

  LoadFile = 0
  IF MouseLB THEN
    IF LClick = 0 THEN
      LoadFile = 1
    END IF
  ELSE
    LClick = 0
  END IF


  Press = _KEYHIT
  SELECT CASE Press
    CASE 256 * 72: Sel = Sel - 1
    CASE 256 * 80: Sel = Sel + 1
    CASE 32: LoadFile = 1: Done = 1
    CASE 27: Done = 2
  END SELECT
  IF Sel < 1 THEN: Sel = 1
  IF Sel > 5 THEN: Sel = 5

  IF Trans > 0 THEN
    Trans = Trans - 5
    LINE (0, 0)-(799, 599), _RGBA(0, 0, 0, Trans), BF
  END IF

  DrawMouse 1

  ShowScreen

  CurDate$ = DATE$

  IF LoadFile = 1 THEN
    File$ = SaveDir + "save" + LTRIM$(STR$(Sel)) + ".sav"
    IF _FILEEXISTS(File$) THEN
      Done = 1
      OPEN SaveDir + "save" + LTRIM$(STR$(Sel)) + ".sav" FOR BINARY AS #1
      GET #1, , CurDate$
      GET #1, , CurLev
      GET #1, , Player.Money
      GET #1, , GameTime
      GET #1, , DamageDone
      GET #1, , Player
      GET #1, , PlayWep()
      GET #1, , Invert()
      CLOSE #1
      MissionPoint = 0
    ELSE
      LoadFile = 0
      Done = 0
    END IF
  END IF

LOOP UNTIL Done > 0

END SUB

SUB MakeBG

FOR i = 1 TO NumBG
  DO
    Done = 1
    BackGround(i).Use = 1
    BackGround(i).Alt = 0
    BackGround(i).X = (RND * Level(CurLev).Width - (Level(CurLev).Width / 2)) * 10
    BackGround(i).Y = (RND * Level(CurLev).Height - (Level(CurLev).Height / 2)) * 10
    IF CurLev = 6 THEN
      IF Distance(BackGround(i).X, BackGround(i).Y, 0, 0) < 1000 THEN: Done = 0
    END IF
  LOOP UNTIL Done = 1
  BGType = INT(RND * 10 + 1)
  SELECT CASE BGType
    CASE 1 TO 6
      BackGround(i).Style = 0 'Pyramid
      'CASE 5 TO 6
      ' BackGround(i).Style = 1 'Building
    CASE 7 TO 10
      BackGround(i).Style = 2 'Cloud
      BackGround(i).Alt = INT(10000 * RND) + 3000
      BackGround(i).Type = INT(10 * RND + 1)
  END SELECT
NEXT

END SUB

SUB MakeColors

FOR i = 1 TO 12

  SELECT CASE i
    CASE 1, 12
      _DEST Sky(i)
      FOR y = 299 TO 0 STEP -1
        SELECT CASE y
          CASE 0 TO 99
            Col& = _RGB32((y / 99) * 255, (y / 99) * 255, 255)
          CASE 100 TO 199
            Col& = _RGB32(255, 255, ((199 - y) / 99) * 255)
          CASE 200 TO 299
            Col& = _RGB32(255, ((299 - y) / 99) * 255, 0)
        END SELECT
        LINE (0, y)-(399, y), Col&
      NEXT

      _DEST Ground(i)
      FOR y = 0 TO 299
        Col% = (y / 299) * 255
        LINE (0, y)-(399, y), _RGB32(0, Col%, 0)
      NEXT
    CASE 2
      _DEST Sky(i)
      FOR y = 299 TO 0 STEP -1
        SELECT CASE y
          CASE 0 TO 199
            Col& = _RGB32((y / 199) * 255, (y / 199) * 255, 255)
          CASE 200 TO 299
            Col& = _RGB32(255, 255, ((299 - y) / 99) * 255)
        END SELECT
        LINE (0, y)-(399, y), Col&
      NEXT

      _DEST Ground(i)
      FOR y = 0 TO 299
        Col% = (y / 299) * 150 + 100
        LINE (0, y)-(399, y), _RGB32(0, Col%, 0)
      NEXT
    CASE 3, 11
      _DEST Sky(i)
      FOR y = 299 TO 0 STEP -1
        SELECT CASE y
          CASE 0 TO 259
            Col& = _RGB32((y / 259) * 255, (y / 259) * 255, 255)
          CASE 260 TO 299
            Col& = _RGB32(255, 255, ((299 - y) / 39) * 255)
        END SELECT
        LINE (0, y)-(399, y), Col&
      NEXT

      _DEST Ground(i)
      FOR y = 0 TO 299
        Col% = (y / 299) * 150 + 100
        LINE (0, y)-(399, y), _RGB32(255, Col%, 0)
      NEXT
    CASE 4
      _DEST Sky(i)
      FOR y = 0 TO 299
        SELECT CASE y
          CASE 0 TO 149
            Col& = _RGB32((y / 149) * 255, 0, 0)
          CASE 150 TO 299
            Col& = _RGB32(255, ((y - 150) / 50) * 255, 0)
        END SELECT
        LINE (0, y)-(399, y), Col&
      NEXT

      _DEST Ground(i)
      FOR y = 0 TO 299
        Col% = (y / 299) * 150 + 100
        LINE (0, y)-(399, y), _RGB32(255, Col%, 0)
      NEXT
    CASE 5
      _DEST Sky(i)
      FOR y = 0 TO 299
        Col& = _RGB32(255, ((299 - y) / 299) * 255, 0)

        LINE (0, y)-(399, y), Col&
      NEXT

      _DEST Ground(i)
      FOR y = 0 TO 299
        Col% = (y / 299) * 150 + 100
        LINE (0, y)-(399, y), _RGB32(0, Col%, 0)
      NEXT
    CASE 6
      _DEST Sky(i)
      FOR y = 0 TO 299
        Col& = _RGB32(0, 0, ((299 - y) / 299) * 255)
        LINE (0, y)-(399, y), Col&
      NEXT

      _DEST Ground(i)
      FOR y = 0 TO 299
        Col% = (y / 299) * 150 + 100
        LINE (0, y)-(399, y), _RGB32(0, Col%, 0)
      NEXT
    CASE 7
      _DEST Sky(i)
      FOR y = 0 TO 299
        Col& = _RGB32(0, 0, (y / 299) * 150 + 100)
        LINE (0, y)-(399, y), Col&
      NEXT

      _DEST Ground(i)
      FOR y = 0 TO 299
        Col% = (y / 299) * 200 + 50
        LINE (0, y)-(399, y), _RGB32(0, Col%, 0)
      NEXT
    CASE 8
      _DEST Sky(i)
      FOR y = 299 TO 0 STEP -1
        SELECT CASE y
          CASE 0 TO 99
            Col& = _RGB32((y / 99) * 255, (y / 99) * 255, 255)
          CASE 100 TO 199
            Col& = _RGB32(255, 255, ((199 - y) / 99) * 255)
          CASE 200 TO 299
            Col& = _RGB32(255, ((299 - y) / 99) * 255, 0)
        END SELECT
        LINE (0, y)-(399, y), Col&
      NEXT

      _DEST Ground(i)
      FOR y = 0 TO 299
        Col& = _RGB32(0, 0, (y / 299) * 150 + 50)
        LINE (0, y)-(399, y), Col&
      NEXT
    CASE 9
      _DEST Sky(i)
      FOR y = 299 TO 0 STEP -1
        SELECT CASE y
          CASE 0 TO 259
            Col& = _RGB32((y / 259) * 255, (y / 259) * 255, 255)
          CASE 260 TO 299
            Col& = _RGB32(255, 255, ((299 - y) / 39) * 255)
        END SELECT
        LINE (0, y)-(399, y), Col&
      NEXT

      _DEST Ground(i)
      FOR y = 0 TO 299
        Col% = (y / 299) * 200 + 50
        LINE (0, y)-(399, y), _RGB32(0, Col%, 0)
      NEXT
    CASE 10
      _DEST Sky(i)
      FOR y = 0 TO 299
        SELECT CASE y
          CASE 0 TO 149
            Col& = _RGB32((y / 149) * 255, 0, 0)
          CASE 150 TO 299
            Col& = _RGB32(255, ((y - 150) / 50) * 255, 0)
        END SELECT
        LINE (0, y)-(399, y), Col&
      NEXT

      _DEST Ground(i)
      FOR y = 0 TO 299
        Col% = (y / 299) * 200 + 0
        LINE (0, y)-(399, y), _RGB32(0, Col%, 0)
      NEXT


  END SELECT

NEXT


BombPic = _NEWIMAGE(100, 100)
_DEST BombPic
MaxDist = 0
FOR X = 0 TO 100
  FOR y = 0 TO 100
    IF Distance(X, y, 50, 50) < 50 THEN
      IF Distance(X, y, 75, 25) > MaxDist THEN: MaxDist = Distance(X, y, 75, 25)
    END IF
  NEXT
NEXT

FOR X = 0 TO 100
  FOR y = 0 TO 100
    Col = 30 - (30 * (Distance(X, y, 75, 25) / MaxDist))
    G = 180 - ((Distance(X, y, 75, 25) / MaxDist) * 180)
    IF Distance(X, y, 50, 50) < 50 THEN: PSET (X, y), _RGB32(G, G, G)
  NEXT
NEXT
_CLEARCOLOR _RGB32(0, 0, 0)


END SUB


SUB MakeFonts

IF _FILEEXISTS(DataDir + "font.fnt") THEN
  OPEN DataDir + "font.fnt" FOR INPUT AS #1
  FOR I = 1 TO 94
    INPUT #1, Name$
    Info% = ASC(Name$)
    FOR Y = 1 TO 5
      INPUT #1, Info$
      FOR X = 1 TO 5
        Fonts(Info%, X, Y) = VAL(MID$(Info$, X, 1))
      NEXT
    NEXT
  NEXT
  CLOSE #1
ELSE
  _DEST 0
  CLS
  PRINT "Incorrect Directory.  Be sure the directory destination is correct."
  SLEEP
  SYSTEM
END IF
IF _FILEEXISTS(DataDir + "fontbig.fnt") THEN
  OPEN DataDir + "fontbig.fnt" FOR INPUT AS #1
  FOR I = 1 TO 94
    INPUT #1, Name$
    Info% = ASC(Name$)
    FOR Y = 1 TO 8
      INPUT #1, Info$
      FOR X = 1 TO 7
        BigFonts(Info%, X, Y) = VAL(MID$(Info$, X, 1))
      NEXT
    NEXT
  NEXT
  CLOSE #1
END IF

END SUB

SUB MakeSounds

Sounds(1) = _SNDOPEN(SoundDir + "death.wav", "VOL, SYNC")
Sounds(2) = _SNDOPEN(SoundDir + "hit.wav", "VOL, SYNC")
Sounds(3) = _SNDOPEN(SoundDir + "laser.wav", "VOL, SYNC")
Sounds(4) = _SNDOPEN(SoundDir + "mine.wav", "VOL, SYNC")
Sounds(5) = _SNDOPEN(SoundDir + "nuke.wav", "VOL, SYNC")
Sounds(7) = _SNDOPEN(SoundDir + "rocket.wav", "VOL, SYNC")
Sounds(8) = _SNDOPEN(SoundDir + "shoot1.wav", "VOL, SYNC")
Sounds(9) = _SNDOPEN(SoundDir + "shoot2.wav", "VOL, SYNC")
Sounds(10) = _SNDOPEN(SoundDir + "shoot3.wav", "VOL, SYNC")
END SUB


SUB MakeTypes

TYPE BGInfo
  X AS INTEGER
  Y AS INTEGER
  Alt AS LONG
  Style AS _BYTE
  ScreenX AS INTEGER
  ScreenY AS INTEGER
  Dist AS LONG
  Ang AS SINGLE
  Use AS _BYTE
  Type AS _BYTE
END TYPE


TYPE EnemyInfo
  X AS SINGLE '                 X Coordinate
  Y AS SINGLE '                 Y Coordinate
  Type AS INTEGER '             Type of Enemy
  Alt AS SINGLE '               Current Altitude
  MaxSpeed AS SINGLE '          Maximum Speed
  Speed AS SINGLE '             Current Speed
  Dir AS SINGLE '               Direction (Angle) from Player
  GoX AS LONG '                 Destination X Coordinate
  GoY AS LONG '                 Destination Y Coordinate
  GoAlt AS LONG '               Destination Altitude
  TargetAngle AS SINGLE '       Angle to Enemy's Target
  Armor AS LONG '               Armor (Hit Points)
  OldArmor AS LONG '            Previous Armor (If changes, they're hit)
  Status AS INTEGER '           0 = Alive      > 0 = Exploding
  Engage AS INTEGER '           Distance Enemy Engages Player
  ScreenX AS INTEGER '          X Position on Screen
  ScreenY AS INTEGER '          Y Position on Screen
  Dist AS LONG '                Distance from Player
  Ang AS SINGLE '               Angle Traveling
  Thrust AS SINGLE '            Thrust of Enemy  (Acceleration)
  Turn AS SINGLE '              Turning Ability
  TargetDist AS LONG '          Distance from Enemy to its Target
  TurnRadius AS SINGLE '        Tightest Circle the Enemy can Fly
  Pic AS INTEGER '              Which Picture the Enemy Uses
  Name AS STRING * 16 '         Name of Enemy
  Ground AS _BYTE '             Can it Fly?  (1 = No  0 = Yes)
  Size AS INTEGER '             How Large is the Enemy
  Frame AS _BYTE '              Which frame the enemy uses.
  Tilt AS SINGLE '              Altitude increase/decrease
  Hit AS _BYTE '                Display Damage Flash (1 = Yes  0 = No)
  Scrap AS LONG '               How Much Scrap Is It Worth?
  Use AS _BYTE '                Is the enemy currently in use?  (1 = Yes  0 = No)
  Friendly AS _BYTE '           Is it on your side?  (1 = Yes   0 = No)
  Origin AS INTEGER '           Used for Carriers.  Which one they came from.
END TYPE


TYPE EnemyStart
  X AS LONG
  Y AS LONG
  Which AS INTEGER ' Which object/enemy, etc.
  Type AS INTEGER '  Type of object.  Enemy, Building.
  Use AS _BYTE
END TYPE

TYPE EnemyStats
  MaxSpeed AS SINGLE '
  Armor AS LONG '
  Thrust AS SINGLE '
  Turn AS SINGLE '
  FileName AS STRING * 16 '
  Name AS STRING * 16 '
  Engage AS LONG '           How far away from the player the enemy will engage
  Ground AS _BYTE '          Is it confined to the ground?  '1 = yes (tank) '0 = no (jet)
  Scrap AS LONG '            How Much Is Its Destruction Worth?
  Size AS INTEGER '          How big is it?
END TYPE


TYPE Level
  Width AS LONG
  Height AS LONG
  Sky AS INTEGER
  Ground AS INTEGER
  StartX AS LONG
  StartY AS LONG
END TYPE

TYPE ObjectList
  Type AS _BYTE '                 1 = Enemy     2 = BackGround
  Which AS INTEGER '              Enemy/BG Pointer
  Dist AS SINGLE '                Distance
  Use AS _BYTE '                  Anything in the slot?
END TYPE

TYPE PicInfo
  Name AS STRING * 16
  Num AS INTEGER
  Type AS _BYTE
END TYPE


TYPE Player
  Ang AS SINGLE
  Alt AS SINGLE
  Speed AS SINGLE
  TargetSpeed AS SINGLE
  X AS SINGLE
  Y AS SINGLE
  Target AS INTEGER
  CurWep AS _BYTE
  Armor AS LONG
  Drop AS SINGLE
  Thrust AS SINGLE
  WepLock AS _BYTE
  Heat AS SINGLE
  Money AS LONG
  Laser AS _BYTE
END TYPE

TYPE PlayWep
  Name AS STRING * 16
  Refire AS LONG
  BulletTimer AS LONG
  Ammo AS LONG
  MaxAmmo AS LONG
  Power AS LONG
  Speed AS SINGLE
  Radius AS SINGLE
  Range AS LONG
  Tilt AS SINGLE
END TYPE




TYPE ScreenInfo
  X AS SINGLE
  Y AS SINGLE
  Col AS LONG
  Angle AS SINGLE
  Dist AS SINGLE
END TYPE

TYPE Text
  CurX AS SINGLE
  CurY AS SINGLE
  OrigX AS INTEGER
  OrigY AS INTEGER
  Ang AS SINGLE
  Speed AS SINGLE
  Turn AS SINGLE
  Col AS LONG
END TYPE


TYPE Weapon
  X AS SINGLE '         X Coord
  Y AS SINGLE '         Y Coord
  Alt AS SINGLE '       Altitude
  Ang AS SINGLE '       Angle
  Speed AS SINGLE '     Speed
  MaxSpeed AS SINGLE '  Maximum Speed
  Tilt AS SINGLE '      Tilt
  Type AS _BYTE '       Type of Weapon
  Use AS _BYTE '        1 = Active
  Var AS LONG '         Variable for any use
  Who AS _BYTE '        Who Fired it
  Power AS LONG '       Damage done by weapon
  Range AS LONG '       How far it can travel
  Radius AS LONG '      Explosion size
  Dist AS SINGLE '      Distance of weapon from player
  Target AS INTEGER '   Number of Target  -1 = Player
  Shooter AS LONG '     Who Shot it?      -1 = Player
  StartX AS SINGLE '    Starting X Coord
  StartY AS SINGLE '    Starting Y Coord
  StartAlt AS SINGLE '  Starting Altitude
  OldX AS SINGLE '      Previous X Coord
  OldY AS SINGLE '      Previous Y Coord
  OldAlt AS SINGLE '    Previous Altitude
  Pic AS INTEGER '      Which Picture
END TYPE



TYPE Weaponstats
  WeaponType AS INTEGER
  '1  Bullet
  '2  Missile
  '3  Laser
  '4  Heat Seek
  '5  Flak  (Area Damage)

  Damage AS SINGLE
  Speed AS SINGLE
  Ammo AS LONG
  Refire AS LONG
  Range AS LONG '   How close the weapon needs to be
  Ang AS SINGLE '   How close the angle needs to be

  Use AS _BYTE
END TYPE



END SUB

SUB MakeWeapons

PlayWep(1).Name = "Bomb"
PlayWep(1).Refire = 100
PlayWep(1).Speed = 3500
PlayWep(1).Radius = 5000
PlayWep(1).Range = 85
PlayWep(1).Power = 250
PlayWep(1).MaxAmmo = 20
PlayWep(1).Tilt = 8.5

PlayWep(2).Name = "Vulcan"
PlayWep(2).Refire = 0
PlayWep(2).Speed = 20000
PlayWep(2).Radius = 20
PlayWep(2).Range = 1000
PlayWep(2).Power = 75
PlayWep(2).MaxAmmo = 1000
PlayWep(2).Tilt = 1.3

PlayWep(3).Name = "Nuke"
PlayWep(3).Refire = 150
PlayWep(3).Speed = 3500
PlayWep(3).Radius = 15000
PlayWep(3).Range = 200
PlayWep(3).Power = 550
PlayWep(3).MaxAmmo = 5
PlayWep(3).Tilt = 8.5

PlayWep(4).Name = "Rocket"
PlayWep(4).Refire = 25
PlayWep(4).Speed = 7500
PlayWep(4).Radius = 100
PlayWep(4).Range = 1000
PlayWep(4).Power = 750
PlayWep(4).MaxAmmo = 50
PlayWep(4).Tilt = 3.75

PlayWep(5).Name = "Missile"
PlayWep(5).Refire = 15
PlayWep(5).Speed = 4000
PlayWep(5).Radius = 100
PlayWep(5).Range = 2000
PlayWep(5).Power = 250
PlayWep(5).MaxAmmo = 150
PlayWep(5).Tilt = 6.5

PlayWep(6).Name = "Laser"
PlayWep(6).Refire = 20
PlayWep(6).Speed = 6000
PlayWep(6).Radius = 50
PlayWep(6).Range = 1000
PlayWep(6).Power = 750
PlayWep(6).MaxAmmo = 0
PlayWep(6).Tilt = 4.25

PlayWep(7).Name = "Back Flash"
PlayWep(7).Refire = 35
PlayWep(7).Speed = 0
PlayWep(7).Radius = 0
PlayWep(7).Range = 2000
PlayWep(7).Power = 750
PlayWep(7).MaxAmmo = 30
PlayWep(7).Tilt = 0

PlayWep(8).Name = "Magnum"
PlayWep(8).Refire = 25
PlayWep(8).Speed = 20000
PlayWep(8).Radius = 150
PlayWep(8).Range = 350
PlayWep(8).Power = 1000
PlayWep(8).MaxAmmo = 150
PlayWep(8).Tilt = 1.3


MaxWep = 8

FOR i = 1 TO MaxWep
  PlayWep(i).BulletTimer = PlayWep(i).Refire
  'PlayWep(i).Ammo = PlayWep(i).MaxAmmo
NEXT


END SUB

SUB MeltRoutine


DIM Temp(400, 300) AS ScreenInfo

_SOURCE Layer

FOR X = 0 TO 399
  FOR Y = 0 TO 299
    PixAngle = Angle(200, 150, X, Y)
    PixDist = Distance(200, 150, X, Y)
    Col = POINT(X, Y)
    Temp(X, Y).X = X
    Temp(X, Y).Y = Y
    Temp(X, Y).Col = Col
    Temp(X, Y).Angle = PixAngle
    Temp(X, Y).Dist = PixDist
  NEXT
NEXT

DO

  CLS
  GreatDist = 0
  Rate = Rate + .001
  FOR X = 0 TO 399
    FOR Y = 0 TO 299
      Temp(X, Y).X = 200 + COS(Temp(X, Y).Angle / Rad) * Temp(X, Y).Dist
      Temp(X, Y).Y = 150 + SIN(Temp(X, Y).Angle / Rad) * Temp(X, Y).Dist
      PSET (Temp(X, Y).X, Temp(X, Y).Y), Temp(X, Y).Col
      Temp(X, Y).Angle = Temp(X, Y).Angle + Temp(X, Y).Dist / (20 - Rate * 200)
      Temp(X, Y).Dist = Temp(X, Y).Dist * (1 - Rate)
      IF Temp(X, Y).Dist < 1 THEN: Temp(X, Y).Dist = 0
      IF GreatDist < Temp(X, Y).Dist THEN: GreatDist = Temp(X, Y).Dist
    NEXT
  NEXT
  ShowScreen
LOOP UNTIL GreatDist = 0
_DEST DisplayScreen
CLS


END SUB

SUB MidScreen

DIM DB AS INTEGER, Button AS INTEGER

IF _FILEEXISTS(PicDir + "jets.png") THEN
  BG = _LOADIMAGE(PicDir + "jets.png")
ELSE
  PRINT "File jets.png missing or not found."
  END
END IF

IF _FILEEXISTS(PicDir + "button.jpg") THEN
  Button = _LOADIMAGE(PicDir + "button.jpg")
ELSE
  PRINT "File button.jpg missing or not found."
  END
END IF

_DEST Layer

DO
  CLS

  Click = 0

  LINE (10, 10)-(390, 290), Gray, BF
  _PUTIMAGE (20, 20)-(379, 279), BG, Layer

  IF MouseLB THEN
    SELECT CASE MouseY
      CASE 460 TO 510
        SELECT CASE MouseX
          CASE 60 TO 290: Click = 1
          CASE 340 TO 440: Save
          CASE 540 TO 710: IF CurLev <> 5 THEN: Shop
        END SELECT
    END SELECT
  END IF


  _PUTIMAGE (30, 230)-(145, 255), Button, Layer
  _PUTIMAGE (170, 230)-(220, 255), Button, Layer
  IF CurLev <> 5 THEN: _PUTIMAGE (270, 230)-(355, 255), Button, Layer

  Mouse

  Font "NEXT MISSION", 40, 240, White, 2
  Font "SAVE", 180, 240, White, 2
  IF CurLev <> 5 THEN: Font "JET SHOP", 280, 240, White, 2

  DrawMouse 1

  ShowScreen
LOOP UNTIL Click = 1

END SUB



SUB Mission

GameOverCheck

SELECT CASE MissionPoint
  CASE 0
    Intro
    IF CurLev > 1 THEN: MidScreen
    MissionTimer = TIMER
    NumEnemy = 0
    FOR i = 1 TO 5000
      Enemy(i).Use = 0
      Enemy(i).Friendly = 0
      Enemy(i).Status = 0
    NEXT
    FOR i = 1 TO NumWeapon
      Weapon(i).Use = 0
    NEXT
    Player.Heat = 0
    AutoPilot = 0
    MissionPoint = 1
    FOR i = 1 TO 5000
      Enemy(i).Status = 0
      IF EnemyStart(CurLev, i).Use = 1 THEN
        GOSUB MakeEnemies
      END IF
    NEXT
    SELECT CASE CurLev
      CASE 5
        Player.Armor = 10000
      CASE 6
        LevelTimer = 0
        FOR i = 1 TO NumEnemy
          IF Enemy(i).Type = 11 THEN: Enemy(i).Friendly = 1
        NEXT
        FOR x = 0 TO 10
          FOR y = 0 TO 50
            Grid(x, y, 1) = x * 10
            Grid(x, y, 2) = y * 10
          NEXT
        NEXT
      CASE 9
        FOR i = 1 TO NumEnemy
          IF Enemy(i).Type = 11 THEN: Enemy(i).Friendly = 1
        NEXT
    END SELECT
    MakeBG
    Player.Alt = 1000
    Player.Speed = 100
    Player.TargetSpeed = 1000
    Player.Thrust = 10
    Player.X = Level(CurLev).StartX * 10
    Player.Y = Level(CurLev).StartY * 10
    Player.Ang = Angle(Player.X, Player.Y, 0, 0)
    _MOUSEMOVE 400, 300
  CASE 1
    SELECT CASE CurLev
      CASE 1, 2, 7, 8
        IF EnemyTotal = 0 THEN
          FOR i = 1 TO NumWeapon
            Weapon(i).Use = 0
          NEXT
          CurLev = CurLev + 1
          MeltRoutine
          MissionPoint = 0
        END IF
      CASE 3
        Done = 1
        FOR i = 1 TO NumEnemy
          IF Enemy(i).Type = 5 THEN
            IF Enemy(i).Armor > 0 THEN: Done = 0
          END IF
        NEXT
        IF Done = 1 THEN
          CurLev = 4
          MeltRoutine
          MissionPoint = 0
        END IF
      CASE 4
        Done = 1
        FOR i = 1 TO NumEnemy
          IF Enemy(i).Type = 9 THEN
            IF Enemy(i).Status < 30 THEN: Done = 0
            IF Enemy(i).Speed >= Enemy(i).MaxSpeed THEN: MissionPoint = 2
          END IF
        NEXT
        IF Done = 1 THEN
          CurLev = 5
          MeltRoutine
          MissionPoint = 0
        END IF
      CASE 5
        Done = 1
        FOR i = 1 TO NumEnemy
          IF Enemy(i).Type = 5 THEN
            IF Enemy(i).Status < 30 THEN: Done = 0
          END IF
        NEXT
        IF Done = 1 THEN
          CurLev = 6
          MeltRoutine
          MissionPoint = 0
          Player.Armor = 10000
        END IF
      CASE 6
        LevelTimer = LevelTimer + 1
        NewJet = RND * 500
        IF NewJet > 490 THEN
          NumEnemy = NumEnemy + 1
          FOR i = 1 TO 5000
            IF Enemy(i).Use = 0 THEN
              Enemy(i).Use = 1
              Enemy(i).Status = 0
              EnemyType = INT(RND * 10)
              IF EnemyType = 5 THEN
                Enemy(i).Type = 1
              ELSE
                Enemy(i).Type = 10
              END IF
              NewAng = RND * 360
              NewDist = ((RND * Level(CurLev).Width) / 2 + (Level(CurLev).Width / 2)) * 5

              Enemy(i).X = COS(NewAng / Rad) * NewDist
              Enemy(i).Y = SIN(NewAng / Rad) * NewDist

              Enemy(i).GoX = 0
              Enemy(i).GoY = 0
              Enemy(i).Alt = 2000 * RND + 1000
              Enemy(i).Scrap = EnemyStat(Enemy(i).Type).Scrap * 10

              Enemy(i).Name = EnemyStat(Enemy(i).Type).Name
              Enemy(i).Ground = EnemyStat(Enemy(i).Type).Ground
              Enemy(i).Size = EnemyStat(Enemy(i).Type).Size
              Enemy(i).MaxSpeed = EnemyStat(Enemy(i).Type).MaxSpeed
              Enemy(i).Thrust = EnemyStat(Enemy(i).Type).Thrust
              Enemy(i).Armor = EnemyStat(Enemy(i).Type).Armor
              Enemy(i).Status = 0 '   status      (0 = Ok    Other = destroyed)
              Enemy(i).Turn = EnemyStat(Enemy(i).Type).Turn
              Enemy(i).Engage = EnemyStat(Enemy(i).Type).Engage

              FOR p = 1 TO PicCount
                IF UCASE$(RTRIM$(EnemyStat(Enemy(i).Type).FileName)) = UCASE$(RTRIM$(PicInfo(p).Name)) THEN
                  Enemy(i).Pic = p
                END IF
              NEXT


              FOR A = 1 TO 10
                Ammo(i, A) = WeaponStat(Enemy(i).Type, A).Ammo
              NEXT
              EXIT FOR
            END IF

          NEXT
        END IF

        IF LevelTimer >= 8 * 60 * 30 THEN
          CurLev = 7
          MeltRoutine
          MissionPoint = 0
        END IF

        BaseAlive = 0
        FOR i = 1 TO NumEnemy
          IF Enemy(i).Type = 11 THEN
            IF Enemy(i).Armor > 0 THEN: BaseAlive = 1
          END IF
        NEXT
        IF BaseAlive = 0 THEN: MissionPoint = 2

      CASE 9
        FOR i = 1 TO NumEnemy
          IF Enemy(i).Type = 7 THEN
            IF Distance(Enemy(i).X, Enemy(i).Y, Enemy(i).GoX, Enemy(i).GoY) < 50 THEN
              MeltRoutine
              MissionPoint = 2
            END IF
            IF Enemy(i).Status = 30 THEN
              CurLev = 10
              MeltRoutine
              MissionPoint = 0
            END IF
          END IF
        NEXT
      CASE 10
        FlakHide = 0
        Across = 1
        FlakLive = 0
        FriendlyTotal = 0

        FOR i = 1 TO NumEnemy
          SELECT CASE Enemy(i).Type
            CASE 12
              IF Enemy(i).Armor > 0 THEN
                FriendlyTotal = FriendlyTotal + 1
                IF Enemy(i).X < 40000 THEN: Across = 0
              END IF
            CASE 13
              IF Enemy(i).Armor > 0 THEN: FlakLive = 1
            CASE 14
              IF Enemy(i).Armor > 0 THEN
                FlakHide = -1
                EXIT FOR
              END IF
          END SELECT
        NEXT

        IF FriendlyTotal < 125 THEN
          MeltRoutine
          MissionPoint = 2
        END IF

        IF FlakLive = 0 OR Across = 1 THEN
          CurLev = 11
          MeltRoutine
          MissionPoint = 0
        END IF
      CASE 11
        CarrierNum = 0
        FOR i = 1 TO NumEnemy
          IF Enemy(i).Type = 15 THEN
            IF Enemy(i).Status < 30 THEN: CarrierNum = CarrierNum + 1
          END IF
        NEXT
        IF CarrierNum = 0 THEN
          CurLev = 12
          MeltRoutine
          MissionPoint = 0
        END IF
      CASE 12

        FOR i = 1 TO NumEnemy
          IF Enemy(i).Type = 16 THEN
            IF Enemy(i).Status = 30 THEN
              CurLev = 13
              MeltRoutine
              MissionPoint = 0

            END IF
          END IF
        NEXT

    END SELECT
END SELECT

EXIT SUB


MakeEnemies:
NumEnemy = NumEnemy + 1

Enemy(i).Type = EnemyStart(CurLev, i).Type
Enemy(i).X = EnemyStart(CurLev, i).X * 10
Enemy(i).Y = EnemyStart(CurLev, i).Y * 10

TravAng = RND * 360
TravDist = RND * 1000
Enemy(i).GoX = Enemy(i).X + COS(TravAng / Rad) * TravDist
Enemy(i).GoY = Enemy(i).Y + SIN(TravAng / Rad) * TravDist
Enemy(i).Alt = 2000 * RND + 1000
Enemy(i).Scrap = EnemyStat(Enemy(i).Type).Scrap * 10

Enemy(i).Name = EnemyStat(Enemy(i).Type).Name
Enemy(i).Ground = EnemyStat(Enemy(i).Type).Ground
Enemy(i).Size = EnemyStat(Enemy(i).Type).Size
Enemy(i).MaxSpeed = EnemyStat(Enemy(i).Type).MaxSpeed
Enemy(i).Thrust = EnemyStat(Enemy(i).Type).Thrust
Enemy(i).Armor = EnemyStat(Enemy(i).Type).Armor
Enemy(i).Status = 0 '   status      (0 = Ok    Other = destroyed)
Enemy(i).Ang = RND * 360
Enemy(i).Turn = EnemyStat(Enemy(i).Type).Turn
Enemy(i).Engage = EnemyStat(Enemy(i).Type).Engage

Enemy(i).Use = 1

FOR p = 1 TO PicCount
  IF UCASE$(RTRIM$(EnemyStat(Enemy(i).Type).FileName)) = UCASE$(RTRIM$(PicInfo(p).Name)) THEN
    Enemy(i).Pic = p
  END IF
NEXT


FOR A = 1 TO 10
  Ammo(i, A) = WeaponStat(Enemy(i).Type, A).Ammo
NEXT

SELECT CASE CurLev
  CASE 4
    IF Enemy(i).Type = 9 THEN
      NewAng = RND * 360
      IF Level(CurLev).Width > Level(CurLev).Height THEN
        NewDist = Level(CurLev).Width * 5
      ELSE
        NewDist = Level(CurLev).Height * 5
      END IF
      Enemy(i).X = COS(NewAng / Rad) * NewDist
      Enemy(i).Y = SIN(NewAng / Rad) * NewDist
      NewAng = Angle(Enemy(i).X, Enemy(i).Y, 0, 0)
      Enemy(i).GoX = Enemy(i).X + COS(NewAng / Rad) * 500000
      Enemy(i).GoY = Enemy(i).Y + SIN(NewAng / Rad) * 500000
    END IF
END SELECT




RETURN

END SUB




SUB Mouse
DO WHILE _MOUSEINPUT
  MouseX = _MOUSEX
  MouseY = _MOUSEY
  MouseLB = _MOUSEBUTTON(1)
  MouseRB = _MOUSEBUTTON(2)
  MouseMB = _MOUSEBUTTON(3)
  MouseScrl = MouseScrl - _MOUSEWHEEL
LOOP
IF MouseScrl < -1 THEN: MouseScrl = -1
IF MouseScrl > 1 THEN: MouseScrl = 1
END SUB

SUB Navigation

DIM TerrainCol AS LONG, JetCol AS LONG, YouCol AS LONG

'TerrainCol = _RGB32(200, 50, 35)
JetCol = White
YouCol = Yellow


DO
  CLS

  MapX = 200
  MapY = 150
  MapSize = 100

  IF Level(CurLev).Width > Level(CurLev).Height THEN
    MapWid = (Level(CurLev).Width / 2) * 10
  ELSE
    MapWid = (Level(CurLev).Height / 2) * 10
  END IF

  MapRatio = (MapWid / MapSize)

  LINE (0, 0)-(399, 299), _RGB32(0, 0, 200), BF
  LINE (MapX - MapSize, MapY - MapSize)-(MapX + MapSize, MapY + MapSize), _RGB32(0, 0, 100), BF
  LINE (MapX - MapSize, MapY - MapSize)-(MapX + MapSize, MapY + MapSize), White, B

  LINE (8, 42)-(16, 50), TerrainCol, BF
  LINE (8, 62)-(16, 70), JetCol, BF
  LINE (8, 82)-(16, 90), YouCol, BF

  Font " NAVIGATION", 150, 0, White, 2
  Font "~~~~~~~~~~~~", 150, 20, White, 2

  Font "North", MapX - 20, MapY - MapSize - 20, White, 2
  Font "South", MapX - 20, MapY + MapSize + 10, White, 2
  Font "West", MapX - MapSize - 40, MapY - 10, White, 2
  Font "East", MapX + MapSize + 10, MapY - 10, White, 2

  Font "< Key >", 10, 20, White, 2
  'Font "Terrain", 20, 45, White, 1
  Font "Enemy Jets", 20, 65, White, 1
  Font "You", 20, 85, White, 1


  Closest = 500000
  FOR i = 1 TO NumEnemy
    IF Enemy(i).Status = 0 THEN

      Dist = Distance(Enemy(i).X, Enemy(i).Y, PointX, PointY)
      TargetDist = Distance(Enemy(i).X, Enemy(i).Y, Enemy(i).GoX, Enemy(i).GoY)

      IF Dist < Closest THEN
        Closest = Dist
        Which = i
      END IF

      Show = 1
      IF CurLev = 10 THEN
        IF Enemy(i).Type = 13 OR Enemy(i).Type = 14 THEN
          IF FlakHide THEN
            Show = 0
          END IF
        END IF
      END IF

      IF Show = 1 THEN

        X = MapX + Enemy(i).X / MapRatio
        Y = MapY + Enemy(i).Y / MapRatio

        IF Enemy(i).Status = 0 THEN
          PSET (X - 1, Y), JetCol
          PSET (X + 1, Y), JetCol
          PSET (X, Y - 1), JetCol
          PSET (X, Y + 1), JetCol
          PSET (X, Y), JetCol
        END IF

        StartX = Enemy(i).X
        StartY = Enemy(i).Y
        Ang = EnemyAng + 90
        StartAng = Ang

        X2 = MapX + Enemy(i).GoX / MapRatio
        Y2 = MapY + Enemy(i).GoY / MapRatio

        LINE (X, Y)-(X2, Y2), _RGBA(255, 255, 255, 128)
      END IF
    END IF
  NEXT

  X = MapX + Player.X / MapRatio
  Y = MapY + Player.Y / MapRatio
  CIRCLE (X, Y), (10000 / MapRatio), _RGB32(0, 255, 0)
  X2 = X + COS((Player.Ang - 32) / Rad) * (10000 / MapRatio)
  Y2 = Y + SIN((Player.Ang - 32) / Rad) * (10000 / MapRatio)
  X3 = X + COS((Player.Ang + 32) / Rad) * (10000 / MapRatio)
  Y3 = Y + SIN((Player.Ang + 32) / Rad) * (10000 / MapRatio)

  LINE (X - 5, Y)-(X + 5, Y), Yellow
  LINE (X, Y - 5)-(X, Y + 5), Yellow
  LINE (X, Y)-(X2, Y2), Yellow
  LINE (X, Y)-(X3, Y3), Yellow


  Press = _KEYHIT
  ShowScreen
LOOP UNTIL Press = 27


END SUB


SUB Save

DIM WhichLev AS _BYTE
DIM Money AS LONG
DIM PlayTime AS SINGLE

Trans = 255
LClick = 1
Done = 0
DO
  X = _KEYHIT
LOOP UNTIL X = 0

DO
  _LIMIT 30
  CLS
  FOR i = 1 TO 10
    LINE (10 + i, 10 + i)-(389 - i, 289 - i), _RGB32(15 * i + 50, 15 * i + 50, 15 * i + 50), B
  NEXT
  FOR S = 1 TO 5
    FOR i = 1 TO 5
      IF S = Sel THEN
        LINE (30 + i, i + 45 * S)-(369 - i, 40 + 45 * S - i), _RGB32(15 * i + 50, 0, 0), B
      ELSE
        LINE (30 + i, i + 45 * S)-(369 - i, 40 + 45 * S - i), _RGB32(15 * i + 50, 15 * i + 50, 15 * i + 50), B
      END IF
    NEXT
  NEXT

  Font "SAVE", 184, 30, White, 2
  Mouse


  SELECT CASE MouseX
    CASE 72 TO 727
      SELECT CASE MouseY
        CASE 92 TO 170: Sel = 1
        CASE 182 TO 260: Sel = 2
        CASE 272 TO 350: Sel = 3
        CASE 362 TO 440: Sel = 4
        CASE 452 TO 530: Sel = 5
      END SELECT
  END SELECT

  FOR i = 1 TO 5
    File$ = SaveDir + "save" + LTRIM$(STR$(i)) + ".sav"
    IF _FILEEXISTS(File$) THEN
      OPEN File$ FOR BINARY AS #1
      GET #1, , CurDate$
      GET #1, , WhichLev
      GET #1, , Money
      GET #1, , PlayTime
      CLOSE #1

      Seconds = (PlayTime / 30) MOD 60
      Minutes = (PlayTime / 1800) MOD 60
      Hours = INT(PlayTime / 108000)

      Font "Level     : " + STR$(WhichLev), 55, i * 45 + 12, White, 1
      Font CurDate$, 205, i * 45 + 12, White, 1
      Font "Credits   : " + STR$(Money), 55, i * 45 + 22, White, 1
      Font "Game Time : " + STR$(Hours) + "h" + STR$(Minutes) + "m" + STR$(Seconds) + "s", 205, i * 45 + 22, White, 1

    ELSE
      Font "EMPTY", 55, i * 45 + 15, White, 2
    END IF
  NEXT

  SaveFile = 0
  IF MouseLB THEN
    IF LClick = 0 THEN
      SaveFile = 1
    END IF
  ELSE
    LClick = 0
  END IF


  Press = _KEYHIT
  SELECT CASE Press
    CASE 256 * 72: Sel = Sel - 1
    CASE 256 * 80: Sel = Sel + 1
    CASE 32: SaveFile = 1: Done = 1
    CASE 27: Done = 1
  END SELECT
  IF Sel < 1 THEN: Sel = 1
  IF Sel > 5 THEN: Sel = 5

  IF Trans > 0 THEN
    Trans = Trans - 5
    LINE (0, 0)-(799, 599), _RGBA(0, 0, 0, Trans), BF
  END IF

  DrawMouse 1

  ShowScreen

  CurDate$ = DATE$

  IF SaveFile = 1 THEN
    File$ = SaveDir + "save" + LTRIM$(STR$(Sel)) + ".sav"
    IF _FILEEXISTS(File$) THEN: KILL File$
    OPEN File$ FOR BINARY AS #1
    PUT #1, , CurDate$
    PUT #1, , CurLev
    PUT #1, , Player.Money
    PUT #1, , GameTime
    PUT #1, , DamageDone
    PUT #1, , Player
    PUT #1, , PlayWep()
    PUT #1, , Invert()
    CLOSE #1
  END IF

LOOP UNTIL Done = 1
END SUB


FUNCTION ScreenCheck (X, Y, Range)
IF (X + Range) > 0 AND (Y + Range) > 0 AND (X - Range) < 399 AND (Y - Range) < 299 THEN
  ScreenCheck = 1
ELSE
  ScreenCheck = 0
END IF
END FUNCTION



SUB SetCol (Colr%, R%, G%, B%)
PALETTE Colr%, R% + 256 * G% + 65536 * B%
END SUB


SUB Shop

IF _FILEEXISTS(PicDir + "shop.jpg") THEN
  ShopPic = _LOADIMAGE(PicDir + "shop.jpg")
  RefreshPic = _NEWIMAGE(150, 120)
  _PUTIMAGE (0, 0)-(149, 119), ShopPic, RefreshPic, (220, 80)-(370, 200)
ELSE
  PRINT "File shop.jpg missing or not found."
  END
END IF

TextBox = _NEWIMAGE(400, 300)
_DEST TextBox
_CLEARCOLOR _RGB32(0, 0, 0)


'LINE (10, 10)-(390, 290), _RGB32(200, 200, 200), BF
'LINE (20, 20)-(380, 280), Black, BF
'LINE (140, 30)-(260, 50), Gray, B
'LINE (220, 80)-(370, 200), Gray, B

Font "JET SHOP", 170, 35, White, 2

Font "Repair", 50, 110, White, 1
Font "Full Repair", 50, 120, White, 1

Font "Task                Cost", 50, 85, White, 1
LINE (50, 95)-(200, 96), Gray, B

Font "Bomb", 50, 140, White, 1
Font "Vulcan", 50, 155, White, 1
Font "Nuke", 50, 170, White, 1
Font "Rocket", 50, 185, White, 1
Font "Missile", 50, 200, White, 1
Font "Laser", 50, 215, White, 1
Font "Back Flash", 50, 230, White, 1
Font "Magnum", 50, 245, White, 1

DIM WepCost(8) AS LONG
WepCost(1) = 2000
WepCost(2) = 250
WepCost(3) = 15000
WepCost(4) = 2500
WepCost(5) = 500
WepCost(6) = 100000
WepCost(7) = 1000
WepCost(8) = 1250

RepairCost = 125

'Player.Money = 100000
'Player.Armor = 0

_DEST Layer
Sel = 1
LClick = 1

DO

  _PUTIMAGE (0, 0)-(399, 299), ShopPic, Layer
  _PUTIMAGE (0, 0)-(399, 299), TextBox, Layer


  SELECT CASE Sel
    CASE 1
      Text$ = "Repair your jet by 25 units."
    CASE 2
      Text$ = "Repairs your jet to full armor."
    CASE 3
      Text$ = "An explosive weapon that does radius damage to enemies around it once it detonates."
    CASE 4
      Text$ = "A high speed machine gun that fires a spray of destruction in front of your jet."
    CASE 5
      Text$ = "A highly explosive weapon that does massive damage to all enemies in the area once it detonates."
    CASE 6
      Text$ = "A homing missile weapon that hunts down enemies."
    CASE 7
      Text$ = "A missile weapon that has limited homing ability."
    CASE 8
      Text$ = "A multi-beam weapon that requires no ammunition but generates a moderate amount of heat."
    CASE 9
      Text$ = "A flash of damage directly behind your jet to discourage tailgaters."
    CASE 10
      Text$ = "An unstoppable slug of destruction that tears through any enemy in its path."

  END SELECT

  SELECT CASE Sel
    CASE 1, 2: Font ">", 40, 98 + Sel * 10, White, 2
    CASE ELSE: Font ">", 40, 93 + Sel * 15, White, 2
  END SELECT

  IF OldSel <> Sel THEN
    _DEST TextBox
    _PUTIMAGE (220, 80)-(370, 200), RefreshPic, TextBox
    FontBox Text$, 220, 80, 370, 200, 5, 0
    _DEST Layer
  END IF

  Font "Credits: " + STR$(Player.Money), 230, 210, White, 1

  IF Sel > 2 THEN
    IF Sel <> 8 THEN
      Font "Ammo: ", 245, 230, White, 1
      Font STR$(PlayWep(Sel - 2).Ammo), 245, 240, White, 1
      Font "/", 280, 240, White, 1
      Font STR$(PlayWep(Sel - 2).MaxAmmo), 285, 240, White, 1
    END IF
    Font "Damage: ", 245, 255, White, 1
    Font STR$(PlayWep(Sel - 2).Power), 295, 255, White, 1
  END IF
  IF Sel < 3 THEN
    Font "Armor: ", 245, 230, White, 1
    Font STR$(Player.Armor), 245, 240, White, 1
    Font "/ 10000", 290, 240, White, 1
  END IF

  Font STR$(RepairCost), 165, 110, White, 1
  Font STR$((RepairCost * (10000 - Player.Armor)) / 25), 165, 120, White, 1

  FOR i = 1 TO 8
    IF i = 6 THEN
      IF Player.Laser = 0 THEN
        Font STR$(WepCost(i)), 165, 125 + i * 15, White, 1
      ELSE
        Font "-", 165, 125 * i * 15, White, 1
      END IF
    ELSE
      Font STR$(WepCost(i)), 165, 125 + i * 15, White, 1
    END IF
  NEXT

  '1 = Bomb
  '2 = Vulcan
  '3 = Nuke
  '4 = Rocket
  '5 = Missile
  '6 = Laser
  '7 = Back Flash
  '8 = Magnum

  OldSel = Sel

  Press = _KEYHIT
  Add = 0
  AddMany = 0
  SELECT CASE Press
    CASE 256 * 72: Sel = Sel - 1
    CASE 256 * 80: Sel = Sel + 1
    CASE 27
      _MOUSEMOVE 400, 300
      EXIT SUB
    CASE 256 * 77: Add = 1
    CASE 100303, 100304: ShiftHold = 1
    CASE -100303, -100304: ShiftHold = 0
  END SELECT

  IF MouseRB THEN
    Add = 1
  END IF
  IF MouseLB THEN
    IF MouseX >= 81 AND MouseX <= 158 AND MouseY >= 66 AND MouseY <= 98 THEN
      _MOUSEMOVE 400, 300
      EXIT SUB
    END IF
    IF LClick = 0 OR ShiftHold = 1 THEN
      LClick = 1
      Add = 1
    END IF
  ELSE
    LClick = 0
  END IF

  IF Add = 1 THEN
    SELECT CASE Sel
      CASE 1 '  Repair Some
        IF Player.Armor < 10000 THEN
          IF Player.Money >= RepairCost THEN
            Player.Money = Player.Money - RepairCost
            Player.Armor = Player.Armor + 25
            IF Player.Armor > 10000 THEN: Player.Armor = 10000
          END IF
        END IF
      CASE 2 '  Repair All
        IF Player.Armor < 10000 THEN
          IF Player.Money >= ((RepairCost * (10000 - Player.Armor)) / 25) THEN
            Player.Money = Player.Money - (RepairCost * (10000 - Player.Armor)) / 25
            Player.Armor = 10000
          END IF
        END IF
      CASE 8 '   Laser
        IF Player.Laser = 0 THEN
          IF Player.Money >= WepCost(6) THEN
            Player.Money = Player.Money - WepCost(6)
            Player.Laser = 1
          END IF
        END IF
      CASE 4 '   Vulcan
        IF PlayWep(Sel - 2).Ammo <= PlayWep(Sel - 2).MaxAmmo - 5 THEN
          IF Player.Money >= WepCost(Sel - 2) THEN
            Player.Money = Player.Money - WepCost(Sel - 2)
            PlayWep(Sel - 2).Ammo = PlayWep(Sel - 2).Ammo + 5
          END IF
        ELSEIF PlayWep(Sel - 2).Ammo < PlayWep(Sel - 2).MaxAmmo AND PlayWep(Sel - 2).Ammo > PlayWep(Sel - 2).MaxAmmo - 5 THEN
          Cost = (WepCost(Sel - 2) / 5) * (PlayWep(Sel - 2).MaxAmmo - PlayWep(Sel - 2).Ammo)
          IF Player.Money >= Cost THEN
            Player.Money = Player.Money - Cost
            PlayWep(Sel - 2).Ammo = PlayWep(Sel - 2).MaxAmmo
          END IF
        END IF
      CASE ELSE
        IF PlayWep(Sel - 2).Ammo < PlayWep(Sel - 2).MaxAmmo THEN
          IF Player.Money >= WepCost(Sel - 2) THEN
            Player.Money = Player.Money - WepCost(Sel - 2)
            PlayWep(Sel - 2).Ammo = PlayWep(Sel - 2).Ammo + 1
          END IF
        END IF

    END SELECT
  END IF

  Mouse

  Font "Hold Shift or R. Click", 40, 265, White, 1
  Font "to add many.", 40, 273, White, 1
  Font "Exit", 46, 38, White, 1


  SELECT CASE MouseX
    CASE 105 TO 420
      SELECT CASE MouseY
        CASE 222 TO 238: Sel = 1
        CASE 239 TO 258: Sel = 2
        CASE 280 TO 520
          Sel = INT((MouseY - 280) / 30) + 3

      END SELECT
  END SELECT

  IF Sel < 1 THEN: Sel = 1
  IF Sel > 10 THEN: Sel = 10

  DrawMouse 1

  ShowScreen
LOOP

END SUB



SUB ShowScreen
_LIMIT 30
IF Player.Alt > 80 OR CurLev = 5 OR MissionPoint = 0 THEN
  _PUTIMAGE (0, 0)-(799, 599), Layer, 0
ELSE
  Hit = INT(4 * RND + 1)
  Bounce = INT(Player.Speed / 300)
  SELECT CASE Hit
    CASE 1: X = -Bounce: Y = -Bounce
    CASE 2: X = -Bounce: Y = Bounce
    CASE 3: X = Bounce: Y = -Bounce
    CASE 4: X = Bounce: Y = Bounce
  END SELECT
  _PUTIMAGE (X, Y)-(X + 799, Y + 599), Layer, 0
END IF
END SUB


SUB TitleScreen

DIM Title(2)
FOR i = 1 TO 2
  Title(i) = _NEWIMAGE(400, 300)
NEXT

_DEST Title(2)

_PRINTSTRING (16, 0), "AIR"
_PRINTSTRING (5, 12), "ATTACK"
_PRINTSTRING (0, 24), "EXTREME"

GreatX = 0
GreatY = 0
_SOURCE Title(2)
FOR x = 0 TO 200
  FOR y = 0 TO 200
    IF POINT(x, y) > _RGB32(0, 0, 0) THEN
      IF x > GreatX THEN: GreatX = x
      IF y > GreatY THEN: GreatY = y
    END IF
  NEXT
NEXT

_PUTIMAGE (40, 10)-(359, 280), Title(2), Title(1), (0, 0)-(GreatX, GreatY)
'_PUTIMAGE (80, 80)-(300, 200), Title(2), Title(1), (0, 0)-(GreatX, GreatY)


_SOURCE Title(1)

Total = 0
Top = 0
Left = 0
Bottom = 0
Right = 0

FOR x = 0 TO 399
  FOR y = 0 TO 299
    IF POINT(x, y) > _RGB32(0, 0, 0) THEN
      Total = Total + 1
      IF Top = 0 THEN: Top = y
      IF Left = 0 THEN: Left = x
      IF x > Right THEN: Right = x
      IF y > Bottom THEN: Bottom = y
    END IF
  NEXT
NEXT

ColRange = Distance(Left, Top, Right, Bottom)

DIM Text(Total) AS Text
DIM BG AS INTEGER



Count = 0
FOR x = 0 TO 399
  FOR y = 0 TO 299
    IF POINT(x, y) > _RGB32(0, 0, 0) THEN
      Count = Count + 1
      Text(Count).CurX = 200
      Text(Count).CurY = 150
      Text(Count).OrigX = x
      Text(Count).OrigY = y
      Text(Count).Ang = RND * 360
      Text(Count).Speed = .001 '  RND * 30 + 10
      A = (Distance(x, y, Left, Top) / ColRange) * 155 + 100
      R = 255
      'IF R < 1 THEN: R = 1
      G = 255 - ((Distance(x, y, Left, Top) / ColRange) * 255)
      Text(Count).Col = _RGBA32(R, G, B, A)
    END IF
  NEXT
NEXT



Radius = 30

_DEST Layer

Start = TIMER
ScreenTimer = TIMER

IF _FILEEXISTS(PicDir + "dark_cloud.jpg") THEN
  BG = _LOADIMAGE(PicDir + "dark_cloud.jpg")
ELSE
  PRINT "File dark_cloud.jpg missing or not found."
  END
END IF

OldLayer = _NEWIMAGE(400, 300)

DO
  DO
    _PUTIMAGE (0, 0)-(399, 299), BG, Layer
    'CLS
    Current = TIMER
    Frames = Frames + 1
    IF Current - Start >= 1 THEN
      Start = TIMER
      FPS = Frames
      Frames = 0
    END IF
    IF FPS > 35 THEN: _LIMIT 30
    Count = 0
    FOR i = 0 TO Total
      PSET (Text(i).CurX, Text(i).CurY), Text(i).Col
      Dist = Distance(MouseX / 2, MouseY / 2, Text(i).CurX, Text(i).CurY)
      IF Dist <= (RND * Radius) THEN
        IF MouseSpeed > 0 THEN
          Text(i).Ang = Angle(MouseX / 2, MouseY / 2, Text(i).CurX, Text(i).CurY)
          Text(i).Speed = MouseSpeed
        END IF
        Text(i).CurX = (MouseX / 2) + COS(Text(i).Ang / Rad) * Radius
        Text(i).CurY = (MouseY / 2) + SIN(Text(i).Ang / Rad) * Radius
      END IF
      Text(i).CurX = Text(i).CurX + COS(Text(i).Ang / Rad) * Text(i).Speed
      Text(i).CurY = Text(i).CurY + SIN(Text(i).Ang / Rad) * Text(i).Speed
      IF Text(i).Ang > 360 THEN: Text(i).Ang = Text(i).Ang - 360
      IF Text(i).Ang < 0 THEN: Text(i).Ang = Text(i).Ang + 360


      Dist = Distance(Text(i).CurX, Text(i).CurY, Text(i).OrigX, Text(i).OrigY)

      IF Dist > 0 THEN
        Count = Count + 1
        OrigAng = Angle(Text(i).CurX, Text(i).CurY, Text(i).OrigX, Text(i).OrigY)

        AngleDif = ABS(Text(i).Ang - OrigAng)
        IF AngleDif <= 5 THEN: Text(i).Ang = OrigAng


        IF AngleDif < 180 THEN
          Text(i).Turn = AngleDif / 10
          IF Text(i).Turn = 0 THEN: Text(i).Turn = .01
          IF Text(i).Ang > OrigAng THEN
            Text(i).Ang = Text(i).Ang - Text(i).Turn
          ELSEIF Text(i).Ang < OrigAng THEN
            Text(i).Ang = Text(i).Ang + Text(i).Turn
          ELSE
            TurnDir = INT(2 * RND + 1)
            IF TurnDir = 1 THEN
              Text(i).Ang = Text(i).Ang + Text(i).Turn
            ELSE
              Text(i).Ang = Text(i).Ang - Text(i).Turn
            END IF
          END IF
        ELSE
          AngleDif = 360 - AngleDif
          Text(i).Turn = AngleDif / 10
          IF Text(i).Ang > OrigAng THEN
            Text(i).Ang = Text(i).Ang + Text(i).Turn
          ELSEIF Text(i).Ang < OrigAng THEN
            Text(i).Ang = Text(i).Ang - Text(i).Turn
          END IF
        END IF

        IF Dist <= 2 THEN
          Text(i).CurX = Text(i).OrigX
          Text(i).CurY = Text(i).OrigY
          Text(i).Speed = 0
        END IF

        IF Text(i).Speed > .25 THEN: Text(i).Speed = Text(i).Speed * .98
        IF Dist > 1 THEN
          IF AngleDif > 5 THEN
            IF Text(i).Speed < .1 THEN: Text(i).Speed = .25
          END IF
          IF AngleDif < 3 THEN
            IF Dist > 20 AND Text(i).Speed < 2 THEN: Text(i).Speed = Text(i).Speed * 1.25
          END IF
        END IF

      END IF
    NEXT


    OldX = MouseX
    OldY = MouseY

    Mouse

    MouseSpeed = Distance(OldX / 2, OldY / 2, MouseX / 2, MouseY / 2)

    'CIRCLE (MouseX / 2, MouseY / 2), Radius, _RGBA32(255, 255, 255, 32)
    IF MouseScrl THEN
      Radius = Radius + MouseScrl
      MouseScrl = 0
    END IF

    '_PRINTSTRING (0, 0), STR$(Count)
    '_PRINTSTRING (0, 20), STR$(FPS)
    '_PRINTSTRING (0, 40), STR$(MouseX / 2) + "," + STR$(MouseY / 2)

    IF TIMER - ScreenTimer > 3.5 THEN: TitleText = TitleText + 1
    IF TitleText > 200 THEN: TitleText = 200

    Font "New Game", 171, 103, _RGBA(200, 0, 0, TitleText), 2
    Font "Load", 185, 195, _RGBA(200, 0, 0, TitleText), 2
    Font "Options", 5, 5, _RGBA(200, 0, 0, TitleText), 1
    LINE (0, 0)-(54, 17), _RGBA(200, 0, 0, TitleText * 1.1), B

    Press = _KEYHIT
    SELECT CASE Press
      CASE 32
        FOR i = 1 TO Total
          Text(i).CurX = 200
          Text(i).CurY = 150
          Text(i).Ang = RND * 360
          Text(i).Speed = 0.001 'RND * 30 + 10
        NEXT
      CASE 13
        FOR i = 1 TO Total
          Text(i).CurX = RND * 400
          Text(i).CurY = RND * 300
          Text(i).Ang = Angle(Text(i).CurX, Text(i).CurY, Text(i).OrigX, Text(i).OrigY)
          Text(i).Speed = 5 'RND * 5
        NEXT
      CASE 8
        FOR i = 1 TO Total
          Text(i).CurX = 400
          Text(i).CurY = 300
          Text(i).Ang = Angle(Text(i).CurX, Text(i).CurY, Text(i).OrigX, Text(i).OrigY)
          Text(i).Speed = RND * 5 + 3
        NEXT
      CASE 27
        FOR i = 1 TO Total
          Text(i).Ang = RND * 360
          Text(i).Speed = RND * 25 + 25
        NEXT

    END SELECT

    IF MouseLB THEN
      Click = 1
      NewGame = 0: LoadGame = 0
      IF Distance(MouseX / 2, MouseY / 2, 200, 107) < 25 THEN: NewGame = 1
      IF Distance(MouseX / 2, MouseY / 2, 200, 200) < 25 THEN: LoadGame = 1
      IF MouseX < 108 AND MouseY < 34 THEN
        PCOPY Layer, OldLayer

        DO

          Mouse

          PCOPY OldLayer, Layer
          LINE (20, 20)-(380, 280), Black, BF
          LINE (20, 20)-(380, 280), Yellow, B
          Press = _KEYHIT
          Done = 0
          SELECT CASE Press
            CASE 27
              Done = 1
          END SELECT

          IF Invert(1) = 1 THEN
            UD$ = "On"
          ELSE
            UD$ = "Off"
          END IF

          IF Invert(2) = 1 THEN
            LR$ = "On"
          ELSE
            LR$ = "Off"
          END IF


          LINE (24, 37)-(155, 48), Gray, B
          LINE (24, 53)-(155, 64), Gray, B
          Font "L  R    Invert : " + UD$, 25, 40, White, 1
          Font "U  D    Invert : " + LR$, 25, 55, White, 1
          Font "Controls", 65, 80, White, 1
          Font "-------", 65, 90, White, 1
          Font "-           Slow Down", 25, 100, White, 1
          Font "+           Speed Up", 25, 110, White, 1
          Font "1 - 9       Select Speed", 25, 120, White, 1
          Font "Bksp        Super Speed", 25, 130, White, 1
          Font "Space       Match Target", 25, 140, White, 1
          Font "Speed", 97, 147, White, 1
          Font "Page Up / Page Down", 25, 160, White, 1
          Font "Change Lock On", 97, 170, White, 1
          Font "Target Radius", 97, 177, White, 1
          Font "L. Click    Shoot Laser", 25, 190, White, 1
          Font "R. Click    Special Wep.", 25, 200, White, 1
          Font "M. Wheel    Change Wep.", 25, 210, White, 1
          Font "<   >       Change Invert", 25, 230, White, 1
          Font "F1 - F8     Select Wep.", 25, 245, White, 1
          Font "N           Navigation", 25, 260, White, 1
          Font "C           Cockpit On/Off", 25, 270, White, 1
          '
          LINE (200, 25)-(375, 275), Yellow, B

          Text$ = "Some weapons and actions create heat.  Over heating causes damage.  Slow down to cool down faster."
          FontBox Text$, 200, 25, 375, 275, 5, 0

          Text$ = "Defeating enemies earns you credits you can use to repair your ship and purchase ammunition."
          FontBox Text$, 200, 100, 375, 275, 5, 0

          Text$ = "Watch your altitude so you don't hit into the ground."
          FontBox Text$, 200, 175, 375, 275, 5, 0

          Text$ = "Colliding with enemies (especially large ones) can be deadly!"
          FontBox Text$, 200, 215, 375, 275, 5, 0



          IF MouseLB THEN
            IF Click = 0 THEN
              SELECT CASE MouseX
                CASE 48 TO 310
                  SELECT CASE MouseY
                    CASE 74 TO 96
                      Click = 1
                      IF Invert(1) = 0 THEN
                        Invert(1) = 1
                      ELSE
                        Invert(1) = 0
                      END IF
                    CASE 106 TO 128
                      Click = 1
                      IF Invert(2) = 0 THEN
                        Invert(2) = 1
                      ELSE
                        Invert(2) = 0
                      END IF


                  END SELECT
              END SELECT
            END IF
          ELSE
            Click = 0
          END IF

          DrawMouse 1

          ShowScreen
        LOOP UNTIL Done = 1
      END IF
    END IF

    DrawMouse 1

    ShowScreen
  LOOP UNTIL (NewGame + LoadGame) > 0
  _SNDPLAYCOPY Sounds(7)

  _DEST 0
  FOR i = 1 TO 60
    _LIMIT 30
    LINE (0, 0)-(799, 599), _RGBA(0, 0, 0, i), BF

  NEXT
  CLS

  Done = 0

  IF NewGame = 1 THEN
    Done = 1
    CurLev = 1
    Player.Money = 75000
    Mission
    Shop
  END IF

  IF LoadGame = 1 THEN: Load Done
  NewGame = 0
  LoadGame = 0

LOOP UNTIL Done = 1

END SUB



SUB WeaponUse

IF InfiniteAmmo = 1 THEN
  FOR i = 1 TO 8
    IF PlayWep(i).Ammo < PlayWep(i).MaxAmmo THEN: PlayWep(i).Ammo = PlayWep(i).MaxAmmo
  NEXT
  Player.Laser = 1
END IF

WeaponActive = 0
FOR i = 1 TO NumWeapon
  IF Weapon(i).Use = 1 THEN
    SELECT CASE Weapon(i).Target
      CASE IS >= 0 'Enemies     (Player Weapons)

        '1 = Bomb
        '2 = Vulcan
        '3 = Nuke
        '4 = Rocket
        '5 = Missile
        '6 = Laser
        '7 = Back Flash
        '8 = Magnum

        Weapon(i).OldX = Weapon(i).X
        Weapon(i).OldY = Weapon(i).Y
        Weapon(i).OldAlt = Weapon(i).Alt

        SELECT CASE Weapon(i).Type
          CASE 1, 3
            IF Weapon(i).Var > 0 THEN
              Weapon(i).Var = Weapon(i).Var + 1
              Weapon(i).Dist = Distance3D(Player.X, Player.Y, Player.Alt, Weapon(i).X, Weapon(i).Y, Weapon(i).Alt)
              IF Weapon(i).Var > Weapon(i).Range THEN
                FOR j = 1 TO NumEnemy
                  IF Enemy(j).Status = 0 AND Enemy(j).Friendly = 0 THEN
                    Damage = ((Weapon(i).Radius - Distance3D(Weapon(i).X, Weapon(i).Y, Weapon(i).Alt, Enemy(j).X, Enemy(j).Y, Enemy(j).Alt)) / Weapon(i).Radius) * Weapon(i).Power
                    IF Damage < 0 THEN: Damage = 0
                    Enemy(j).Armor = Enemy(j).Armor - Damage
                    DamageDone = DamageDone + Damage
                  END IF
                NEXT
              ELSE
                Weapon(i).X = Weapon(i).X + COS(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)
                Weapon(i).Y = Weapon(i).Y + SIN(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)
                Weapon(i).Alt = Weapon(i).Alt - Weapon(i).Tilt
                IF Weapon(i).Alt < 0 THEN: Weapon(i).Var = Weapon(i).Range
              END IF
              IF Weapon(i).Var = Weapon(i).Range THEN: _SNDPLAYCOPY Sounds(5)
              IF Weapon(i).Var >= Weapon(i).Range * 1.25 THEN
                Weapon(i).Use = 0
                Weapon(i).Var = 0
              END IF
            END IF

          CASE 2, 6, 8
            IF Weapon(i).Var > 0 THEN
              Weapon(i).Var = Weapon(i).Var + 1
              Weapon(i).Dist = Distance3D(Player.X, Player.Y, Player.Alt, Weapon(i).X, Weapon(i).Y, Weapon(i).Alt)

              Weapon(i).X = Weapon(i).X + COS(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)
              Weapon(i).Y = Weapon(i).Y + SIN(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)
              Weapon(i).Alt = Weapon(i).Alt - Weapon(i).Tilt
              IF Weapon(i).Alt < 0 THEN: Weapon(i).Var = Weapon(i).Range

              FOR j = 1 TO NumEnemy
                IF Enemy(j).Status = 0 AND Enemy(j).Friendly = 0 THEN
                  TargDist = Weapon(i).Radius + Enemy(j).Size
                  IF ABS(Weapon(i).Alt - Enemy(j).Alt) < TargDist THEN
                    'IF (Weapon(i).Alt >= Enemy(j).Alt) AND (Weapon(i).Alt <= (Enemy(j).Alt - Enemy(j).Size)) THEN
                    IF IfHit(Weapon(i).OldX, Weapon(i).OldY, Weapon(i).X, Weapon(i).Y, Enemy(j).X, Enemy(j).Y, TargDist, 0) THEN
                      Enemy(j).Armor = Enemy(j).Armor - Weapon(i).Power
                      DamageDone = DamageDone + Weapon(i).Power
                      SELECT CASE Weapon(i).Type
                        CASE 2, 6: Weapon(i).Use = 0
                      END SELECT
                      SELECT CASE Enemy(j).Type
                        CASE 7, 15 TO 17: Weapon(i).Use = 0
                      END SELECT
                    END IF
                  END IF
                END IF
              NEXT

              IF Weapon(i).Var >= Weapon(i).Range OR Weapon(i).Alt <= 0 THEN
                Weapon(i).Use = 0
                Weapon(i).Var = 0
              END IF
            END IF

          CASE 4, 5

            EnemyDist = Distance3D(Weapon(i).X, Weapon(i).Y, Weapon(i).Alt, Enemy(Weapon(i).Target).X, Enemy(Weapon(i).Target).Y, Enemy(Weapon(i).Target).Alt)
            Weapon(i).Dist = Distance3D(Player.X, Player.Y, Player.Alt, Weapon(i).X, Weapon(i).Y, Weapon(i).Alt)

            Weapon(i).Var = Weapon(i).Var + 1
            IF Weapon(i).Var > Weapon(i).Range THEN: Weapon(i).Use = 0

            IF Weapon(i).Target > 0 THEN
              Weapon(i).Tilt = ABS((Weapon(i).Alt - Enemy(Weapon(i).Target).Alt) / (EnemyDist / (Weapon(i).Speed / 100)))
              'ELSE
              'Weapon(i).Tilt = PlayWep(Weapon(i).Type).Tilt
            END IF

            Weapon(i).X = Weapon(i).X + COS(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)
            Weapon(i).Y = Weapon(i).Y + SIN(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)

            IF Weapon(i).Target > 0 THEN

              IF Weapon(i).Alt > Enemy(Weapon(i).Target).Alt THEN
                Weapon(i).Alt = Weapon(i).Alt - Weapon(i).Tilt
              ELSEIF Weapon(i).Alt < Enemy(Weapon(i).Target).Alt THEN
                Weapon(i).Alt = Weapon(i).Alt + Weapon(i).Tilt
              END IF

              TargetAngle = Angle(Weapon(i).X, Weapon(i).Y, Enemy(Weapon(i).Target).X, Enemy(Weapon(i).Target).Y)
              AngleDif = ABS(Weapon(i).Ang - TargetAngle)

              SELECT CASE Weapon(i).Type
                CASE 4
                  'Turn = 45
                  Weapon(i).Ang = TargetAngle
                  AngleDif = 0
                  IF Enemy(Weapon(i).Target).Armor <= 0 THEN
                    Weapon(i).Target = 0
                  END IF
                CASE 5: Turn = .25
              END SELECT

              IF AngleDif < 180 THEN
                IF AngleDif < Turn THEN: Weapon(i).Ang = TargetAngle
                IF Weapon(i).Ang < TargetAngle THEN
                  Weapon(i).Ang = Weapon(i).Ang + Turn
                ELSEIF Weapon(i).Ang > TargetAngle THEN
                  Weapon(i).Ang = Weapon(i).Ang - Turn
                END IF
              ELSEIF AngleDif > 180 THEN
                IF Weapon(i).Ang > TargetAngle THEN
                  Weapon(i).Ang = Weapon(i).Ang + Turn
                  IF ((360 - AngleDif) + TargetAngle) < Turn THEN: Weapon(i).Ang = TargetAngle
                ELSE
                  Weapon(i).Ang = Weapon(i).Ang - Turn
                  IF ((360 - TargetAngle) + AngleDif) < Turn THEN: Weapon(i).Ang = TargetAngle
                END IF
              END IF

              TurnRadius = ((360 / Turn) * (Weapon(i).Speed / 100)) / Pi / 2

              IF Weapon(i).Type = 4 THEN
                IF TurnRadius > EnemyDist AND AngleDif > Turn THEN
                  Weapon(i).Speed = Weapon(i).Speed * .9
                ELSE
                  Weapon(i).Speed = Weapon(i).Speed + 1.1111
                  IF Weapon(i).Speed > Weapon(i).MaxSpeed THEN: Weapon(i).Speed = Weapon(i).MaxSpeed
                END IF
              END IF

            ELSE
              Weapon(i).Alt = Weapon(i).Alt - Weapon(i).Tilt
              FOR j = 1 TO NumEnemy
                IF Enemy(j).Status = 0 AND Enemy(j).Friendly = 0 THEN
                  TargDist = Weapon(i).Radius + Enemy(j).Size
                  IF ABS(Weapon(i).Alt - Enemy(j).Alt) < TargDist THEN
                    IF IfHit(Weapon(i).OldX, Weapon(i).OldY, Weapon(i).X, Weapon(i).Y, Enemy(j).X, Enemy(j).Y, TargDist, 0) THEN
                      Enemy(j).Armor = Enemy(j).Armor - Weapon(i).Power
                      DamageDone = DamageDone + Weapon(i).Power
                      Weapon(i).Type = 0
                    END IF
                  END IF
                END IF
              NEXT
            END IF

            IF Weapon(i).Alt < 0 THEN: Weapon(i).Use = 0

            IF EnemyDist < Weapon(i).Radius THEN
              Weapon(i).Use = 0
              Enemy(Player.Target).Armor = Enemy(Player.Target).Armor - Weapon(i).Power
              DamageDone = DamageDone + Weapon(i).Power
            END IF
          CASE 7
            Weapon(i).Use = 0
            DamageSpotX = Player.X + COS((Player.Ang - 180) / Rad) * (Weapon(i).Range / 2)
            DamageSpotY = Player.Y + SIN((Player.Ang - 180) / Rad) * (Weapon(i).Range / 2)
            LINE (0, 0)-(399, 299), Yellow, BF

            FOR j = 1 TO NumEnemy
              IF Enemy(j).Status = 0 AND Enemy(j).Friendly = 0 THEN
                IF Distance3D(DamageSpotX, DamageSpotY, Player.Alt, Enemy(j).X, Enemy(j).Y, Enemy(j).Alt) < (Weapon(i).Range / 2) THEN
                  Damage = Weapon(i).Power
                  IF Damage < 0 THEN: Damage = 0
                  Enemy(j).Armor = Enemy(j).Armor - Damage
                  DamageDone = DamageDone + Damage
                END IF
              END IF
            NEXT


        END SELECT
      CASE -1 'Player   (Enemy Weapons)
        SELECT CASE Weapon(i).Type

          CASE 1, 3 ' Bullet / Laser
            Weapon(i).Var = Weapon(i).Var + 1

            Weapon(i).Dist = Distance3D(Player.X, Player.Y, Player.Alt, Weapon(i).X, Weapon(i).Y, Weapon(i).Alt)
            IF Distance(Weapon(i).X, Weapon(i).Y, Enemy(Weapon(i).Shooter).X, Enemy(Weapon(i).Shooter).Y) > Weapon(i).Range THEN: Weapon(i).Use = 0

            Weapon(i).OldX = Weapon(i).X
            Weapon(i).OldY = Weapon(i).Y
            Weapon(i).OldAlt = Weapon(i).Alt

            Weapon(i).Alt = Weapon(i).Alt - Weapon(i).Tilt

            Weapon(i).X = Weapon(i).X + COS(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)
            Weapon(i).Y = Weapon(i).Y + SIN(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)

            IF Weapon(i).Alt < 0 THEN: Weapon(i).Use = 0

            IF Weapon(i).Dist < 50 THEN
              Weapon(i).Use = 0
              Player.Armor = Player.Armor - Weapon(i).Power
              LINE (0, 0)-(799, 599), _RGBA32(255, 0, 0, 128), BF
            END IF
            SELECT CASE CurLev
              CASE 6
                IF Distance3D(Weapon(i).X, Weapon(i).Y, Weapon(i).Alt, 0, 0, 80) < 250 THEN
                  FOR j = 1 TO NumEnemy
                    IF Enemy(j).Type = 11 THEN
                      IF Enemy(j).Use = 1 THEN
                        Enemy(j).Armor = Enemy(j).Armor - Weapon(i).Power
                        IF Enemy(j).Armor <= 0 THEN: Enemy(j).Use = 0
                        Weapon(i).Use = 0
                        EXIT FOR
                      END IF
                    END IF
                  NEXT
                END IF
            END SELECT

            IF Weapon(i).Var > Weapon(i).Range THEN: Weapon(i).Use = 0

          CASE 2, 4 ' Missile  /  Heat Seek

            Weapon(i).Var = Weapon(i).Var + 1
            IF Weapon(i).Var > 30 * 10 THEN: Weapon(i).Use = 0
            Weapon(i).Dist = Distance3D(Player.X, Player.Y, Player.Alt, Weapon(i).X, Weapon(i).Y, Weapon(i).Alt)


            IF Weapon(i).Dist > Weapon(i).Range * 10 THEN: Weapon(i).Use = 0
            Weapon(i).Tilt = ABS((Weapon(i).Alt - Player.Alt) / (Weapon(i).Dist / (Weapon(i).Speed / 100)))

            Weapon(i).OldX = Weapon(i).X
            Weapon(i).OldY = Weapon(i).Y
            Weapon(i).OldAlt = Weapon(i).Alt

            Weapon(i).X = Weapon(i).X + COS(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)
            Weapon(i).Y = Weapon(i).Y + SIN(Weapon(i).Ang / Rad) * (Weapon(i).Speed / 100)

            TargetAngle = Angle(Weapon(i).X, Weapon(i).Y, Player.X, Player.Y)
            AngleDif = ABS(Weapon(i).Ang - TargetAngle)

            SELECT CASE Weapon(i).Type
              CASE 2: Turn = 1
              CASE 4: Turn = 15
            END SELECT


            IF AngleDif < 180 THEN
              IF AngleDif < Turn THEN: Weapon(i).Ang = TargetAngle
              IF Weapon(i).Ang < TargetAngle THEN
                Weapon(i).Ang = Weapon(i).Ang + Turn
              ELSEIF Weapon(i).Ang > TargetAngle THEN
                Weapon(i).Ang = Weapon(i).Ang - Turn
              END IF
            ELSE
              IF Weapon(i).Ang > TargetAngle THEN
                Weapon(i).Ang = Weapon(i).Ang + Turn
                IF ((360 - AngleDif) + TargetAngle) < Turn THEN: Weapon(i).Ang = TargetAngle
              ELSE
                Weapon(i).Ang = Weapon(i).Ang - Turn
                IF ((360 - TargetAngle) + AngleDif) < Turn THEN: Weapon(i).Ang = TargetAngle
              END IF
            END IF

            IF ABS(Weapon(i).Alt - Player.Alt) < Weapon(i).Tilt THEN
              Weapon(i).Alt = Player.Alt
            ELSE
              IF Weapon(i).Alt < Player.Alt THEN
                Weapon(i).Alt = Weapon(i).Alt + Weapon(i).Tilt
                IF Weapon(i).Alt > Player.Alt THEN: Weapon(i).Alt = Player.Alt
              ELSE
                Weapon(i).Alt = Weapon(i).Alt - Weapon(i).Tilt
                IF Weapon(i).Alt < Player.Alt THEN: Weapon(i).Alt = Player.Alt
              END IF
            END IF

            IF Weapon(i).Alt < 0 THEN: Weapon(i).Use = 0

            IF Weapon(i).Dist < 50 THEN
              Weapon(i).Use = 0
              Player.Armor = Player.Armor - Weapon(i).Power
            END IF

          CASE 5 ' Flak

            Weapon(i).Dist = Distance3D(Player.X, Player.Y, Player.Alt, Weapon(i).X, Weapon(i).Y, Weapon(i).Alt)
            Weapon(i).Alt = Weapon(i).Alt + Weapon(i).Speed / 100

            IF Weapon(i).Alt > Weapon(i).Range THEN: Weapon(i).Var = Weapon(i).Var + 1

            IF Weapon(i).Var = 2 THEN

              Damage = (Weapon(i).Power * 2) - (Weapon(i).Dist * 2)
              IF Damage < 0 THEN: Damage = 0
              Player.Armor = Player.Armor - Damage / 200
              LINE (0, 0)-(799, 599), _RGBA32(255, 0, 0, 128), BF

              FOR e = 1 TO NumEnemy
                IF Enemy(e).Friendly = 1 THEN
                  Dist = Distance3D(Enemy(e).X, Enemy(e).Y, Enemy(e).Alt, Weapon(i).X, Weapon(i).Y, Weapon(i).Alt)
                  Damage = (Weapon(i).Power * 2) - (Dist * 2)
                  IF Damage < 0 THEN: Damage = 0
                  Enemy(e).Armor = Enemy(e).Armor - Damage / 200
                END IF
              NEXT
            END IF
            IF Weapon(i).Var > 20 THEN: Weapon(i).Use = 0

        END SELECT

    END SELECT
  END IF
NEXT
END SUB






