' Keyboard constants
CONST KEYDOWN& = &H5000
CONST KEYUP& = &H4800
CONST KEYLEFT& = &H4B00
CONST KEYRIGHT& = &H4D00
CONST KEYq& = &H71
CONST KEYESCAPE& = &H1B

' Our user defined type.
TYPE ObjectType
     x AS SINGLE
     y AS SINGLE
     speed AS SINGLE
END TYPE

DIM SHARED CircleM AS ObjectType
' We can't declare this variable with "Circle"
' since then QB64 can't differ it from 
' the statement CIRCLE, thus "CircleM".

SCREEN _NEWIMAGE(640, 480, 256) ' Sets the graphic mode

CircleM.x = 150   ' Initial circle position
CircleM.y = 90
CircleM.speed = 1.5 ' Circle's speed => 1 pixel per loop
_MOUSEHIDE ' hide the mouse cursor

DO

_LIMIT 60 ' limit FPS to 60
CLS ' clear the screen

CIRCLE (CircleM.x, CircleM.y), 10, 15 ' Draw circle on CircleM.x and CircleM.y,
                                      ' radius 10, color 15  
_DISPLAY

' According to pushed key we change the circle's coordinates.
IF _KEYDOWN(KEYRIGHT&) THEN CircleM.x = CircleM.x + CircleM.speed
IF _KEYDOWN(KEYLEFT&) THEN CircleM.x = CircleM.x - CircleM.speed
IF _KEYDOWN(KEYDOWN&) THEN CircleM.y = CircleM.y + CircleM.speed
IF _KEYDOWN(KEYUP&) THEN CircleM.y = CircleM.y - CircleM.speed

LOOP UNTIL _KEYDOWN(KEYq&) OR _KEYDOWN(KEYESCAPE&) ' Loop until the user presses Q or ESCAPE