#Include "fbgfx.bi"
#If __FB_LANG__ = "fb"
Using FB '' Scan code constants are stored in the FB namespace in lang FB
#EndIf
#Define SCREEN_WIDTH 320
#Define SCREEN_HEIGHT 200 
Function bmp_load( filename As String, ByRef bmpwidth As Integer, ByRef bmpheight As Integer ) As Any Ptr
    Dim As Integer filenum
    Dim As Any Ptr img
    filenum = Freefile()
    If Open( filename For Binary Access Read As #filenum ) <> 0 Then Return 0
        Get #filenum, 19, bmpwidth
        Get #filenum, 23, bmpheight
    Close #filenum                       
    img = ImageCreate( bmpwidth, Abs(bmpheight) )
    If img = 0 Then Return 0
    If BLoad( filename, img ) <> 0 Then ImageDestroy( img ): Return 0
    Return img
End Function 
Sub clears_image(scr As Any Ptr)
    Dim As Integer sw, sh
    Dim As Integer spitch, sbypp
    Dim spixels As Any Ptr
    If scr <> 0 Then
        ImageInfo( scr, sw, sh, sbypp, spitch, spixels )
    Else
        Screeninfo sw, sh, , sbypp, spitch
        spixels  = Screenptr()
    EndIf
    Dim i As Short
    For i=0 To sh-1 Step 1
        Dim j As Short
        For j=0 To sw-1 Step 1
            Dim spixpointer As UInteger Ptr
            spixpointer = (spixels+(i*spitch)+(j*sbypp))
            *spixpointer = 0 
        Next j
    Next i 
End Sub
Sub scroll_image(t0 As Any Ptr, t1 As Any Ptr, u As Integer, v As Integer)
    Dim As Integer w, h, size
    Dim As Integer pitch, bypp
    Dim As Any Ptr pixels, pixelsx, pixelsy
    ImageInfo( t0, w, h, bypp, pitch, pixels )
    Dim As Integer sw, sh
    Dim As Integer spitch, sbypp
    Dim As Any Ptr spixels, spixelsx, spixelsy
    If t1 <> 0 Then
        ImageInfo( t1, sw, sh, sbypp, spitch, spixels )
    Else
        Screeninfo sw, sh, , sbypp, spitch
        spixels  = Screenptr()
    EndIf
    Dim As UInteger Ptr matrixx, matrixy                  
    Dim spixpointer As UInteger Ptr 
    Dim pixpointer As UInteger Ptr
    Dim As Integer i, j, t0xoff, t0yoff 
    u=Abs(u Mod w)
    v=Abs(v Mod h)
    t0xoff = (u*bypp)
    t0yoff = (v*pitch)
    pixelsy = pixels + t0yoff
    spixelsy = spixels
    For i=v To v+h-1 Step 1
        If i=h-1 Then
            pixelsy = pixels
        EndIf    
        spixelsx = spixelsy
        pixelsx = pixelsy + t0xoff
        For j=u To u+w-1 Step 1
            If j=w-1 Then
                pixelsx = pixelsy
            EndIf
            pixpointer = pixelsx 
            spixpointer = spixelsx
            *spixpointer = *pixpointer            
            spixelsx = spixelsx+sbypp 
            pixelsx = pixelsx+bypp
        Next j      
        spixelsy = spixelsy+spitch
        pixelsy = pixelsy+pitch
    Next i  
End Sub 
#Define RGB_R( c ) ( CUInt( c ) Shr 16 And 255 )
#Define RGB_G( c ) ( CUInt( c ) Shr  8 And 255 )
#Define RGB_B( c ) ( CUInt( c )        And 255 ) 
Sub point_set(spixels As Any Ptr, sbypp As Integer, spitch As Integer, px As Integer, py As Integer, col As UInteger)
    Dim spixpointer As UInteger Ptr
    spixpointer = spixels + (px * sbypp) + (py * spitch)
    *spixpointer = col
End Sub
Function point_get(spixels As Any Ptr, sbypp As Integer, spitch As Integer, px As Integer, py As Integer) As UInteger
    Dim spixpointer As UInteger Ptr
    spixpointer = spixels + (px * sbypp) + (py * spitch)
    Return *spixpointer
End Function
Sub dither(s As Any Ptr)
    Dim As Integer sw, sh
    Dim As Integer spitch, sbypp
    Dim As Any Ptr spixels  
    If s <> 0 Then
        ImageInfo( s, sw, sh, sbypp, spitch, spixels )
    Else
        Screeninfo sw, sh, , sbypp, spitch
        spixels  = Screenptr()
    EndIf
    Dim t As Any Ptr
    t = ImageCreate(sw, sh) 
    Dim As Integer tw, th
    Dim As Integer tpitch, tbypp
    Dim As Any Ptr tpixels
    ImageInfo( t, tw, th, tbypp, tpitch, tpixels )      
    Dim As Short i, j     
    For j=1 To sh-1 Step 1
        For i=1 To sw-1 Step 1
            point_set(tpixels, tbypp, tpitch, i,j, Rgb((RGB_R(point_get(spixels, sbypp, spitch,i-1,j-1))+RGB_R(point_get(spixels, sbypp, spitch,i,j-1))+RGB_R(point_get(spixels, sbypp, spitch,i+1,j-1))+RGB_R(point_get(spixels, sbypp, spitch,i-1,j))+RGB_R(point_get(spixels, sbypp, spitch,i,j))+RGB_R(point_get(spixels, sbypp, spitch,i+1,j))+RGB_R(point_get(spixels, sbypp, spitch,i-1,j+1))+RGB_R(point_get(spixels, sbypp, spitch,i,j+1))+RGB_R(point_get(spixels, sbypp, spitch,i+1,j+1)))/9, (RGB_G(point_get(spixels, sbypp, spitch,i-1,j-1))+RGB_G(point_get(spixels, sbypp, spitch,i,j-1))+RGB_G(point_get(spixels, sbypp, spitch,i+1,j-1))+RGB_G(point_get(spixels, sbypp, spitch,i-1,j))+RGB_G(point_get(spixels, sbypp, spitch,i,j))+RGB_G(point_get(spixels, sbypp, spitch,i+1,j))+RGB_G(point_get(spixels, sbypp, spitch,i-1,j+1))+RGB_G(point_get(spixels, sbypp, spitch,i,j+1))+RGB_G(point_get(spixels, sbypp, spitch,i+1,j+1)))/9, (RGB_B(point_get(spixels, sbypp, spitch,i-1,j-1))+RGB_B(point_get(spixels, sbypp, spitch,i,j-1))+RGB_B(point_get(spixels, sbypp, spitch,i+1,j-1))+RGB_B(point_get(spixels, sbypp, spitch,i-1,j))+RGB_B(point_get(spixels, sbypp, spitch,i,j))+RGB_B(point_get(spixels, sbypp, spitch,i+1,j))+RGB_B(point_get(spixels, sbypp, spitch,i-1,j+1))+RGB_B(point_get(spixels, sbypp, spitch,i,j+1))+RGB_B(point_get(spixels, sbypp, spitch,i+1,j+1)))/9))    
        Next i
    Next j
    Put s, (0, 0), t, trans
    imageDestroy(t)
End Sub
Sub render_a_cloud(spixels As Any Ptr, sw As Integer, sh As Integer, spitch As Integer, sbypp As Integer, cx As Short, cy As Short, f As Short)
    Dim spixpointer As UInteger Ptr
    spixpointer = spixels + (cx*sbypp) + (cy*spitch)
    *spixpointer = Rgb(255-f,255-f,255-f)     
    If f > 0 Then
        If (cx+1 < sw) And (100*Rnd()) <= 90 Then
            spixpointer = spixels + ((cx+1)*sbypp) + (cy*spitch)
            If (RGB_R(*spixpointer) <> RGB_G(*spixpointer) And RGB_G(*spixpointer) <> RGB_B(*spixpointer) And RGB_R(*spixpointer) <> RGB_B(*spixpointer)) Or (RGB_R(*spixpointer) = 0 And RGB_G(*spixpointer) = 0 And RGB_B(*spixpointer) <> 0)  Then
                render_a_cloud(spixels, sw, sh, spitch, sbypp, cx+1, cy, f-1)
            EndIf    
        EndIf
        If (cx-1 > 0) And (100*Rnd()) <= 90 Then
            spixpointer = spixels + ((cx-1)*sbypp) + (cy*spitch)
            If (RGB_R(*spixpointer) <> RGB_G(*spixpointer) And RGB_G(*spixpointer) <> RGB_B(*spixpointer) And RGB_R(*spixpointer) <> RGB_B(*spixpointer)) Or (RGB_R(*spixpointer) = 0 And RGB_G(*spixpointer) = 0 And RGB_B(*spixpointer) <> 0) Then
                render_a_cloud(spixels, sw, sh, spitch, sbypp, cx-1, cy, f-1)
            EndIf    
        EndIf
        If (cy+1 < sh) And (100*Rnd()) <= 90 Then
            spixpointer = spixels + (cx*sbypp) + ((cy+1)*spitch)
            If (RGB_R(*spixpointer) <> RGB_G(*spixpointer) And RGB_G(*spixpointer) <> RGB_B(*spixpointer) And RGB_R(*spixpointer) <> RGB_B(*spixpointer)) Or (RGB_R(*spixpointer) = 0 And RGB_G(*spixpointer) = 0 And RGB_B(*spixpointer) <> 0) Then
                render_a_cloud(spixels, sw, sh, spitch, sbypp, cx, cy+1, f-1)
            EndIf    
        EndIf
        If (cy-1 > 0) And (100*Rnd()) <= 90 Then
            spixpointer = spixels + (cx*sbypp) + ((cy-1)*spitch)
            If (RGB_R(*spixpointer) = RGB_G(*spixpointer) And RGB_G(*spixpointer) = RGB_B(*spixpointer) And RGB_R(*spixpointer) <> RGB_B(*spixpointer)) Or (RGB_R(*spixpointer) = 0 And RGB_G(*spixpointer) = 0 And RGB_B(*spixpointer) <> 0) Then
                render_a_cloud(spixels, sw, sh, spitch, sbypp, cx, cy-1, f-1)
            EndIf    
        EndIf
    EndIf   
End Sub
Sub render_clouds(s As Any Ptr, clouds_seed As Short)
    Dim As Integer sw, sh
    Dim As Integer spitch, sbypp
    Dim As Any Ptr spixels, spixelsx, spixelsy  
    If s <> 0 Then
        ImageInfo( s, sw, sh, sbypp, spitch, spixels )
    Else
        Screeninfo sw, sh, , sbypp, spitch
        spixels  = Screenptr()
    EndIf                
    Dim spixpointer As UInteger Ptr 
    Dim As Short i, j 
    Randomize
    spixelsy = spixels
    For i=0 To sh-1 Step 1
        spixelsx = spixelsy
        For j=0 To sw-1 Step 1      
            spixpointer = spixelsx
            *spixpointer = Rgb(0,0,150+(100*Rnd()))            
            spixelsx = spixelsx+sbypp      
        Next j
        spixelsy = spixelsy + spitch
    Next i
    For i=0 To clouds_seed Step 1
        Dim As Short cx, cy
        cx = sw*Rnd()
        cy = sh*Rnd()
        render_a_cloud(spixels, sw, sh, spitch, sbypp, cx, cy, 255)        
    Next i  
End Sub  
Sub render_matrix(matrix As UInteger Ptr, t As Any Ptr, s As Any Ptr)
    Dim As Integer w, h, size
    Dim As Integer pitch, bypp
    Dim As Any Ptr pixels
    ImageInfo( t, w, h, bypp, pitch, pixels )
    Dim As Integer sw, sh
    Dim As Integer spitch, sbypp
    Dim As Any Ptr spixels, spixelsx, spixelsy
    If s <> 0 Then
        ImageInfo( s, sw, sh, sbypp, spitch, spixels )
    Else
        Screeninfo sw, sh, , sbypp, spitch
        spixels  = Screenptr()
    EndIf
    Dim As UInteger Ptr matrixx, matrixy                  
    Dim spixpointer As UInteger Ptr 
    Dim pixpointer As UInteger Ptr
    Dim As Short i, j
    spixelsy = spixels
    matrixy = matrix
    For i=0 To sh-1 Step 1    
        matrixx = matrixy
        spixelsx = spixelsy 
        For j=0 To sw-1 Step 1 
            If *matrixx <> -1 Then
                pixpointer = pixels + *matrixx
                spixpointer = spixelsx
                *spixpointer = *pixpointer 
            EndIf
            spixelsx = spixelsx+sbypp
            matrixx = matrixx+1
        Next j      
        spixelsy = spixelsy+spitch
        matrixy = matrixy+sw
    Next i  
End Sub
Function pre_render_horizon_plane(horizon As Integer, distance As Single, s As Any Ptr, img As Any Ptr, inverse As Short) As UInteger Ptr
    Dim As Integer w, h
    Dim As Integer pitch, bypp
    Dim pixels As Any Ptr
    ImageInfo( img, w, h, bypp, pitch, pixels ) 
    Dim pixpointer As UInteger Ptr 
    Dim As Integer sw, sh
    Dim As Integer spitch, sbypp 
    Dim spixels As Any Ptr
    If s <> 0 Then
        ImageInfo( s, sw, sh, sbypp, spitch, spixels )
    Else
        Screeninfo sw, sh, , sbypp, spitch
        spixels  = Screenptr()
    EndIf
    Dim spixpointer As UInteger Ptr        
    Dim As Integer i, j, sx, sy
    Dim As Single x, y, z, zinc, ix, iy, ixinc, iyinc      
    Dim As UInteger Ptr offset_matrix = Allocate(sw*sh*Sizeof(UInteger))
    iy = 0
    ixinc = w/sw : iyinc = h/(sh-horizon)
    z=1 : zinc=distance/(sh-horizon)
    For i=0 To horizon*sw Step 1
        *(offset_matrix + i) = -1
    Next i       
    For i=horizon To sh-1 Step 1
         ix = 0 : sy=(h/2)+((iy-(h/2))/z)
         If (sy < 0 Or sy >= h) Then                      
             While sy < 0
                sy = h+sy
             Wend 
             While sy >= h 
                sy = sy-h
             Wend  
         EndIf         
         For j=0 To sw-1 Step 1
            sx=(w/2)+((ix-(w/2))/z)
            If sx < 0 Or sx >= w Then              
                While sx < 0
                    sx = w+sx
                Wend 
                While sx >= w
                    sx = sx-w
                Wend
            EndIf       
            Dim As UInteger Ptr offset_matrix_pointer
            If inverse <> 0 Then
                offset_matrix_pointer = offset_matrix + ((i * sw) + j)
            Else
                offset_matrix_pointer = offset_matrix + (((sh-i) * sw) + j)
            EndIf
            *offset_matrix_pointer = (CShort(sy) * pitch) + (CShort(sx) * bypp)
            ix = ix+ixinc
         Next j          
         iy = iy+iyinc
         z=z+zinc        
    Next i  
    Return offset_matrix
End Function 
Sub scale_image(x As Short, y As Short, factor As Single, spr As Any Ptr, scr As Any Ptr)
    Dim As Integer i, j
    Dim As Integer w, h, wby2, hby2
    Dim As Integer pitch, bypp
    Dim As Any Ptr pixels, pixelsx, pixelsy
    ImageInfo( spr, w, h, bypp, pitch, pixels )
    wby2=w/2 : hby2=h/2
    Dim As Integer sw, sh
    Dim As Integer spitch, sbypp
    Dim As Any Ptr spixels
    If scr <> 0 Then
        ImageInfo( scr, sw, sh, sbypp, spitch, spixels )
    Else
        Screeninfo sw, sh, , sbypp, spitch
        spixels  = Screenptr()
    EndIf
    Dim spixpointer As UInteger Ptr 
    Dim pixpointer As UInteger Ptr
    Dim As Single sx, sy, sxx, syy
        pixelsy = pixels
        For i=-hby2+1 To hby2 Step 1
            Dim As Single sy_cos, sy_sin
            sy = y+(CSng(i)*factor) 
            pixelsx = pixelsy
            For j=-wby2+1 To wby2 Step 1
                pixpointer = pixelsx
                If *pixpointer <> Rgb(255,0,255) Then 
                    sx = x+(CSng(j)*factor)                         
                    If sx >= 0 And sx <= SCREEN_WIDTH-1 And sy >= 0 And sy <= SCREEN_HEIGHT-1 Then
                        spixpointer = spixels + (CShort(sy) * spitch) + (CShort(sx) * sbypp)
                        *spixpointer = *pixpointer
                    EndIf
                EndIf
                pixelsx = pixelsx + bypp
            Next j
            pixelsy = pixelsy+pitch 
        Next i
End Sub
Type player_state
    id_player As Short
    w As Single
    winc As Single
    wheel As Single
    side As Single
    phase As Single
    car As Any Ptr
    section As Single
    iter As Single
    cycles As Single
    speed As Single 
    fuel As Single
    lap As Single
    tire_00 As Single
    tire_01 As Single
    tire_10 As Single
    tire_11 As Single
    time_to_finish As Single
    state As Short
    player_name As String 
    other_player As player_state Ptr
End Type 
Dim Shared As Any Ptr ground_layer_a, ground_layer_d
Dim Shared As Any Ptr ground_layer_b_1, ground_layer_c_1 
Dim Shared As Any Ptr ground_layer_b_2, ground_layer_c_2
Dim Shared As Any Ptr ground_layer_g_1, ground_layer_g_2  
Dim Shared As Any Ptr ground_layer_e
Dim Shared As Any Ptr ground_layer_f
Dim Shared As Any Ptr window_player_1, window_player_2
Dim Shared As Any Ptr pit
Dim Shared As UInteger Ptr ground_matrix
Dim Shared As Short players = 1
Dim Shared As Single timer_control = 1, current_timer
Dim Shared As LongInt iter=0
Dim Shared As Short laps_to_go = 0
Dim Shared As Short sections_track
Dim Shared As Short len_track
Dim Shared As Single track0(12) = { 0, 90, -45, -60, 0, 30, -65, -90, 0, 0, 0, -20 } 
Dim Shared As Single track1(24) = { 0, -20, -80, 0, 30, 30, 0, 0, 10,  0, 0, 0, 0, 0, 0, 10, -90, 0, 0, 70, 0, 0, -5, 0, 0 }
Dim Shared As Single track2(18) = { 20, 25, 35, 0, -20, 0, 90, 25, 0, 0, 0, 0, 5, -5, -50, -50, 20, 0 }  
Dim Shared As Single track3(23) = { -90, 0, 70, 0, -50, 0, 90, 0, -90, 0, 0, -10, 0, 0, 0, 0, 0, 0, 90, 0, 0, -1, 0 }
Dim Shared As Short track_id
Dim Shared As Single Ptr the_track  
Dim Shared As player_state player1, player2
Dim Shared As String record_name(3)
Dim Shared As Single record_avg(3)
record_avg(0)=-1:record_avg(1)=-1:record_avg(2)=-1:record_avg(3)=-1
Sub render_track(w As Single, r As Single, phase As Short, s As Any Ptr)
    Dim As Single ww, winc = Abs(w)/SCREEN_HEIGHT, x = 0, y = 0, rr=r, rinc=1
    ww=w
    For y = SCREEN_HEIGHT To 0 Step -1
        x=-((SCREEN_WIDTH/2)-rr)*Sin(-ww)
        If w < 0 Then
            ww+=winc
        Else
            ww-=winc
        EndIf 
        Dim As LongInt c1, c2
        If ((phase+y)/25) Mod 2 = 0 Then
            c1 = Rgb(255,0,0)
        Else
            c1 = Rgb(255,255,0)
        EndIf
        If ((phase+y)/30) Mod 2 = 0 Then
            c2 = Rgb(255,255,255)
        Else
            c2 = Rgb(255,0,255)
        EndIf
        Line s, ((SCREEN_WIDTH-r)+(x)+5, y)-(r+x-5, y), Rgb(255,0,255)
        Line s, ((SCREEN_WIDTH-r)+(x)-5, y)-((SCREEN_WIDTH-r)+(x)+5, y), c1                           
        Pset s, ((SCREEN_WIDTH-r)+(x)-5, y), Rgb(0,0,0)
        Pset s, ((SCREEN_WIDTH-r)+(x)+5, y), Rgb(0,0,0)  
        Line s, (r+x-5, y)-(r+x+5, y), c1
        Pset s, (r+x-5, y), Rgb(0,0,0)
        Pset s, (r+x+5, y), Rgb(0,0,0)  
        Rem Pset s, (r+x, y), Rgb(255,255,255)
        Line s, ((SCREEN_WIDTH/2)+x-2, y)-((SCREEN_WIDTH/2)+x+2, y), c2
        rr+=rinc
    Next y    
End Sub
Function creates_a_layer(layer_name As String) As Any Ptr
    Dim As Any Ptr layer = imagecreate(SCREEN_WIDTH, SCREEN_HEIGHT)
    Dim As Any Ptr tex = bmp_load(layer_name, 64, 64)
    Dim As Short i, j
    For i=0 To SCREEN_HEIGHT Step 64
        For j=0 To SCREEN_WIDTH Step 64
            Put layer, (j,i), tex, Pset
        Next j
    Next i
    imagedestroy(tex)
    dither(layer)
    Return layer
End Function
Function creates_fog_layer(horizon As Short, height As Short, range As Short) As Any Ptr
    Dim As Any Ptr layer = imagecreate(SCREEN_WIDTH, height)
    Dim As Short i, j
    Dim As Single c, cinc
    c = 0 : cinc = range/horizon
    For i=height To 0 Step -1
        Line layer, (0,i)-(SCREEN_WIDTH,i), Rgb(c,c,c)
        If c <= range Then
            c += cinc
        EndIf
    Next i
    Return layer
End Function
Function creates_back_layer(horizon As Short) As Any Ptr
    Dim As Any Ptr layer = imagecreate(SCREEN_WIDTH+50, horizon)
    Dim As Short i
    render_clouds(layer, 10)
    Dim As Single h = Rnd()
    For i=0 To SCREEN_WIDTH+50 Step 1
        If h < 5 Then
            h = 5
        EndIf
        Line layer, (i, horizon-h)-(i, horizon), Rgb(32,128,32)
        Dim As Short j
        For j=0 To 50*Rnd()
            Pset layer, (i, horizon-(h*Rnd())), Rgb(64*Rnd(), 255*Rnd(), 64*Rnd())
        Next j
        If i Mod 32 >= 16 Then
            h-=Rnd()
        Else 
            h+=Rnd()
        EndIf     
    Next i 
    dither(layer)
    Line layer, (0, horizon-1)-(SCREEN_WIDTH, horizon-1), Rgb(0,0,0)
    Return layer
End Function
Sub render_mini_track(layer As Any Ptr, x0 As Single, y0 As Single, p1 As player_state Ptr, p2 As player_state Ptr, secs As Short, track As Single Ptr)
    Dim As Short i
    Dim As Integer cycles = 0
    Dim As Single w = 0, winc, x=x0, y=y0
    cycles=0
    For i=0 To secs-1 Step 1
        If *(track+i) = 0 And i <> 0 Then
            winc = 0
        Else
            If Sgn(w) <> Sgn(*(track+i)) Then
                winc=(*(track+i)-w)/10
            Else 
                winc=(*(track+i)+w)/10
            EndIf
        EndIf 
        Dim As Single b_w, b_cycles, b_x, b_y
        Dim j As Short 
        b_w = w : b_cycles = cycles : b_x = x : b_y = y
        For j=0 To 9 Step 1
            x+=1*Cos(w*0.017)
            y+=1*Sin(w*0.017)
            Pset layer, (x, y), Rgb(254,254,254)
            w+=winc
            cycles+=10
        Next j
        w = b_w : cycles = b_cycles : x = b_x : y = b_y
        For j=0 To 9 Step 1
            x+=1*Cos(w*0.017)
            y+=1*Sin(w*0.017)
            If Point (x, y-1, layer) <> Rgb(254,254,254) Then
                Pset layer, (x, y-1), Rgb(0,0,0)
            EndIf
            If Point (x, y+1, layer) <> Rgb(254,254,254) Then
                Pset layer, (x, y+1), Rgb(0,0,0)
            EndIf
            If Point (x-1, y, layer) <> Rgb(254,254,254) Then
                Pset layer, (x-1, y), Rgb(0,0,0)
            EndIf
            If Point (x+1, y, layer) <> Rgb(254,254,254) Then
                Pset layer, (x+1, y), Rgb(0,0,0)
            EndIf
            w+=winc
            cycles+=10 
         Next j
         w = b_w : cycles = b_cycles : x = b_x : y = b_y 
         Dim As LongInt colors(2) = { Rgb(255,0,0), Rgb(0,255,0) }
         For j=0 To 9 Step 1
            x+=1*Cos(w*0.017)
            y+=1*Sin(w*0.017)
            If cycles=0 Then
                Line layer, (x-1,y-3)-(x+1,y+3), Rgb(255,255,255), BF 
                Line layer, (x-1,y-3)-(x+1,y+3), Rgb(0,0,0), B
            EndIf
            If iter Mod 2 = 0 Then
                If p1 <> 0 Then
                    If p1->cycles >= cycles And p1->cycles < cycles+10 Then
                        Line layer, (x-1,y-1)-(x+1,y+1),colors(p1->id_player-1), BF 
                    EndIf
                EndIf
                If p2 <> 0 Then
                    If p2->cycles >= cycles And p2->cycles < cycles+10 Then
                        Line layer, (x-1,y-1)-(x+1,y+1), colors(p2->id_player-1), BF 
                    EndIf
                EndIf
            Else
                If p2 <> 0 Then
                    If p2->cycles >= cycles And p2->cycles < cycles+10 Then
                        Line layer, (x-1,y-1)-(x+1,y+1), colors(p2->id_player-1), BF 
                    EndIf
                EndIf
                If p1 <> 0 Then
                    If p1->cycles >= cycles And p1->cycles < cycles+10 Then
                        Line layer, (x-1,y-1)-(x+1,y+1),colors(p1->id_player-1), BF 
                    EndIf            
                EndIf
            EndIf
            w+=winc
            cycles+=10 
         Next j
    Next i
End Sub 
Sub init_player(x As player_state Ptr, wheel As Single, id_player As Short, cr As Short, cg As Short, cb As Short, other_player As player_state Ptr)
    Dim As Any Ptr a_car = bmp_load("pitstop_car.bmp", 50, 20) 
    x->car = imagecreate(50,20)
    Put x->car, (0,0), a_car, Pset
    imagedestroy(a_car)
    x->id_player = id_player
    Dim As Short i, j
    For i=0 To 19
        For j=0 To 49
            Dim As Integer c  
            c = Point(j,i,x->car)
            If c <> Rgb(255,0,255) And c <> Rgb(0,0,0) And c <> Rgb(255,255,255) Then
                Dim As Short r, g, b
                r = RGB_R(c)+cr
                g = RGB_G(c)+cg
                b = RGB_B(c)+cb
                If r > 255 Then
                    r = 255
                EndIf
                If g < 0 Then
                    g = 0
                EndIf
                If b < 0 Then
                    b = 0
                EndIf 
                Pset x->car, (j,i), Rgb(r, g, b)
            EndIf 
        Next j
    Next i 
    Draw String x->car, (22, 7), Str(id_player), Rgb(0,0,255)
    x->fuel=5000 
    x->other_player = other_player
    x->wheel = wheel
    x->w = 0
    x->winc = 0
    x->side = 0
    x->phase = 0
    x->section = 0
    x->iter = 0
    x->cycles = 0
    x->speed = 0
    x->lap = 0
    x->tire_00 = 0
    x->tire_01 = 0
    x->tire_10 = 0
    x->tire_11 = 0
    x->state = 0
    x->time_to_finish = 0   
End Sub
Function time_to_string(a_time As Single) As String
    Dim As short minutes, seconds
    minutes=Valint(Str(a_time/60))
    seconds=Valint(Str((a_time-(minutes*60))))
    Return Str(minutes)+":"+Str(seconds)
End Function
Sub render_player(x As player_state Ptr, split As Short, window_player As Any Ptr)
    scroll_image(ground_layer_d, ground_layer_c_1, 0, 200+(x->phase Mod 200))
    render_track(x->w*0.017, 100, x->phase, ground_layer_c_1)
    scroll_image(ground_layer_a, ground_layer_b_1, 0, 200+(x->phase Mod 200))
    Put ground_layer_b_1, (0,0), ground_layer_c_1, trans
    render_matrix(ground_matrix, ground_layer_b_1, window_player)
    scroll_image(ground_layer_f, ground_layer_g_1, 370+((x->w/4) Mod 370), 200) 
    Put window_player, (-25,0), ground_layer_g_1, Pset
    Dim l As Short
    If split <> 0 Then  
        If x->section = sections_track And x->other_player->section = 0 Then
            If x->other_player->cycles+(len_track-x->cycles) < 65 Then    
                scale_image(160+(x->other_player->wheel*((100-(x->other_player->cycles+(len_track-x->cycles)))*0.01)),89-((x->other_player->cycles+(len_track-x->cycles))*(1/1.5)),1-((x->other_player->cycles+(len_track-x->cycles))*0.005),x->other_player->car,window_player)
            EndIf
        Else         
            If x->other_player->cycles >= x->cycles And x->other_player->cycles-x->cycles < 65 Then
                scale_image(160+(x->other_player->wheel*((100-(x->other_player->cycles-x->cycles))*0.01)),89-((x->other_player->cycles-x->cycles)*(1/1.5)),1-((x->other_player->cycles-x->cycles)*0.005),x->other_player->car,window_player)
            EndIf
        EndIf
        scale_image(160+x->wheel,89,1,x->car,window_player)
        If x->section = sections_track Then
            If len_track-x->cycles < 65 Then
                scale_image(160+(230*((100-(len_track-x->cycles))*0.01)),89-((len_track-x->cycles)*(1/1.5)),1-((len_track-x->cycles)*0.01),pit,window_player)
            EndIf     
        EndIf     
    Else
        If x->section >= sections_track-1 And x->other_player->section <= 1 Then
            If x->other_player->cycles+(len_track-x->cycles) < 140 Then
                scale_image(160+(x->other_player->wheel*((200-(x->other_player->cycles+(len_track-x->cycles)))*0.005)),189-(((x->other_player->cycles+(len_track-x->cycles)))*(1/1.5)),1-((x->other_player->cycles+(len_track-x->cycles))*0.005),x->other_player->car,window_player)
            EndIf
        Else         
            If x->other_player->cycles >= x->cycles And x->other_player->cycles-x->cycles < 140 Then
                scale_image(160+(x->other_player->wheel*((200-(x->other_player->cycles-x->cycles))*0.005)),189-((x->other_player->cycles-x->cycles)*(1/1.5)),1-((x->other_player->cycles-x->cycles)*0.005),x->other_player->car,window_player)
            EndIf
        EndIf
        scale_image(160+x->wheel,189,1,x->car,window_player)
        If x->section >= sections_track-1 Then
            If len_track-x->cycles < 140 Then
                scale_image(160+(230*((200-(len_track-x->cycles))*0.005)),189-((len_track-x->cycles)*(1/1.5)),1-((len_track-x->cycles)*0.005),pit,window_player)
            EndIf     
        EndIf           
    EndIf
    Put window_player, (0,0), ground_layer_e, alpha, 90
    rem render_mini_track(window_player,280,25,x,x->other_player,track0())
    If track_id = 0 Then
        render_mini_track(window_player,280,25,x,x->other_player,sections_track,the_track)
    ElseIf track_id = 1 Then
        render_mini_track(window_player,280,30,x,x->other_player,sections_track,the_track)
    ElseIf track_id = 2 Then
        render_mini_track(window_player,280,10,x,x->other_player,sections_track,the_track)
    ElseIf track_id = 3 Then
        render_mini_track(window_player,260,40,x,x->other_player,sections_track,the_track)
    EndIf
    Draw String window_player, (5, 5), "SPEED "+Str(CInt(x->speed*15))+" mph "+"LAP "+Str(x->lap)+"/"+Str(laps_to_go)+" TIME "+time_to_string(x->time_to_finish), Rgb(0, 0, 0)
    Draw String window_player, (5, 15), "NAME "+x->player_name+" AVG "+time_to_string(x->time_to_finish/laps_to_go), Rgb(0, 0, 0)
    If record_avg(track_id) >= 0 Then
        Draw String window_player, (5, 25), "BEST "+record_name(track_id)+" AVG "+time_to_string(record_avg(track_id)), Rgb(0,0,0)
    EndIf
    Draw String window_player, (5, 35), "FUEL ", Rgb(0, 0, 0)
    Line window_player, (45, 35)-(46+101,40), Rgb(0,0,0), BF
    Dim i As Short
    For i=0 To (x->fuel*100)/5000 
        Line window_player, (46+i, 36)-(46+i,39), Rgb(100+i,50+i,0)
    Next i
    If split <> 0 Then
        If x->id_player = 1 Then
            Put (0,0), window_player, Pset
        Else
            Put (0,100), window_player, Pset
        EndIf
    Else
        Put (0,0), window_player, Pset
    EndIf
End Sub
Sub iteract_player(x As player_state Ptr, human As Short)
    If x->lap < laps_to_go Then
        If x->cycles >= 1150 And x->cycles <= len_track And x->wheel = 130 And x->speed = 0 Then
            If x->fuel < 5000 Then
                x->fuel += 10
                If x->fuel > 5000 Then
                    x->fuel = 5000
                EndIf
            EndIf
            x->tire_00-=1
            x->tire_01-=1
            x->tire_10-=1
            x->tire_11-=1
            If x->tire_00 < 0 Then
                x->tire_00=0    
            EndIf 
            If x->tire_01 < 0 Then
                x->tire_01=0
            EndIf
            If x->tire_10 < 0 Then
                x->tire_10=0
            EndIf
            If x->tire_11 < 0 Then
                x->tire_11=0
            EndIf
        EndIf      
        If x->cycles > len_track Then
            x->cycles -= len_track
            x->lap+=1 
        EndIf
        If x->fuel > 0 Then 
            x->time_to_finish = Timer-current_timer
            If *(the_track+CInt(x->section)) <= 0 Then
                If x->w > *(the_track+CInt(x->section)) Then
                    x->w-=.9*x->speed
                EndIf
            EndIf
            If *(the_track+CInt(x->section)) >= 0 Then
                If x->w < *(the_track+CInt(x->section)) Then
                    x->w+=.9*x->speed
                EndIf
            EndIf
            x->side=-(x->w/90)*((x->speed*x->speed)/5)
            If x->side+x->wheel > -130 And x->side+x->wheel < 130 Then 
                x->wheel+=x->side 
            Else
                If Not (x->cycles >= 1150 And x->cycles <= len_track And x->speed = 0) And x->side+x->wheel < -130 Then
                    x->wheel = -130 
                    x->tire_00 += 10*Rnd()
                    x->tire_01 += 10*Rnd()
                    If x->tire_00 > 255 Then
                        x->tire_00 = 255
                    EndIf
                    If x->tire_01 > 255 Then
                        x->tire_01 = 255
                    EndIf
                ElseIf Not (x->cycles >= 1150 And x->cycles <= len_track And x->speed = 0) And x->side+x->wheel > 130 Then
                    x->tire_10 += 10*Rnd()
                    x->tire_11 += 10*Rnd()
                    x->wheel = 130
                    If x->tire_10 > 255 Then
                        x->tire_10 = 255
                    EndIf
                    If x->tire_11 > 255 Then
                        x->tire_11 = 255
                    EndIf                 
                EndIf
                x->speed-=1
                If x->speed < 0 Then
                    x->speed=0
                EndIf
            EndIf
            If human <> 0 Then 
                If (x->id_player = 1 And Multikey(SC_UP)) Or (x->id_player = 2 And Multikey(SC_W)) Then
                    x->speed+=.1
                    If x->speed > 10 Then
                        x->speed=10
                    EndIf    
                ElseIf (x->id_player = 1 And Multikey(SC_DOWN)) Or (x->id_player = 2 And Multikey(SC_S)) Then 
                    x->speed-=.1
                    If x->speed < 0 Then
                        x->speed=0
                    EndIf
                EndIf
                If (x->id_player = 1 And Multikey(SC_LEFT)) Or (x->id_player = 2 And Multikey(SC_A)) Then
                    x->wheel-=x->speed*(1-((x->tire_00+x->tire_01)/512))
                    If x->wheel < -130 Then
                        x->wheel=-130
                    EndIf
                ElseIf (x->id_player = 1 And Multikey(SC_RIGHT)) Or (x->id_player = 2 And Multikey(SC_D)) Then
                    x->wheel+=x->speed*(1-((x->tire_10+x->tire_11)/512))
                    If x->wheel > 130 Then
                        x->wheel=130
                    EndIf
                EndIf
            Else
                If x->state = 1 Then
                    If x->fuel>=((laps_to_go-x->lap)*len_track)-len_track Or x->fuel = 5000 Then
                        x->state = 2
                    EndIf
                ElseIf x->state = 2 Then
                    x->speed+=.1
                    If x->speed > 10 Then
                        x->speed = 10
                    EndIf
                    If x->wheel > 0 Then
                        x->wheel-=x->speed*(1-((x->tire_00+x->tire_01)/512))
                    Else
                        x->state = 0
                    EndIf                   
                ElseIf x->cycles > len_track-50 And x->cycles <= len_track And (x->fuel < len_track And laps_to_go-x->lap > 1) And x->speed = 0 And x->wheel = 130 And x->state = 0 Then
                    x->state = 1
                ElseIf x->cycles > len_track-200 And x->cycles <= len_track And (x->fuel < len_track And laps_to_go-x->lap > 1) And x->state = 0 Then
                    x->speed-=.1
                    If x->speed < 1 Then
                        x->speed = 1
                    EndIf
                    If x->side+x->wheel < 130 Then
                        x->wheel+=x->speed*(1-((x->tire_00+x->tire_01)/512))
                    EndIf 
                Else
                    If x->side-x->wheel > Rnd(1)*x->speed Then
                        x->wheel+=x->speed*(1-((x->tire_00+x->tire_01)/512))
                    ElseIf x->side-x->wheel < Rnd(1)*-x->speed Then
                        x->wheel-=x->speed*(1-((x->tire_00+x->tire_01)/512))
                    EndIf
                    If x->speed = 0 Then
                        x->speed+=.1
                    ElseIf x->side < x->speed Then
                        If x->speed < 10 Then
                            x->speed+=.1
                        Else
                            x->speed=10
                        EndIf
                    Else
                        If x->speed < 1 Then
                            x->speed+=.1
                        EndIf
                    EndIf          
                EndIf
            EndIf
            If x->section = sections_track And x->other_player->section = 0 Then
                If (len_track-x->cycles)+x->other_player->cycles <= 20 And x->wheel >= x->other_player->wheel-40 And x->wheel <= x->other_player->wheel+40 Then
                    x->speed=0
                EndIf
            Else
                If x->other_player->cycles >= x->cycles And x->other_player->cycles-x->cycles <= 20 And x->wheel >= x->other_player->wheel-40 And x->wheel <= x->other_player->wheel+40 Then
                    x->speed=0
                EndIf
            EndIf 
            x->phase-=x->speed 
            x->iter+=x->speed
            x->cycles+=x->speed 
            x->fuel-=(x->speed*x->speed)/10
            If x->iter > 100 Then
                x->iter-=100
                x->section+=1 
                If x->section = (len_track/100) Then
                    x->section = 0
                EndIf
                x->winc=(*(the_track+CInt(x->section))-x->w)/100
            EndIf
        Else
            x->fuel=0
            x->speed=0        
        EndIf
        Line x->car, (8,6)-(10,9), Rgb(x->tire_00, 1, x->tire_00), BF
        Line x->car, (1,10)-(6,18), Rgb(x->tire_01, 1, x->tire_01), BF
        Line x->car, (39,6)-(41,9), Rgb(x->tire_10, 1, x->tire_10), BF
        Line x->car, (43,10)-(48,18), Rgb(x->tire_11, 1, x->tire_11), BF
        Dim As Short i, j
        If x->speed = 0 Then
            j = 0
        Else
            j = iter
        EndIf
        For i=0 To 8
            If j Mod 2 = 0 Then
                Line x->car, (1,10+i)-(6,10+i), Rgb(128, 128, 128), B, &b1100001100001100
            Else
                Line x->car, (1,10+i)-(6,10+i), Rgb(128, 128, 128), B, &b0011110011110011
            EndIf  
            If j Mod 2 = 1 Then
                Line x->car, (43,10+i)-(48,10+i), Rgb(128, 128, 128), B, &b1100001100001100
            Else
                Line x->car, (43,10+i)-(48,10+i), Rgb(128, 128, 128), B, &b0011110011110011
            EndIf
            j=j+1           
        Next i
    Else
        If x->time_to_finish/laps_to_go < record_avg(track_id) Or record_avg(track_id) < 0 Then
            record_avg(track_id) = x->time_to_finish/laps_to_go
            record_name(track_id) = x->player_name 
        EndIf   
    endif
End Sub
Type text_field
    As Short x, y 
    As Short cursor_text
    As Short len_text
    As Short insert_state
    As ZString Ptr str_text
End Type

Function set_text_field(x As Short, y As Short, l As Short) As text_field Ptr
    Dim i As Short
    Dim As text_field Ptr tf = Allocate(Sizeof(text_field))
    tf->x = x : tf->y = y
    tf->cursor_text = 0
    tf->len_text = l 
    tf->insert_state = 1
    tf->str_text = Allocate(l)
    For i=0 To l-1 Step 1
        *(tf->str_text+i) = 32
    Next i
    *(tf->str_text+l)=0
    Return tf
End Function 

Sub show_text_field(x As text_field Ptr, inv_video As Byte)
    Dim i As Integer
    Line (x->x, x->y)-(x->x+(x->len_text*8), x->y), Rgb(255,255,255)
    Line (x->x, x->y)-(x->x, x->y+10), Rgb(255,255,255)
    Line (x->x+(x->len_text*8), x->y)-(x->x+(x->len_text*8), x->y+10), Rgb(255,255,255)
    Line (x->x, x->y+10)-(x->x+(x->len_text*8), x->y+10), Rgb(255,255,255)
    If inv_video <> 0 Then
        Color Rgb(255,255,255)
    Else
        Color Rgb(0,0,0)
    EndIf
    For i=1 To 9 Step 1
        Line (x->x+1, x->y+i)-(x->x+(x->len_text*8)-1, x->y+i)
    Next i
    If inv_video = 0 Then
        Color Rgb(255,255,255)
    Else
        Color Rgb(0,0,0)
    EndIf 
    For i=0 To x->len_text-1 Step 1
        If i=x->cursor_text Then 
            If x->insert_state = 1 Then
                Draw String (x->x+(i*8),x->y+1), "_"
            Else
                Draw String (x->x+(i*8),x->y+1), Chr(220)
            EndIf       
        EndIf 
        If *(x->str_text+i) = 0 Then
            Draw String (x->x+(i*8),x->y+1),  " "
        Else
            Draw String (x->x+(i*8),x->y+1), Str(*(x->str_text+i))
        End If    
    Next i
End Sub 

Sub accept_char(x As text_field Ptr, char As String)
    If char = Chr(255) + "M" Then 
        If x->cursor_text+1 < x->len_text Then
            x->cursor_text=x->cursor_text+1
        EndIf
    ElseIf char = Chr(255) + "K" Then
        If x->cursor_text-1 >= 0 Then
            x->cursor_text=x->cursor_text-1
        EndIf
    ElseIf char = Chr(8) Then 
        Dim i As Integer
        If x->cursor_text-1 >= 0 Then
            For i=x->cursor_text-1 To x->len_text-2 Step 1
                *(x->str_text+i) = *(x->str_text+i+1)    
            Next i
            *(x->str_text+i) = 0
            x->cursor_text=x->cursor_text-1 
        EndIf
    ElseIf char = Chr(255) + "S" Then
        Dim i As Integer
        For i=x->cursor_text To x->len_text-1 Step 1
            *(x->str_text+i) = *(x->str_text+i+1)    
        Next i   
    ElseIf char = Chr(255) + "R" Then
        If x->insert_state = 0 Then
            x->insert_state = 1
        Else
            x->insert_state = 0
        EndIf
    ElseIf char >= Chr(32) And char <= ""  Then
        Dim i As Integer
        If x->insert_state <> 0 Then
            For i=x->len_text-1 To x->cursor_text+1 Step -1
                Rem *(x->str_text+i) = *(x->str_text+i-1)    
            Next i
            *(x->str_text+x->len_text)=0 
        EndIf
        *(x->str_text+x->cursor_text) = Asc(char)
        If x->cursor_text+1 < x->len_text Then
            x->cursor_text = x->cursor_text+1
        EndIf
    EndIf
End Sub

Function filter_numeric(char As String) As Byte
    If (char >= "0" And char <= "9") Or char = Chr(8) Or (char = Chr(255) + "M")Or (char = Chr(255) + "K") Or (char = Chr(255) + "R") Or (char = Chr(255) + "S") Or (char = Chr(8))Then
        Return 1
    Else
        Return 0
    EndIf
End Function

Function filter_alphabetic(char As String) As Byte
    If (char >= "a" And char <= "z") Or (char >= "A" And char <= "Z") Or (char >= "" And char <= "") Or (char >= "" And char <= "") Or char = "" Or char = "" Or (char = Chr(255) + "R") Or (char = Chr(255) + "S") Or char = Chr(8) Or char = Chr(32) Or char = Chr(255) + "M" Or char = Chr(255) + "K" Then
        Return 1
    Else
        Return 0
    EndIf
End Function
Function enter_game_settings As Short
    Dim As Short rval = 1
    Dim i As Short 
    Dim campos(3) As text_field Ptr
    Screenset 0, 0
    Cls              
    campos(0) = set_text_field(21*8, 16*8, 2)
    campos(1) = set_text_field(21*8, 18*8, 15)
    campos(2) = set_text_field(21*8, 20*8, 15)
    Color Rgb(255,255,255), Rgb(0,0,0)
    For i=1 To 207 Step 1
        Line (23, 180+i)-(777, 180+i), Rgb(0,0,0)
    Next i
    Locate 0, 0 : Print "* PITSTOP 2000  by Ivan Bermejo Bolado *" 
    Locate 24, 6 : Print "One player!"
    Locate 24, 18 : Print "Two player!" 
    Locate 24, 30 : Print "Exit!"
    Locate 17, 7 : Print "How many laps?"
    Locate 19, 4 : Print "Name of player #1" 
    Locate 21, 4 : Print "Name of player #2"
    Dim As Short focus = 0, check_list = 0
    While 1
        Dim As String input_char
        Dim As Short k=0
        For i=0 To 1
            Dim j As Short
            For j=0 To 1
                If k=focus Then                                                                    
                    Line (60+(i*100),16+(j*50))-(60+((i+1)*100),16+((j+1)*50)), Rgb(255,255,255), BF
                    If check_list=k Then
                       Line (60+(i*100),16+(j*50))-(60+((i+1)*100),16+((j+1)*50)), Rgb(0,0,0)
                       Line (60+(i*100),16+((j+1)*50))-(60+((i+1)*100),16+(j*50)), Rgb(0,0,0)
                    EndIf
                Else
                    Line (60+(i*100),16+(j*50))-(60+((i+1)*100),16+((j+1)*50)), Rgb(0,0,0), BF
                    Line (60+(i*100),16+(j*50))-(60+((i+1)*100),16+((j+1)*50)), Rgb(255,255,255), B
                    If check_list=k Then
                       Line (60+(i*100),16+(j*50))-(60+((i+1)*100),16+((j+1)*50)), Rgb(255,255,255)
                       Line (60+(i*100),16+((j+1)*50))-(60+((i+1)*100),16+(j*50)), Rgb(255,255,255)
                    EndIf
                EndIf
                If k=0 Then
                    render_mini_track(0,100,50,0,0,12, @track0(0))
                ElseIf k=1 Then
                    render_mini_track(0,110,98,0,0,24, @track1(0))
                ElseIf k=2 Then
                    render_mini_track(0,205,30,0,0,18, @track2(0))  
                ElseIf k=3 Then
                    render_mini_track(0,195,105,0,0,23, @track3(0))                       
                EndIf
                k+=1
            Next j
        Next i        
        For i=0 To 2 Step 1
            If i+4=focus Then
                show_text_field(campos(i),0)  
            Else
                show_text_field(campos(i),1)
            EndIf
        Next i
        Do 
            input_char = inkey
        Loop Until input_char <> ""
        If input_char = Chr(13) Then 
            If focus < 4 Then
                check_list = focus
            ElseIf focus = 7 Or focus = 8 Then
                If focus = 7 Then
                    players=1
                ElseIf focus = 8 Then
                    players=2
                EndIf
                laps_to_go = Valint(*campos(0)->str_text)
                If laps_to_go > 0 Then
                    Exit While
                EndIf 
            ElseIf focus = 9 Then
                rval = 0
                Exit While
            EndIf
        EndIf              
        If input_char = Chr(9) Or input_char = Chr(13) Then
            If focus < 7 Then
                If focus = 6 Then
                    Color Rgb(0,0,0), Rgb(255,255,255) : Locate 24, 6 : Print "One player!"
                    Color Rgb(255,255,255), Rgb(0,0,0) : Locate 24, 18 : Print "Two player!"
                    Color Rgb(255,255,255), Rgb(0,0,0) : Locate 24, 30 : Print "Exit!"
                EndIf
                focus+=1
            ElseIf focus = 7 Then
                Color Rgb(255,255,255), Rgb(0,0,0) : Locate 24, 6 : Print "One player!"
                Color Rgb(0,0,0), Rgb(255,255,255) : Locate 24,18 : Print "Two player!"
                Color Rgb(255,255,255), Rgb(0,0,0) : Locate 24,30 : Print "Exit!"
                focus=8
            ElseIf focus = 8 Then
                Color Rgb(255,255,255), Rgb(0,0,0) : Locate 24, 6 : Print "One player!"
                Color Rgb(255,255,255), Rgb(0,0,0) : Locate 24,18 : Print "Two player!"
                Color Rgb(0,0,0), Rgb(255,255,255) : Locate 24,30 : Print "Exit!"         
                focus=9
            ElseIf focus = 9 Then 
                Color Rgb(255,255,255), Rgb(0,0,0) : Locate 24, 6 : Print "One player!"
                Color Rgb(255,255,255), Rgb(0,0,0) : Locate 24,18 : Print "Two player!"
                Color Rgb(255,255,255), Rgb(0,0,0) : Locate 24,30 : Print "Exit!"             
                focus=0    
            EndIf
        Else
            If focus = 4 Then
                If filter_numeric(input_char) <> 0 Then                              
                    accept_char(campos(focus-4), input_char)
                EndIf   
            ElseIf focus = 5 Or focus = 6 Then
                If filter_alphabetic(input_char) <> 0 Then    
                    accept_char(campos(focus-4), input_char)
                EndIf   
            EndIf
        EndIf
        Flip                                                                                         
    Wend 
    If check_list = 0 Then
        sections_track = 12
        track_id = 0 
        the_track = @track0(0)
    ElseIf check_list = 1 Then
        sections_track = 24
        track_id = 1  
        the_track = @track1(0)
    ElseIf check_list = 2 Then
        sections_track = 18
        track_id = 2   
        the_track = @track2(0)    
    ElseIf check_list = 3 Then
        sections_track = 23
        track_id = 3   
        the_track = @track3(0)    
    EndIf
    len_track = (sections_track+1)*100 
    player1.player_name = Str(*campos(1)->str_text)
    player2.player_name = Str(*campos(2)->str_text)
    For i=0 To 2 Step 1
        Deallocate(campos(i))
    Next i 
    Screenset 1,0
    Color Rgb(255,255,255), Rgb(0,0,0)
    Return rval
End Function 
Screenres 320, 200, 24, 2, GFX_FULLSCREEN
Screenset 0, 1
setmouse 0, 0, 0
ground_layer_a = creates_a_layer("pitstop_tex1.bmp")
ground_layer_d = creates_a_layer("pitstop_tex0.bmp")
ground_layer_b_1 = imagecreate(SCREEN_WIDTH, SCREEN_HEIGHT)
ground_layer_c_1 = imagecreate(SCREEN_WIDTH, SCREEN_HEIGHT) 
ground_layer_b_2 = imagecreate(SCREEN_WIDTH, SCREEN_HEIGHT)
ground_layer_c_2 = imagecreate(SCREEN_WIDTH, SCREEN_HEIGHT)
ground_layer_e = creates_fog_layer(100, 200, 255)
pit = bmp_load("pitstop_pit.bmp", 37, 59)
While(1)
    laps_to_go=0
    If enter_game_settings = 0 Then
        Exit While
    EndIf
    If players = 1 Then
        ground_layer_f = creates_back_layer(SCREEN_HEIGHT/2)
        ground_layer_g_1 = imagecreate(SCREEN_WIDTH+50, SCREEN_HEIGHT/2) 
        ground_layer_e = creates_fog_layer(100, 200, 255)
        window_player_1 = imagecreate(SCREEN_WIDTH, SCREEN_HEIGHT)
        ground_matrix = pre_render_horizon_plane(SCREEN_HEIGHT/2, 1.5, window_player_1, ground_layer_c_1, 1) 
    ElseIf players = 2 Then
        ground_layer_f = creates_back_layer(SCREEN_HEIGHT/4)
        ground_layer_g_1 = imagecreate(SCREEN_WIDTH+50, SCREEN_HEIGHT/4)
        ground_layer_g_2 = imagecreate(SCREEN_WIDTH+50, SCREEN_HEIGHT/4) 
        ground_layer_e = creates_fog_layer(50, 100, 255)
        window_player_1 = imagecreate(SCREEN_WIDTH, SCREEN_HEIGHT/2)
        window_player_2 = imagecreate(SCREEN_WIDTH, SCREEN_HEIGHT/2)
        ground_matrix = pre_render_horizon_plane(SCREEN_HEIGHT/4, 1.5, window_player_1, ground_layer_c_1, 1)
    EndIf
    init_player(@player1, -50, 1, 50, -50, -50, @player2)
    init_player(@player2, 50, 2, -50, 50, -50, @player1)
    Randomize
    current_timer = Timer 
    While Multikey(SC_ESCAPE) = 0 
        If inkey = "p" Or inkey = "P" Then
            Dim As Single pause_time = Timer
            While Multikey(SC_P) : Wend
            While inkey <> "" : Wend
            While inkey = "" : Wend 
            current_timer+=timer-pause_time
        EndIf
        If players=1 Then
            render_player(@player1, 0, window_player_1)
            iteract_player(@player1, 1)
            iteract_player(@player2, 0)
        ElseIf players=2 Then
            render_player(@player1, 1, window_player_1)
            render_player(@player2, 1, window_player_2)
            iteract_player(@player1, 1)
            iteract_player(@player2, 1)
        EndIf  
        Flip
        Do
        Loop Until Timer-timer_control >= .04 
        timer_control = Timer 
        iter+=1                 
    Wend 
    If players = 1 Then
        imagedestroy(ground_layer_f)
        imagedestroy(ground_layer_g_1) 
        imagedestroy(ground_layer_e)
        imagedestroy(window_player_1)
        Deallocate(ground_matrix) 
    ElseIf players = 2 Then
        imagedestroy(ground_layer_f)
        imagedestroy(ground_layer_g_1)
        imagedestroy(ground_layer_g_2) 
        imagedestroy(ground_layer_e)
        imagedestroy(window_player_1)
        imagedestroy(window_player_2)
        Deallocate(ground_matrix)
    EndIf
Wend
imagedestroy(ground_layer_a)
imagedestroy(ground_layer_b_1)
imagedestroy(ground_layer_b_2)
imagedestroy(ground_layer_c_1)
imagedestroy(ground_layer_c_2)
imagedestroy(ground_layer_d)
imagedestroy(pit)  
End